{*******************************************************}
{                                                       }
{       Turbo Pascal Version 6.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1990 Borland International        }
{       and Petr Mikulik 1991                           }
{                                                       }
{ Oproti standardni App pridano:
  * globalni promenna SaveUserScreenEnable: boolean;
    je-li nastavena na zacatku aplikacniho programu, pak
    se pred spustenim aplikace uschova vstupni obrazovka
    i poloha kurzoru a po ukonceni aplikace se obnovi.
    Implicitne je false.
  * procedure TVpress: ceka na stisk nejake klavesy. Pokud
    behem doby dane globalni konstantou SwitchOffMin nedojde
    ke stisku zadne klavesy, vyhasne obrazovka a objevi se
    zadost o vypnuti pocitace. Z nekonecneho cyklu je vsak
    mozne se dostat krom resetu take klavesou HOME (pro znale).
  * procedure SaveUserScreen;
  * procedure RestoreUserScreen;
  * procedure PutKb ( W: Word );  pro vlozeni klavesy
  * procedure Putcm ( W: Word );  ci commandu do Handlu
{*******************************************************}

UNIT App1;

{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses Objects, Drivers, Memory, HistList, Views, Menus, crt, dos;

{ $DEFINE Czech}

const

{ TApplication palette entries }

  apColor      = 0;
  apBlackWhite = 1;
  apMonochrome = 2;

{ TApplication palettes }

  CColor =
        #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$21#$00#$70#$7F#$7A#$13#$13#$70#$7F#$00 +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$00#$00;

  CBlackWhite =
        #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$7F#$7F#$70#$07#$70#$07#$00 +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$00#$00;

  CMonochrome =
        #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$00#$00;


{ TBackground palette }

  CBackground = #1;

{ additional variables }

  SaveUserScreenEnable: boolean = false;

type

{ TBackground object }

  PBackground = ^TBackground;
  TBackground = object(TView)
    Pattern: char;
    constructor Init(var Bounds: TRect; APattern: char);
    constructor Load(var S: TStream);
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
    procedure Store(var S: TStream);
  end;

{ PUserScreenBackground object }

  PUserScreenView = ^TUserScreenView;
  TUserScreenView = object ( TView )
                    { ooo constructor Init; }
                    procedure Draw; virtual;
                    end;

{ PTextBackground object }

  PTextBackground = ^TTextBackground;
  TTextBackground = object(TView)
    Color: Word;
    SS: PString;
    constructor Init ( ASS: string; AColor: Word );
    procedure Draw; virtual;
    end;

{ TDeskTop object }

  PDeskTop = ^TDeskTop;
  TDeskTop = object(TGroup)
    Background: PBackground;
    constructor Init(var Bounds: TRect);
    procedure Cascade(var R: TRect);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitBackground; virtual;
    procedure Tile(var R: TRect);
    procedure TileError; virtual;
  end;

{ TProgram object }

  { Palette layout }
  {     1 = TBackground }
  {  2- 7 = TMenuView and TStatusLine }
  {  8-15 = TWindow(Blue) }
  { 16-23 = TWindow(Cyan) }
  { 24-31 = TWindow(Gray) }
  { 32-63 = TDialog }

  PProgram = ^TProgram;
  TProgram = object(TGroup)
    UsrCursX,UsrCursY: byte;
    UsrScrBufSize: Word;
    UsrScrBuf: Pointer;
    constructor Init;
    destructor Done; virtual;
    procedure GetEvent(var Event: TEvent); virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Idle; virtual;
    procedure TVPress;
    procedure InitDeskTop; virtual;
    procedure SaveUserScreen; virtual;
    procedure RestoreUserScreen; virtual;
    procedure InitMenuBar; virtual;
    procedure InitScreen; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
    procedure PutEvent(var Event: TEvent); virtual;
    procedure PutKb ( W: Word );
    procedure Putcm ( W: Word );
    procedure Run; virtual;
    procedure SetScreenMode(Mode: Word);
    function ValidView(P: PView): PView;
  end;

{ TApplication object }

  PApplication = ^TApplication;
  TApplication = object(TProgram)
    constructor Init;
    destructor Done; virtual;
  end;

{ App registration procedure }

procedure RegisterApp;

const

{ Public variables }

  Application: PProgram = nil;
  DeskTop: PDeskTop = nil;
  StatusLine: PStatusLine = nil;
  MenuBar: PMenuView = nil;
  AppPalette: integer = apColor;

{ Stream registration records }

  RBackground: TStreamRec = (
    ObjType: 30;
    VmtLink: Ofs(TypeOf(TBackground)^);
    Load: @TBackground.Load;
    Store: @TBackground.Store);

  RDeskTop: TStreamRec = (
    ObjType: 31;
    VmtLink: Ofs(TypeOf(TDeskTop)^);
    Load: @TDeskTop.Load;
    Store: @TDeskTop.Store);


const SwitchOffMin: longint = 3;
  { cekaci doba pro proceduru TVpress v minutach }


IMPLEMENTATION

const

{ Private variables }

  Pending: TEvent = (What: evNothing);

{ TBackground }

constructor TBackground.Init(var Bounds: TRect; APattern: char);
begin
  TView.Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  Pattern := APattern;
end;

constructor TBackground.Load(var S: TStream);
begin
  TView.Load(S);
  S.read(Pattern, SizeOf(Pattern));
end;

procedure TBackground.Draw;
var
  B: TDrawBuffer;
begin
  MoveChar(B, Pattern, GetColor($01), Size.X);
  WriteLine(0, 0, Size.X, Size.Y, B);
end;

function TBackground.GetPalette: PPalette;
const
  P: string[length(CBackground)] = CBackground;
begin
  GetPalette := @P;
end;

procedure TBackground.Store(var S: TStream);
begin
  TView.Store(S);
  S.write(Pattern, SizeOf(Pattern));
end;

{ TTextBackground }

constructor TTextBackground.Init(ASS: string; AColor: Word);
var R: TRect;
begin
DeskTop^.GetExtent(R);
TView.Init(R);
Color:=AColor; SS:=NewStr(ASS)
end;

procedure TTextBackground.Draw;
var K,L: integer; B: TDrawBuffer; Rad,PomRad: string;
    SB: ^Word; Konec: Pointer;
begin
(* k:=1;
 * longint(Konec):=longint(ScreenBuffer)+2*ScreenWidth*(ScreenHeight-1);
 * longint(SB):=longint(ScreenBuffer)+2*ScreenWidth; k:=1;
 * repeat sb^:=color+ord(e[k]); inc(k); if k>length(e) then k:=1;
 * inc(longint(sb),2) until sb=konec; *)
  if SS=nil then PomRad:='' else PomRad:=SS^;
Rad:='';
if SS=nil then L:=0
   else begin for K:=0 to (255 div length(SS^)) do Rad:=Rad+SS^;
        L:=length(SS^) end;
for K:=0 to Size.Y do
  begin
  PomRad:=Copy(Rad,K mod L,Size.X);
  MoveStr(B,PomRad,Color);
  WriteLine(0,K,Size.X,1,B) end;
end;

{ TUserScreenView }

{ ooo vyrazeno
constructor TUserScreenView.Init;
type AAA= array[0..$f000] of char; var I: integer;
var RR: TRect;
begin
{ if DeskTop<>nil then
   begin application^.GetExtent(R) end
   else R.assign(0,0,ScreenWidth,ScreenHeight);
TView.Init(R);
end;
 ooo }

procedure TUserScreenView.Draw;
var B: TDrawBuffer; P1,P2: TPoint; I: integer;
type W=array[0..10000] of Word;
begin
P1.X:=0;
if 2*ScreenHeight*ScreenWidth=Application^.UsrScrBufSize
   then for I:=0 to Size.Y do
            begin
            P1.X:=0; P1.Y:=I;
            MakeGlobal(P1,P2);
            {  Move( pointer( longint(longint(Usrscrbuf^)+2*P2.y*ScreenWidth) )^,B,2*size.x);  }
            { poj:=pointer( longint(application^.Usrscrbuf^)+2*P2.y*ScreenWidth ); }
            { WriteLine(0, i, Size.X, 1, Poj^); }
            WriteLine(0, I, Size.X, 1, W(Application^.UsrScrBuf^)[P2.Y*ScreenWidth+P2.X*2]);
            end
   else begin
        MoveChar(B, #176, GetColor($01), Size.X);
        WriteLine(0, 0, Size.X, Size.Y, B);
        end;
end;


{ TDeskTop object }

constructor TDeskTop.Init(var Bounds: TRect);
begin
  TGroup.Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  InitBackground;
  if Background <> nil then Insert(Background);
end;

function Tileable(P: PView): boolean;
begin
  Tileable := (P^.Options and ofTileable <> 0) and
    (P^.State and sfVisible <> 0);
end;

procedure TDeskTop.Cascade(var R: TRect);
var
  CascadeNum: integer;
  LastView: PView;
  Min, Max: TPoint;

 
procedure DoCount(P: PView); far;
begin
  if Tileable(P) then
  begin
    inc(CascadeNum);
    LastView := P;
  end;
end;

procedure DoCascade(P: PView); far;
var
  NR: TRect;
begin
  if Tileable(P) and (CascadeNum >= 0) then
  begin
    NR.Copy(R);
    inc(NR.A.X, CascadeNum); inc(NR.A.Y, CascadeNum);
    P^.Locate(NR);
    dec(CascadeNum);
  end;
end;

begin
  CascadeNum := 0;
  ForEach(@DoCount);
  if CascadeNum > 0 then
  begin
    LastView^.SizeLimits(Min, Max);
    if (Min.X > R.B.X - R.A.X - CascadeNum) or
       (Min.Y > R.B.Y - R.A.Y - CascadeNum) then TileError
    else
    begin
      dec(CascadeNum);
      Lock;
      ForEach(@DoCascade);
      Unlock;
    end;
  end;
end;

procedure TDeskTop.HandleEvent(var Event: TEvent);
begin
  TGroup.HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmNext: SelectNext(false);
      cmPrev: if Background <> nil then
                 Current^.PutInFrontOf(Background);
    else
      exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TDeskTop.InitBackground;
var
  R: TRect;
begin
  GetExtent(R);
  new(Background, Init(R, #176))
end;

function ISqr(X: integer): integer; assembler;
asm
	MOV	CX,X
        MOV	BX,0
@@1:    inc     BX
	MOV	AX,BX
	IMUL	AX
        CMP	AX,CX
        JLE	@@1
	MOV	AX,BX
        dec     AX
end;

procedure MostEqualDivisors(N: integer; var X, Y: integer);
var
  I: integer;
begin
  I := ISqr(N);
  if ((N mod I) <> 0) then
    if (N mod (I+1)) = 0 then inc(I);
  if I < (N div I) then I := N div I;
  X := N div I;
  Y := I;
end;

procedure TDeskTop.Tile(var R: TRect);
var
  NumCols, NumRows, NumTileable, LeftOver, TileNum: integer;

procedure DoCountTileable(P: PView); far;
begin
  if Tileable(P) then inc(NumTileable);
end;

function DividerLoc(lo, Hi, Num, pos: integer): integer;
begin
  DividerLoc := LongDiv(LongMul(Hi - lo, pos), Num) + lo;
end;

procedure CalcTileRect(pos: integer; var NR: TRect);
var
  X,Y,D: integer;
begin
  D := (NumCols - LeftOver) * NumRows;
  if pos < D then
  begin
    X := pos div NumRows;
    Y := pos mod NumRows;
  end else
  begin
    X := (pos - D) div (NumRows + 1) + (NumCols - LeftOver);
    Y := (pos - D) mod (NumRows + 1);
  end;
  NR.A.X := DividerLoc(R.A.X, R.B.X, NumCols, X);
  NR.B.X := DividerLoc(R.A.X, R.B.X, NumCols, X+1);
  if pos >= D then
  begin
    NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows+1, Y);
    NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows+1, Y+1);
  end else
  begin
    NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y);
    NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y+1);
  end;
end;

procedure DoTile(P: PView); far;
var
  R: TRect;
begin
  if Tileable(P) then
  begin
    CalcTileRect(TileNum, R);
    P^.Locate(R);
    dec(TileNum);
  end;
end;

begin
  NumTileable := 0;
  ForEach(@DoCountTileable);
  if NumTileable > 0 then
  begin
    MostEqualDivisors(NumTileable, NumCols, NumRows);
    if ((R.B.X - R.A.X) div NumCols = 0) or
       ((R.B.Y - R.A.Y) div NumRows = 0) then TileError
    else
    begin
      LeftOver := NumTileable mod NumCols;
      TileNum := NumTileable-1;
      Lock;
      ForEach(@DoTile);
      Unlock;
    end;
  end;
end;

procedure TDeskTop.TileError;
begin
end;

{ TProgram }

constructor TProgram.Init;
var
  R: TRect;
begin
  Application := @Self;
  InitScreen;
  R.assign(0, 0, ScreenWidth, ScreenHeight);
  TGroup.Init(R);
  State := sfVisible + sfSelected + sfFocused + sfModal + sfExposed;
  Options := 0;
  Buffer := ScreenBuffer;
  if SaveUserScreenEnable then SaveUserScreen;
  InitStatusLine;
  InitMenuBar;
  InitDeskTop; { -pm- pred tim bylo InitDeskTop prvni }
  if StatusLine <> nil then Insert(StatusLine);
  if MenuBar <> nil then Insert(MenuBar);
  if DeskTop <> nil then Insert(DeskTop); { -pm- pred tim bylo InitDeskTop prvni }
end;

destructor TProgram.Done;
begin
  if DeskTop <> nil then dispose(DeskTop, Done);
  if MenuBar <> nil then dispose(MenuBar, Done);
  if StatusLine <> nil then dispose(StatusLine, Done);
  Application := nil;
end;

procedure TProgram.GetEvent(var Event: TEvent);
var
  R: TRect;

function ContainsMouse(P: PView): boolean; far;
begin
  ContainsMouse := (P^.State and sfVisible <> 0) and
    P^.MouseInView(Event.Where);
end;

begin
  if Pending.What <> evNothing then
  begin
    Event := Pending;
    Pending.What := evNothing;
  end else
  begin
    GetMouseEvent(Event);
    if Event.What = evNothing then
    begin
      GetKeyEvent(Event);
      if Event.What = evNothing then Idle;
    end;
  end;
  if StatusLine <> nil then
    if (Event.What and evKeyDown <> 0) or
      (Event.What and evMouseDown <> 0) and
      (FirstThat(@ContainsMouse) = PView(StatusLine)) then
      StatusLine^.HandleEvent(Event);
end;

function TProgram.GetPalette: PPalette;
const
  P: array[apColor..apMonochrome] of string[length(CColor)] =
    (CColor, CBlackWhite, CMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

procedure TProgram.HandleEvent(var Event: TEvent);
var
  I: Word;
  C: char;
begin
  if Event.What = evKeyDown then
  begin
    C := GetAltChar(Event.KeyCode);
    if (C >= '1') and (C <= '9') then
      if Message(DeskTop, evBroadcast, cmSelectWindowNum,
        Pointer(byte(C) - $30)) <> nil then ClearEvent(Event);
  end;
  TGroup.HandleEvent(Event);
  if Event.What = evCommand then
    if Event.Command = cmQuit then
    begin
      EndModal(cmQuit);
      ClearEvent(Event);
    end;
end;

procedure TProgram.Idle;
begin
  if StatusLine <> nil then StatusLine^.UpDate;
  if CommandSetChanged then
  begin
    Message(@Self, evBroadcast, cmCommandSetChanged, nil);
    CommandSetChanged := false;
  end;
end;

procedure TProgram.TVPress;
{ po dobe SwitchOffMin zatmi pocitac }
var E: TEvent; H,M,V,S,H2,M2,V2,S2,Citac: word; L: longint;
begin
delay(222);
GetTime(H,M,V,S);
repeat
GetTime(H2,M2,V2,S2);
L:=((H2-H)*60 +M2-M )*60 +V2-V;
GetKeyEvent(E); if E.What=0 then GetMouseEvent(E);
if E.What<>0 then exit;
until L>SwitchOffMin*60;
Window(1,1,80,28); TextBackground(black);
ClrScr; Citac:=0;
{$IFDEF Czech}
writeln('Vypocet ukoncen, vypnete prosim pocitac. Dekuji.');
{$ELSE}
writeln('The computation was finished. Switch the computer off, please.');
{$ENDIF}
Randomize;
repeat { nekonecny cykl do stisku klavesy HOME nebo vypnuti PC }
GetKeyEvent(E);
delay(100); inc(Citac);
Window(1,1,80,25);
if Citac mod 33=0 then
  begin ClrScr; GotoXY(Random(80),Random(24));
  {$IFDEF Czech}
  writeln('Vypocet ukoncen, vypnete prosim pocitac. Dekuji.');
  {$ELSE}
  writeln('The computation has finished. Switch the computer off, please.');
  {$ENDIF}
  end;
until (E.What=evKeyDown) and (E.KeyCode=kbHome);
Application^.Redraw
end;

procedure TProgram.InitDeskTop;
var
  R: TRect;
begin
  GetExtent(R);
  if MenuBar<>nil then inc(R.A.Y);    {-pm-}
  if StatusLine<>nil then dec(R.B.Y); {-}
  new(DeskTop, Init(R));
end;

procedure TProgram.SaveUserScreen;
begin
UsrScrBufSize:=2*ScreenHeight*ScreenWidth;
GetMem(UsrScrBuf,UsrScrBufSize);
if UsrScrBuf<>nil then
   begin
   Move(ScreenBuffer^,UsrScrBuf^,UsrScrBufSize);
   UsrCursX:=WhereX; UsrCursY:=WhereY
   end
end;

procedure TProgram.RestoreUserScreen;
begin
if UsrScrBuf<>nil then
   begin Move(UsrScrBuf^,ScreenBuffer^,UsrScrBufSize);
   FreeMem(UsrScrBuf,UsrScrBufSize);
   gotoXY(UsrCursX,UsrCursY)
   end
end;

procedure TProgram.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := new(PMenuBar, Init(R, nil));
end;

procedure TProgram.InitScreen;
begin
  if lo(ScreenMode) <> smMono then
  begin
    if ScreenMode and smFont8x8 <> 0 then
      ShadowSize.X := 1 else
      ShadowSize.X := 2;
    ShadowSize.Y := 1;
    ShowMarkers := false;
    if lo(ScreenMode) = smBW80 then
      AppPalette := apBlackWhite else
      AppPalette := apColor;
  end else
  begin
    ShadowSize.X := 0;
    ShadowSize.Y := 0;
    ShowMarkers := true;
    AppPalette := apMonochrome;
  end;
end;

procedure TProgram.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  new(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~Alt-X~ Konec', kbAltX, cmQuit,
      NewStatusKey('', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF5, cmZoom,
      NewStatusKey('', kbCtrlF5, cmResize,
      NewStatusKey('', kbF6, cmNext, nil)))))), nil)));
end;

procedure TProgram.OutOfMemory;
begin
end;

procedure TProgram.PutEvent(var Event: TEvent);
begin
  Pending := Event;
end;

procedure TProgram.Run;
begin
  Execute;
end;

procedure TProgram.PutKb ( W: Word );
var E: TEvent;
begin E.What:=evKeyDown; E.KeyCode:=W;
PutEvent(E) end;

procedure TProgram.Putcm ( W: Word );
var E: TEvent;
begin E.What:=evCommand; E.Command:=W;
PutEvent(E) end;

procedure TProgram.SetScreenMode(Mode: Word);
var
  R: TRect;
begin
  HideMouse;
  SetVideoMode(Mode);
  DoneMemory;
  InitScreen;
  Buffer := ScreenBuffer;
  R.assign(0, 0, ScreenWidth, ScreenHeight);
  ChangeBounds(R);
  ShowMouse;
end;

function TProgram.ValidView(P: PView): PView;
begin
  ValidView := nil;
  if P <> nil then
  begin
    if LowMemory then
    begin
      dispose(P, Done);
      OutOfMemory;
      exit;
    end;
    if not P^.Valid(cmValid) then
    begin
      dispose(P, Done);
      exit;
    end;
    ValidView := P;
  end;
end;

{ TApplication }

constructor TApplication.Init;
begin
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  InitHistory;
  TProgram.Init;
end;

destructor TApplication.Done;
begin
  TProgram.Done;
  DoneHistory;
  DoneSysError;
  DoneEvents;
  DoneVideo;
  RestoreUserScreen;
  DoneMemory;
end;

{ App registration procedure }

procedure RegisterApp;
begin
  RegisterType(RBackground);
  RegisterType(RDeskTop);
end;

end.


