UNIT Fibonacci;
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

const MaxFibCisel = 100;
      MaxTauKrat  = 100;
      GoldenMean   = 0.618033988749895;

var FibCislo: array [ 0..MaxFibCisel ] of longint;
    TauKrat: array [ 0..MaxTauKrat ] of real;

procedure GenerujFibCisla ( F1, F2: longint );

procedure AplusBtau ( X: real; var A, B: integer; var Nej: real );
{ Nej = A + B*GoldenMean, kde Nej je nejblizsi takove cislo k X }

procedure GenerujTauKrat;


IMPLEMENTATION

procedure GenerujFibCisla ( F1, F2: longint );
var I: integer;
begin
FibCislo[0]:=F2-F1;
FibCislo[1]:=F1;
FibCislo[2]:=F2;
for I:=3 to MaxFibCisel do
    FibCislo[I]:=FibCislo[I-1]+FibCislo[I-2];
end;

procedure AplusBtau ( X: real; var A, B: integer; var Nej: real );
{ Nej = A + B*GoldenMean, kde Nej je nejblizsi takove cislo k X }
var Pom,Z,Eps: real; K: integer;
begin
Eps:=1e38;
Z:=Frac(X);
for K:=0 to MaxTauKrat do
  begin
  Pom:=Frac(abs( Z-TauKrat[K]) );
  if Pom < Eps
    then begin Eps:=Pom; B:=K end
    else begin
      Pom:=Frac(abs( Z+Frac(TauKrat[K])) );
      if Pom < Eps
        then begin Eps:=Pom; B:=-K end;
      end;
  end;
if B>0
  then begin A:=round( X-TauKrat[B] );  Nej:=A+TauKrat[B]  end
  else begin A:=round( X+TauKrat[-B] ); Nej:=A-TauKrat[-B] end;
end;

procedure GenerujTauKrat;
var I: integer;
begin
for I:=0 to MaxTauKrat do
  TauKrat[I]:=I*GoldenMean;
end;


begin
GenerujFibCisla(0,1);
GenerujTauKrat;
end. { Fibonacci }
