UNIT Graf094;
{$F+,O+,S-,X+,D-,L-,R-}

  (**********************************************************************+
  |  Rozsireni standardni unit Graph                                     |
  |  Turbo Pascal ver. 5.0-                                              |
  |  Jan Cely, katedra teoreticke fyziky, PF MU , Brno                   |
  |  verse 0.94 / 07-I-91                                                |
  +**********************************************************************)

INTERFACE

USES crt, Graph, DefFloat;

const DoDetectMode: boolean = true;  {true pro Borlandi .bgi, false pro jine}
const TheGrDriver: longint = 0;  { kod egavga.bgi }
const TheGrMode: longint = 3;    { 640x480 }

{ kvuli pouziti v Turbo Vision musi byt longint ! }
{ jine .bgi: napr. svga16.bgi}

CONST
  VerGraf = 0.94;

  _MaxViewPorts = 10;          (* Maximalne mozny pocet graf. oken     *)
  _ScreenBkcol  = Black;       (* Zakladni barva pozadi cele obrazovky *)

  _DispVP    = TRUE;           (* Konstanty pro volani SelectViewPort  *)
  _NotDispVP = FALSE;
  _Ltfactor  = 1.8;            (* LongTick=_Ltfactor*ShortTick *)

TYPE
  _GrLabel     = String[60];
  _AxesType    = (NoAxes,LinAxes,LogAxes);
                       (* Osa : ne, linearni, logaritmicka *)
  _GridType    = (NoGrid,RoughGrid,FineGrid);
                       (* Sit : ne, v posanych delicich bodech, *)
                       (*       ve vsech delicich bode dane osy *)
  _LabPosition = (LabLeftH,LabRightH,LabBellowH,LabAboveH,
                  LabLeftV,LabRightV,LabBellowV,LabAboveV);
                        (* Poloha popisu, H-horizontalne,V-vertikalne *)
  _GrViewPortInfo = RECORD
                      VPdefined :BOOLEAN;        (*TRUE pro definovane*)
                      VP        :ViewPortType;
                      VPframecol,                     (* barva ramecku*)
                      VPcol     :INTEGER;             (* barva pozadi *)
                      VPux1,VPux2,VPuy1,VPuy2        :FLOAT;
                                         (* Uzivatelske jednotky okna *)
                      VPDxPix,VPDyPix,VPPixDx,VPPixDy :FLOAT;
                                        (* uziv.j./pixel,pixel/uziv.j.*)
                      VPmaxX,VPmaxY : INTEGER;
                    END;

VAR
(*-------------- Globalni promenne - programove NEMENIT ! ----------------*)
  _VPinfo : ARRAY [0.._MaxViewPorts] OF _GrViewPortInfo;
(*----------------- Hodnoty pro aktualni ViewPort :  ---------------------*)
  VP_x1,VP_x2,VP_y1,VP_y2,              (* Abs.poloha okna grafu *)
  VP_maxX,VP_maxY          :INTEGER;    (* Xmax,Ymax pro okno *)
  VP_ux1,VP_ux2,VP_uy1,VP_uy2,          (* Uzivatelske jednotky okna *)
  VP_DxPix,VP_DyPix,
  VP_PixDx,VP_PixDy        :FLOAT;      (* uziv.j./pixel,pixel/uziv.j.*)
  VP_col,VP_Framecol       :INTEGER;    (* Barva pozadi ViewPortu *)
  VP_clip                  :BOOLEAN;
  VP_used                  :INTEGER;    (* Cislo nastaveneho ViewPortu *)
(*------------------------------------------------------------------------*)

FUNCTION EnterGraphic: boolean;
  {+++++ vyhod true if doslo k chybe a potvrzeni o pokracovani }
  (*---------------------------------------------------------------------+
  |  Nastavi graficky mod s GrDriverem:=Detect                           |
  +---------------------------------------------------------------------*)

PROCEDURE LeaveGraphic;
  (*---------------------------------------------------------------------+
  |  Provede ClearDevice + CloseGraph                                    |
  +---------------------------------------------------------------------*)

FUNCTION NtDx(x:FLOAT): integer;
FUNCTION NtDy(y:FLOAT): integer;
  (*---------------------------------------------------------------------+
  |  Prevod normalnich souradnic na souradnice displeje ve smeru x a y   |
  |  Normalni souradnice pro celou obrazovku:                            |
  |             (0,0)--------------------------+                         |
  |               |                            |                         |
  |               +------------------------(1.0,1.0)                     |
  +---------------------------------------------------------------------*)

FUNCTION UtDx(x: FLOAT):integer;
FUNCTION UtDy(y: FLOAT):integer;
  (*---------------------------------------------------------------------+
  |  Prevod uzivatelskych jednotek na jednotky obrazovky v aktualnim     |
  |  ViewPortu.                                                          |
  +---------------------------------------------------------------------*)

PROCEDURE DefineViewPort (VPnb :INTEGER;
                          NGx1,NGy1,NGx2,NGy2 :FLOAT;
                          UGx1,UGy1,UGx2,UGy2 :FLOAT;
                          Framecolor,VPcolor :INTEGER);
  (*---------------------------------------------------------------------+
  |  Definuje parametry pro ViewPort cislo VPnb;                         |
  |  NGx1,..,NGy2 poloha okna na obrazovce v normalnich souradnicich,    |
  |  UGx1,..,UGy2 odpovidajici uzivatelske jednotky,                     |
  |  framecolor = barva ramecku VNE okna (pro <0 se nekresli)            |
  |  vpcolor    = barva pozadi                                           |
  |  clipping se nastavi na ClipOff                                      |
  +---------------------------------------------------------------------*)

PROCEDURE RedefineUserUnits (VPnb:INTEGER; UGx1,UGy1,UGx2,UGy2:FLOAT);
  (*---------------------------------------------------------------------+
  |  Zmeni uzivatelske jednotky nastavene v DefineViewPort;              |
  |  je-li ViewPort cislo VPnb prave aktualni (viz SelectViewPort)       |
  |  budou po volani teto procedury platit nove jednotky                 |
  +---------------------------------------------------------------------*)

PROCEDURE VPclip(clip:BOOLEAN);
  (*---------------------------------------------------------------------+
  |  Nastavi clipping aktualniho ViewPortu                               |
  +---------------------------------------------------------------------*)

PROCEDURE DisplayViewPort(VPnb :INTEGER);
  (*---------------------------------------------------------------------+
  |  Zobrazi ViewPort cislo VPnb, ale NENASTAVI do neho vystup           |
  |  (provadi obdobu ClearViewPort,tj pozadi+ ev.ramecek)                |
  +---------------------------------------------------------------------*)

PROCEDURE SelectViewPort(VPnb :INTEGER; DispVP,ClipVP :BOOLEAN);
  (*---------------------------------------------------------------------+
  |  Nastavi vystup na ViewPort cislo VPnb;                              |
  |  pro DisplayVP=TRUE provede i zobrazeni plochy Viewportu+ramecku     |
  |  a nastavi clipping podle ClipVP                                     |
  +---------------------------------------------------------------------*)

FUNCTION IntStr(i:INTEGER):String;
  (*---------------------------------------------------------------------+
  |  Prevede cele cislo na string s odstranenymi mezerami pred cislem    |
  +---------------------------------------------------------------------*)

FUNCTION FloatStr(r :FLOAT; cifer:INTEGER):String;
 (*----------------------------------------------------------------------+
 |  Prevedeni realneho cisla na string s odstranenymi mezerami pred      |
 |  cislem a odstranenymi nevyznamnymi nulami.                           |
 |  Parametr cifer udava pozadovany maximalni pozadovany pocet platnych  |
 |  cifer. Pro Abs(r)>=1e-4 a Abs(r)<=1e-4 vystup v exponencialnim tvaru |
 +----------------------------------------------------------------------*)

PROCEDURE UMoveTo(x,y: FLOAT);
PROCEDURE ULineTo(x,y: FLOAT);
PROCEDURE ULine(x1,y1,x2,y2 :FLOAT);
  (*---------------------------------------------------------------------+
  |  Procedury MoveTo, LineTo, Line z unit Graph ale s parametry         |
  |  v uzivatelskych jednotkach                                          |
  +---------------------------------------------------------------------*)

PROCEDURE PlotAxis (Xax :_AxesType;
                   OdX,DoX,DelOdX,DelDoX,KrokDelX,KrokPopX :FLOAT;
                   XnumPos: _LabPosition; XtickOut,XtickIn :INTEGER;
                   GridX  : _GridType;
                   XLab :_GrLabel; PosLabX :_LabPosition;
                   XsourY,YsourX :FLOAT;
                   Yax :_AxesType;
                   OdY,DoY,DelOdY,DelDoY,KrokDelY,KrokPopY :FLOAT;
                   YnumPos: _LabPosition; YtickOut,YtickIn :INTEGER;
                   GridY  : _GridType;
                   YLab :_GrLabel; PosLabY : _LabPosition;
                   AxCol,AxFont,FontSize :INTEGER;
                   GridCol,GridLineType:INTEGER);
  (*---------------------------------------------------------------------+
  |                      Kresba os X, Y                                  |
  |  Xax = NoAxes|LinAxes|LogAxes (nekresli se|linearni|logaritmicka)    |
  |  Deleni se provede od nejblizsiho vetsiho cisla k DelOdX , ktere je  |
  |  delitelne KrokDelX a provadi se az do DelDoX;                       |
  |  KrokPopX = krok popisu = celociselny nasobek KrokDelX ;             |
  |  Pro Xax=LogAxes : KrokDelX>0 = popisuji se body 2e..,               |
  |                    KrokPopX>0 = popisuji se body 5e.. ;              |
  |  Popis se provadi procedurou FLOATStr v delicich bodech delitelnych  |
  |  parametrem KrokPopX;                                                |
  |  XnumPos - poloha popisu = LabBellowH|LabAboveH (ostatni se nahradi  |
  |            LabBellowH)                                               |
  |  XtickOut,XtickIn - delka delicich carek vne a uvnitr grafu v bodech |
  |            obrazovky(pixel);                                         |
  |  GridX = NoGrid | RoughGrid | FineGrid ;kresba car site kolmo k X ;  |
  |          NoGrid: nekresli se, RoughGrid: v popsanych del.bodech(pro  |
  |          LogAxes v 1,2,5), FineGrid: ve vsech delicich bodech        |
  |          Pro Yax=NoAxes cary pres celou Y-sirku ViewPortu            |
  |  Xlab popis osy v poloze PosLabX = LabAboveH|LabBellowH              |
  |            (ostatni polozky typu _LabPosition se nahradi LabAboveH)  |
  |                                                                      |
  |  XsourY,YsourX : x-ova souradnice osy Y a y-ova souradnice osy X     |
  |                                                                      |
  |  Yax viz Xax                                                         |
  |  Vyznam parametru obdobny jako u osy X, s tim, ze:                   |
  |  YnumPos - poloha popisu = LabLeftH|LabRightH (ostatni se nahradi    |
  |            LabLeftH)                                                 |
  |  Ylab muze byt v poloze: LabLeftH|LabRightH|LabLeftV|LabLeftV        |
  |            (ostatni se nahradi LabLeftH)                             |
  |  AxCol   = barva pro kresbu os                                       |
  |  AxFont  = font pro popis   | FontSize= velikost popisu (normalni je:|
  |  (DefaultFont,SmallFont,..) |         = 1 pro Default, 4 pro Small  )|
  |  GridCol = barva car site,                                           |
  |  GridLineType = typ car site (SolidLn,DottedLine apod.)              |
  |----------------------------------------------------------------------|
  |  Pro OdX=DoX se nastavi OdX:=VP_ux1; DoX:=VP_ux2                     |
  |  Pro DelOdX=DelDoX se nastavi        DelOdX:=OdX;     DelDoX:=DoX ,  |
  |  Analogicky se postupuje u velicin pro osu Y                         |
  |  Pro Xax=LogAxes se musi nastavit v DefineViewPort Log10(UGx1),      |
  |  Log10(UGx2), ale v PlotAxis jsou vsechny x-ove souradnice puvodni,  |
  |  tj. nelogaritmovane. Pri vynaseni bodu do grafu je ovsem nutne      |
  |  vynaset Log10(x-ove souradnice).                                    |
  |  Analogicky pro Yax=LogAxes.                                         |
  +---------------------------------------------------------------------*)


FUNCTION Log10 (x:FLOAT) :FLOAT;
FUNCTION ALog10(x:FLOAT) :FLOAT;
  (*---------------------------------------------------------------------+
  |  Dekadicky logaritmus a antilogaritmus                               |
  +---------------------------------------------------------------------*)

PROCEDURE FillRectangle(ix1,iy1,ix2,iy2: INTEGER; FillPatt,Color: WORD);
  (*---------------------------------------------------------------------+
  |  Vzor FillPatt v barve Color do obdelniku (ix1,iy1),(ix2,iy2)        |
  |  Zachovava puvodni nastaveni(FillSettingsType)                       |
  +---------------------------------------------------------------------*)

PROCEDURE PltSymbol (number :INTEGER; x,y :FLOAT; size,color :INTEGER);
  (*---------------------------------------------------------------------+
  |  Symbol cislo "number" ve velikosti "size" a barve "color" do (x,y)  |
  |  number:                                                             |
  |  ------------------------------------------------------------------  |
  |  1 =  +                | 2 =  x            | 3 = kosoctverec         |
  |  4 =  plny kosoctverec | 5 = ctverec       | 6 = plny ctverec        |
  |  7 - 10 = trojcipa hvezda nahoru(7), vpravo(8), dolu(9), vlevo(10)   |
  |  ------------------------------------------------------------------  |
  |  size <=3 : symbol v matici 3x3 | size > 3 : symbol v matici 5x5     |
  +---------------------------------------------------------------------*)

PROCEDURE PltChar (ch:CHAR; x,y :FLOAT; font,size,color :WORD);
  (*---------------------------------------------------------------------+
  |  Centrovany znak "ch" z fontu "font" ve velikosti "size"             |
  |  a v barve "color" do bodu (x,y)                                     |
  |  (pro DefaultFont(=0) je normalni velikost "size"=1,                 |
  |   pro SmallFont(=2)  je to "size"=4 )                                |
  +---------------------------------------------------------------------*)

PROCEDURE PltText (otext:String; x,y :FLOAT;
                   font,size ,FgCol,BkCol: WORD);
  (*---------------------------------------------------------------------+
  |  Vystup textu "otext" od bodu (x,y).                                 |
  |  Barva textu FgCol na pozadi BkCol (prouzek rozsireny o 2pix)        |
  |  Pro FgCol = BkCol se neprovadi nastaveni barev.                     |
  +---------------------------------------------------------------------*)


PROCEDURE StoreViewPort(VPnb :INTEGER; Frame :BOOLEAN);
  (*---------------------------------------------------------------------+
  |  Ulozi ViewPort cislo VPnb i s rameckem (Frame=TRUE) nebo bez neho   |
  |  (Frame=FALSE); jestlize byl ViewPort definovan bez nakresleneho     |
  |  ramecku, je Frame=TRUE bez ucinku                                   |
  +---------------------------------------------------------------------*)

PROCEDURE RestoreViewPort(VPnb :INTEGER; x,y :INTEGER; BitOper : WORD);
  (*---------------------------------------------------------------------+
  |  Zobrazi ViewPort cislo VPnb s levym hornim rohem v bode (x,y)       |
  |  (souradnice cele obrazovky) s provedenim bitove operace BitOper:    |
  |  NormalPut     = 0;    ( MOV )   CopyPut       = 0;    ( MOV )       |
  |  XORPut        = 1;    ( XOR )   OrPut         = 2;    ( OR  )       |
  |  AndPut        = 3;    ( AND )   NotPut        = 4;    ( NOT )       |
  |  Jestlize ViewPort VPnb nebyl predtim ulozen procedurou              |
  |  StoreViewPort, je RestoreViewPort bez ucinku                        |
  +---------------------------------------------------------------------*)

PROCEDURE DeleteViewPort(VPnb :INTEGER);
  (*---------------------------------------------------------------------+
  |  Uvolni na heapu misto obsazene procedurou StoreViewPort(VPnb)       |
  +---------------------------------------------------------------------*)


(********************************************************)
(******************* pridal jsem si: ********************)
(********************************************************)
{+++++}

function NtUx ( X: float ): float;
function NtUy ( Y: float ): float;

function UtNx ( X: float ): float;
function UtNy ( Y: float ): float;

function DtUx ( X: integer ): float;
function DtUy ( Y: integer ): float;

function StDx ( X: float ): integer;
function StDy ( Y: float ): integer;

function Sxtox ( X: float ): float;
function Sytoy ( Y: float ): float;
{ vraci logaritmovanou hodnotu pokud je osa log }

procedure SLineTo ( x, y: FLOAT );
procedure SMoveTo ( x, y: FLOAT );
  { bezpecny posun, kresleni - safe line to, move to. Zohlednuje log osy }

const XisLog: boolean = false; { implicitni zahrnuti log/lin osy }
      YisLog: boolean = false;

procedure Graf094inic;

(********************************************************)
(********************************************************)





IMPLEMENTATION

CONST
  NbSymbols = 10;

TYPE
  SymbolBitMap  = ARRAY [1..5] OF Byte;
  SymbolBitMaps = ARRAY [1..NbSymbols] OF SymbolBitMap;

  _VPmem = RECORD
            ptr :Pointer;
            size:WORD;
           END;

CONST
  Symbols :SymbolBitMaps =
    (($22,$27,$FA,$20,$20),($8D,$52,$25,$50,$88),($22,$77,$FA,$70,$20),
     ($22,$55,$8A,$50,$20),($FF,$8D,$8F,$88,$F8),($FF,$FF,$FF,$F8,$F8),
     ($22,$22,$25,$50,$88),($84,$43,$3C,$40,$80),($8D,$52,$22,$20,$20),
     ($09,$16,$E1,$10,$08));  (* bit 7-3 matice 5x5, 2-0 matice 3x3 *)

VAR i     :INTEGER;
    _VPsto  : ARRAY [0.._MaxViewPorts] OF _VPmem;

FUNCTION Max(a,b:FLOAT):FLOAT;
  BEGIN
    IF a>=b THEN Max:=a ELSE Max:=b
  END;

FUNCTION Min(a,b:FLOAT):FLOAT;
  BEGIN
    IF a<=b THEN Min:=a ELSE Min:=b
  END;

FUNCTION IMax(i,j:INTEGER):INTEGER;
  BEGIN
    IF j>i THEN IMax:=j ELSE IMax:=i
  END;

FUNCTION IMin(i,j:INTEGER):INTEGER;
  BEGIN
    IF i<=j THEN IMin:=i ELSE IMin:=j
  END;

FUNCTION Bit(number:INTEGER; InByte:Byte):INTEGER;
  BEGIN
    IF (InByte AND (1 SHL number))<>0 THEN Bit:=1
    ELSE Bit:=0;
  END;

FUNCTION EnterGraphic: boolean;   {+++ ted je to funkce }
  VAR
    Gd,Gm,GrErr :INTEGER;
    C: char; {++++}
  BEGIN
    EnterGraphic:=false; {+++}
    if DoDetectMode
      then Gd:=Detect
      else begin Gd:=TheGrDriver; Gm:=TheGrMode end;
    InitGraph(Gd,Gm,'');
    GrErr:= GraphResult;
    IF GrErr<>grOK THEN
      BEGIN
        Write(#7,'GrErr=',GrErr,'  ',GraphErrorMsg(GrErr),'.  A=abort, else continue: ');
        EnterGraphic:=true; {++++}
        repeat until KeyPressed; {++++}
        if UpCase(ReadKey)='A' then Halt(1);
      END;
  END; (* EnterGraphic *)

CONST
  Log10_e = 0.434294481903;
  Ln_10   = 2.302585092994;

FUNCTION Log10(x:FLOAT) :FLOAT;
  BEGIN
    Log10:= Log10_e*Ln(x)
  END;

FUNCTION ALog10(x:FLOAT) :FLOAT;
  BEGIN
    ALog10:= exp(Ln_10*x)
  END;

PROCEDURE NumPart(x:FLOAT; VAR c,f,e :LONGINT);
  (* Oddeli casti zobrazeni x : c.fEe *)
  VAR s   :String;
      i,j :INTEGER;
  BEGIN
    Str(x:12,s);
    i:= Pos('.',s);
    Val(Copy(s,1,i-1),c,j);
    j:= Pos('E',s);
    Val(Copy(s,i+1,j-i-1),f,i);
    Val(Copy(s,j+1,Length(s)-j),e,j);
  END; (* NumPart *)

FUNCTION MakeNum(c,e:LONGINT) :String;
  (* Z casti c, e (z NumPart) vytvori ciselny string *)
  VAR s :String;
      i :INTEGER;
  BEGIN
    IF Abs(e)>3 THEN BEGIN
      Str(e:4,s);
      WHILE s[1]=' ' DO Delete(s,1,1);
      s:= Chr(48+c)+'e'+s
      END
    ELSE BEGIN
      s:=Chr(48+c); s[0]:= #1;
      IF e>=0 THEN FOR i:=1 TO e DO s:=s+'0'
      ELSE BEGIN
        FOR i:= 2 TO Abs(e) DO s:= '0'+s;
        s:='0.'+s;
      END;
    END;
    MakeNum:= s;
  END;  (* MakeNum *)


PROCEDURE LeaveGraphic;
  BEGIN
    ClearDevice; CloseGraph;
  END;

FUNCTION NtDx(x:FLOAT): INTEGER;    var Pom: float;
  BEGIN
  Pom:=x*GetmaxX;  {+++}
  if Pom>MaxInt then NtDx:=MaxInt-1000 else
    if Pom<-MaxInt then NtDx:=-MaxInt+1000 else NtDx:=Round(Pom)
  END;

FUNCTION NtDy(y:FLOAT): INTEGER;   var Pom: float;
  BEGIN
  Pom:=y*GetMaxY; {+++}
  if Pom>MaxInt then NtDy:=MaxInt-1000 else
    if Pom<-MaxInt then NtDy:=-MaxInt+1000 else NtDy:=Round(Pom)
  END;

PROCEDURE DefineViewPort (VPnb :INTEGER;
                       NGx1,NGy1,NGx2,NGy2 :FLOAT;
                       UGx1,UGy1,UGx2,UGy2 :FLOAT;
                       framecolor,vpcolor :INTEGER);
 VAR
   VPinfo :_GrViewPortInfo;
   dx,dy  :FLOAT;
   px,py  :INTEGER;
 BEGIN
  WITH _VPinfo[VPnb] DO BEGIN
     VPdefined:=TRUE;
     VP.x1:=NtDx(NGx1); VP.x2:=NtDx(NGx2);
     VP.y1:=NtDy(NGy1); VP.y2:=NtDy(NGy2);  VP.clip:=ClipOff;
     VPframecol:=framecolor;
     VPcol:=vpcolor;
     VPux1:=UGx1; VPux2:=UGx2; VPuy1:=UGy1; VPuy2:=UGy2;
     px:=VP.x2-VP.x1; py:=VP.y2-VP.y1;
     dx:=UGx2-UGx1; dy:=UGy2-UGy1;
     VPPixDx:= px/dx; VPPixDy:= py/dy;
     VPDxPix:=dx/px; VPDyPix:=dy/py;
     VPmaxX:=VP.x2-VP.x1; VPmaxY:=VP.y2-VP.y1;
  END;
 END  (* DefineViewPort *);

PROCEDURE RedefineUserUnits(VPnb:INTEGER; UGx1,UGy1,UGx2,UGy2:FLOAT);
  VAR dx,dy :FLOAT;
      px,py :INTEGER;
  BEGIN
    IF _VPinfo[VPnb].VPdefined THEN BEGIN
      WITH _VPinfo[VPnb] DO BEGIN
        VPux1:=UGx1; VPux2:=UGx2; VPuy1:=UGy1; VPuy2:=UGy2;
        px:=VP.x2-VP.x1; py:=VP.y2-VP.y1;
        dx:=UGx2-UGx1; dy:=UGy2-UGy1;
        VPPixDx:= px/dx; VPPixDy:= py/dy;
        VPDxPix:=dx/px; VPDyPix:=dy/py;
      END;
    IF VPnb=VP_used THEN
       SelectViewPort(VPnb,FALSE,VP_clip);   {Aktualizace prac.hodnot}
    END;
  END;  (* RedefineUserUnits *)


PROCEDURE VPclip(clip:BOOLEAN);
  BEGIN
    WITH _VPinfo[VP_used] DO BEGIN
      SetViewPort(VP.x1,VP.y1,VP.x2,VP.y2,clip);
      VP_clip:=clip;
    END;
  END; (*VPclip*)

PROCEDURE DisplayViewPort(VPnb :INTEGER);
  VAR
    StoCol: WORD;
    stoVPnb :INTEGER;
    stoVPcl :BOOLEAN;
  BEGIN
    IF _VPinfo[VPnb].VPdefined THEN BEGIN
      stoVPnb:= VP_used; stoVPcl:= VP_clip;
      SelectViewPort(0,FALSE,ClipOff);
      WITH _VPinfo[VPnb] DO BEGIN
        FillRectangle(VP.x1,VP.y1,VP.x2,VP.y2,SolidFill,VPcol);
        IF  VPFramecol>=0 THEN BEGIN
            StoCol:= GetColor;
            SetColor(VPFramecol);
            SetLineStyle(SolidLn,0,NormWidth);
            Rectangle(VP.x1-1,VP.y1-1,VP.x2+1,VP.y2+1);
            SetColor(StoCol);
        END;
      END;
      SelectViewPort(stoVPnb,FALSE,stoVPcl);
    END;
  END; (*DisplayViewPort*)

PROCEDURE SelectViewPort(VPnb :INTEGER; DispVP,ClipVP :BOOLEAN);
  BEGIN
   IF _VPinfo[VPnb].VPdefined THEN BEGIN
     VP_used:=VPnb;
     WITH _VPinfo[VPnb] DO BEGIN
       VP_x1:= VP.x1; VP_x2:=VP.x2; VP_y1:=VP.y1; VP_y2:=VP.y2;
       VP_clip:= ClipVP;
       VP_ux1:= VPux1; VP_ux2:=VPux2; VP_uy1:=VPuy1; VP_uy2:=VPuy2;
       VP_maxX:=VPmaxX; VP_maxY:=VPmaxY;
       VP_DxPix:=VPDxPix; VP_DyPix:=VPDyPix;
       VP_PixDx:=VPPixDx; VP_PixDy:=VPPixDy;
       VP_framecol:=VPframecol;
       VP_col:=VPcol;
       SetViewPort(VP.x1,VP.y1,VP.x2,VP.y2,ClipVp);
       IF DispVP THEN DisplayViewPort(VPnb);
     END;
   END;
{++++++++++++} XisLog:=false; YisLog:=false;
 END; (*SelectViewPort*)

FUNCTION UtDx(x: FLOAT):integer; var Pom: float;
  BEGIN  Pom:=(x-VP_ux1)*VP_PixDx; { +++ }
  if Pom>MaxInt then UtDx:=MaxInt-1000 else
    if Pom<-MaxInt then UtDx:=-MaxInt+1000 else UtDx:=Round(Pom)
  END;

FUNCTION UtDy(y: FLOAT):integer; var Pom: float;
  BEGIN Pom:=(VP_uy2-y)*VP_PixDy; { +++ }
  if Pom>MaxInt then UtDy:=MaxInt-1000 else
    if Pom<-MaxInt then UtDy:=-MaxInt+1000 else UtDy:=Round(Pom)
  END;


PROCEDURE UMoveTo(x,y:FLOAT);
  BEGIN MoveTo(UtDx(x),UtDy(y)) END;

PROCEDURE ULineTo(x,y:FLOAT);
  BEGIN LineTo(UtDx(x),UtDy(y)) END;

PROCEDURE ULine(x1,y1,x2,y2 :FLOAT);
  BEGIN Line(UtDx(x1),UtDy(y1),UtDx(x2),UtDy(y2)) END;

FUNCTION IntStr(i:INTEGER):String;
 VAR
  s :String;
 BEGIN
 Str(i,s);
 WHILE s[1]=' ' DO  Delete(s,1,1);
 IntStr:=s;
 END  (* IntStr *);

FUNCTION FloatStr(r:FLOAT; cifer:INTEGER):String;
 (* Vystup realneho cisla pro popis s min. poctem cifer *)
CONST
 MinFLOAT=1e-36;  (* Pro Abs(r)< MinFLOAT se klade r=0 *)
VAR
 s :String;
 DesMist,j :INTEGER;
 sign,sciform   :Boolean;
 pr :FLOAT;
BEGIN
 IF Abs(r)<MinFLOAT THEN
   FloatStr:='0'
 ELSE
 BEGIN    (* r<>0 *)
  IF cifer<2 THEN cifer:=2;
  IF r<0 THEN sign:=True ELSE sign:=False;
  r:=Abs(r); sciform:=False;
  IF (r>=1E4) OR (r<1E-3) THEN
    BEGIN
    Str(-r:cifer+6,s); Delete(s,1,1);
    s[Pos('E',s)]:='e'; sciform:=True
    END
  ELSE
   BEGIN
   DesMist:=cifer-2; pr:=10.0;
   WHILE r<pr DO
    BEGIN DesMist:=DesMist+1; pr:=0.1*pr END;
   Str(r:18:DesMist,s);
   END;
  IF Pos('.',s)>0 THEN
   BEGIN
   j:=Length(s);
   IF sciform THEN j:=Pos('e',s)-1;
   WHILE s[j]='0' DO BEGIN Delete(s,j,1); j:=j-1 END;
   IF s[j]='.' THEN Delete(s,j,1);
   END;
  WHILE s[1]=' ' DO Delete(s,1,1);
  IF sign THEN s:=Concat('-',s);
  {+++} J:=Pos('e',S); if J>0 then
          begin if S[J+1]='-' then inc(J); inc(J);
          while (J<=length(S)) and (S[J]='0') do Delete(S,J,1) end;
  FloatStr:=s;
 END  (* r<>0 *)
END   (* FLOATStr *);


PROCEDURE PlotAxis (Xax :_AxesType;
                   OdX,DoX,DelOdX,DelDoX,KrokDelX,KrokPopX :FLOAT;
                   XnumPos: _LabPosition; XtickOut,XtickIn :INTEGER;
                   GridX  : _GridType;
                   XLab :_GrLabel; PosLabX :_LabPosition;
                   XsourY,YsourX :FLOAT;
                   Yax :_AxesType;
                   OdY,DoY,DelOdY,DelDoY,KrokDelY,KrokPopY :FLOAT;
                   YnumPos: _LabPosition; YtickOut,YtickIn :INTEGER;
                   GridY  : _GridType;
                   YLab :_GrLabel; PosLabY : _LabPosition;
                   AxCol,AxFont,FontSize :INTEGER;
                   GridCol,GridLineType:INTEGER);

VAR
  MarkNum :String;
  p1,p2,maxtxt,stocol     :INTEGER;
  Xdel,Ydel,tolX,tolY,r1  :FLOAT;
  Xto,Xti,Yto,Yti,                         (* delka delicich carek v pix *)
  XtoL,YtoL,XtiL,YtiL     :INTEGER;        (* xxxL - delsi carky         *)
  grdx1,grdx2,grdy1,grdy2 :INTEGER;        (* meze pro cary site         *)
  xdev,ydev,                               (* aktualni souradnice deleni *)
  dxsoury,dysourx         :INTEGER;        (* XsourY a YsourX v dev.jedn.*)

PROCEDURE GridLineX;
  BEGIN
    IF (Yax=NoAxes) OR (Abs(xdev-dxsoury)>tolX) THEN BEGIN
      SetColor(GridCol); SetLineStyle(GridLineType,0,NormWidth);
      Line(xdev,grdy1,xdev,grdy2);
      SetColor(AxCol);   SetLineStyle(SolidLn,0,NormWidth)
    END;
  END;

PROCEDURE GridLineY;
  BEGIN
    IF (Xax=NoAxes) OR (Abs(ydev-dysourx)>tolY) THEN BEGIN
      SetColor(GridCol); SetLineStyle(GridLineType,0,NormWidth);
      Line(grdx1,ydev,grdx2,ydev);
      SetColor(AxCol);   SetLineStyle(SolidLn,0,NormWidth)
    END;
  END;


PROCEDURE DrawLinX;
 BEGIN
   Xdel:=Round(DelOdX/KrokDelX)*KrokDelX;
   IF Xdel<DelOdX THEN Xdel:=Xdel+KrokDelX;
   ydev:= UtDy(YsourX);  maxtxt:= 0;
   WHILE Xdel<=DelDoX DO BEGIN                    (* znacky a popis *)
     IF Abs(Xdel)<VP_DxPix THEN Xdel:=0;
     xdev:= UtDx(Xdel);
     r1:=Abs(Xdel-KrokPopX*Round(Xdel/KrokPopX));
     IF  (r1<tolX) AND ((Yax=NoAxes) OR (Abs(OdY-YsourX)<tolY)
                         OR (Abs(DoY-YsourX)<tolY)
                         OR (Abs(Xdel-XsourY)>tolX))
         THEN BEGIN                                (* popsana znacka *)
           IF GridX<>NoGrid THEN GridLineX;
           Line(xdev,ydev-XtiL,xdev,ydev+XtoL);
           MarkNum:= FloatStr(Xdel,6);
           maxtxt:=Imax(maxtxt,TextWidth(MarkNum));
           CASE XnumPos OF
             LabBellowH : OutTextXY(xdev,ydev+XtoL+2,MarkNum);
             LabAboveH  : OutTextXY(xdev,ydev-XtiL-2,MarkNum);
             ELSE;
           END
         END
     ELSE BEGIN
         IF GridX=FineGrid THEN GridLineX;
         Line(xdev,ydev-Xti,xdev,ydev+Xto)
     END;
     Xdel:=Xdel+KrokDelX;
   END  (* while *);
 END;  (* DrawLinX *)

PROCEDURE DrawLinY;
  BEGIN
    Ydel:=Round(DelOdY/KrokDelY)*KrokDelY;
    IF Ydel<DelOdY THEN Ydel:=Ydel+KrokDelY;
    xdev:= UtDx(XsourY); maxtxt:=0;
    WHILE Ydel<=DelDoY DO BEGIN
      IF Abs(Ydel)<tolY THEN Ydel:=0;
      ydev:= UtDy(Ydel);
      r1:=Abs(Ydel-KrokPopY*Round(Ydel/KrokPopY));
      IF (r1<tolY) AND ((Xax=NoAxes) OR (Abs(OdX-XsourY)<tolX)
                         OR (Abs(DoX-XsourY)<tolX)
                         OR (Abs(Ydel-YsourX)>tolY))
        THEN BEGIN
          IF GridY<>NoGrid THEN GridLineY;
          Line(xdev-YtoL,ydev,xdev+YtiL,ydev);
(* !!!          MarkNum:= FloatStr(Ydel,6); *)
                MarkNum:= FloatStr(Ydel,6);
          maxtxt:= Imax(maxtxt,TextWidth(MarkNum));
          CASE YnumPos OF
            LabLeftH : OutTextXY(xdev-YtoL-1,ydev,MarkNum);
            LabRightH: OutTextXY(xdev+YtiL+2,ydev,MarkNum);
            ELSE;
          END;
        END
      ELSE BEGIN
        IF GridY=FineGrid THEN GridLineY;
        Line(xdev-Yto,ydev,xdev+Yti,ydev)
      END;
      Ydel:=Ydel+KrokDelY;
    END  (* while *);
 END ; (* DrawLinY *)



PROCEDURE DrawLogX;
 VAR
   c1,f1,e1,
   c2,f2,e2    :LONGINT;
   tick2,tick5 :BOOLEAN;   (* Pro TRUE popisuje 2,resp.5 *)
   xyflg       :BOOLEAN;   (* TRUE pro OdY=YsourX *)
 BEGIN
  ydev:=UtDy(YsourX); maxtxt:=0;
  IF (Abs(dxsoury-UtDy(OdY))<tolY)
     OR (Abs(dxsoury-UtDy(DoY))<tolY) THEN
     xyflg:=TRUE ELSE xyflg:=FALSE;
  IF KrokDelX<>0.0 THEN tick2:=TRUE ELSE tick2:=FALSE;
  IF KrokPopX<>0.0 THEN tick5:=TRUE ELSE tick5:=FALSE;
  NumPart(ALog10(DelOdX),c1,f1,e1);
  NumPart(ALog10(DelDoX),c2,f2,e2);
  IF f1>0 THEN Inc(c1);
  IF c1=10 THEN BEGIN c1:=1; Inc(e1) END;
  REPEAT
    xdev:= UtDx(Log10(c1)+e1);
    IF (c1 IN [1,2,5]) AND
       ((Yax=NoAxes) OR xyflg OR (Abs(xdev-dxsoury)>tolX))
    THEN BEGIN
       IF GridX<>NoGrid THEN GridLineX;
       Line(xdev,ydev-XtiL,xdev,ydev+XtoL);
       IF (c1=1)
          OR ((c1=2) AND tick2) OR ((c1=5) AND tick5) THEN BEGIN
         MarkNum:= MakeNum(c1,e1);
         maxtxt:= Imax(maxtxt,TextWidth(MarkNum));
         CASE XnumPos OF
           LabBellowH : OutTextXY(xdev,ydev+XtoL+2,MarkNum);
           LabAboveH  : OutTextXY(xdev,ydev-Xtil-2,MarkNum);
           ELSE;
         END
       END
      END
    ELSE BEGIN
      IF GridX=FineGrid THEN GridLineX;
      Line(xdev,ydev-Xti,xdev,ydev+Xto)
    END;
    Inc(c1);
    IF c1=10 THEN BEGIN c1:=1; Inc(e1) END;
  UNTIL (e1>=e2) AND (c1>c2);
 END;  (* DrawLogX *)


PROCEDURE DrawLogY;
 VAR
   c1,f1,e1,
   c2,f2,e2    :LONGINT;
   tick2,tick5 :BOOLEAN;   (* Pro TRUE popisuje 2,resp.5 *)
   xyflg       :BOOLEAN;   (* TRUE pro OdX=XsourY *)
 BEGIN
  xdev:=UtDx(XsourY); maxtxt:=0;
  IF (Abs(dysourx-UtDx(OdX))<tolX)
    OR (Abs(dysourx-UtDx(DoX))<tolX) THEN
    xyflg:=TRUE ELSE xyflg:=FALSE;
  IF KrokDelY<>0.0 THEN tick2:=TRUE ELSE tick2:=FALSE;
  IF KrokPopY<>0.0 THEN tick5:=TRUE ELSE tick5:=FALSE;
  NumPart(ALog10(DelOdY),c1,f1,e1);
  NumPart(ALog10(DelDoY),c2,f2,e2);
  IF f1>0 THEN Inc(c1);
  IF c1=10 THEN BEGIN c1:=1; Inc(e1) END;
  REPEAT
    ydev:= UtDy(Log10(c1)+e1);
    IF (c1 IN [1,2,5]) AND
       ((Xax=NoAxes) OR xyflg OR (Abs(ydev-dysourx)>tolY))
    THEN BEGIN
       IF GridY<>NoGrid THEN GridLineY;
       Line(xdev-YtoL,ydev,xdev+YtiL,ydev);
       IF (c1=1)
          OR ((c1=2) AND tick2) OR ((c1=5) AND tick5) THEN BEGIN
         MarkNum:= MakeNum(c1,e1);
         maxtxt:= Imax(maxtxt,TextWidth(MarkNum));
         CASE YnumPos OF
           LabLeftH  : OutTextXY(xdev-YtoL-1,ydev,MarkNum);
           LabRightH : OutTextXY(xdev+YtiL+2,ydev,MarkNum);
           ELSE;
         END
       END
      END
    ELSE BEGIN
      IF GridY=FineGrid THEN GridLineY;
      Line(xdev,ydev-Xto,xdev,ydev+Xti)
    END;
    Inc(c1);
    IF c1=10 THEN BEGIN c1:=1; Inc(e1) END;
  UNTIL ((e1>=e2) AND (c1>c2)) or (ydev<0);
     {+++ pridal jsem ydev<0 - jinak vznikal nekonecny cyklus pri ymax=10^n-1 }
 END;  (* DrawLogX *)


BEGIN
 tolX:= VP_DxPix; tolY:= VP_DyPix;
 stocol:=GetColor;
 SetColor(AxCol);

 IF Yax<>NoAxes THEN BEGIN
   IF OdY=DoY THEN BEGIN OdY:=VP_uy1; DoY:=VP_uy2 END
   ELSE IF Yax=LogAxes THEN BEGIN
      OdY:=Log10(OdY); DoY:=Log10(DoY)
   END;
   IF DelOdY=DelDoY THEN BEGIN DelOdY:=OdY; DelDoY:=DoY END
   ELSE IF Yax=LogAxes THEN BEGIN
      DelOdY:=Log10(DelOdY); DelDoY:=Log10(DelDoY)
   END;
   IF DelOdY<OdY THEN DelOdY:=OdY; IF DelDoY>DoY THEN DelDoY:=DoY;
   IF NOT (YnumPos IN [LabLeftH,LabRightH]) THEN
           YnumPos:= LabLeftH;
   IF NOT (PosLabY IN [LabLeftH,LabRightH,LabLeftV,LabRightV]) THEN
           PosLabY:= LabRightH;

 END;

 IF (Yax=LogAxes) AND (Xax<>NoAxes) THEN YsourX:= Log10(YsourX);
 IF (Xax=LogAxes) AND (Yax<>NoAxes) THEN XsourY:= Log10(XsourY);
 dxsoury:= UtDx(XsourY);  dysourx:= Utdy(YsourX);

        (*------------------    osa X   -----------------*)
 IF Xax<>NoAxes THEN BEGIN
   IF OdX=DoX THEN BEGIN OdX:=VP_ux1; DoX:=VP_ux2 END
   ELSE IF Xax=LogAxes THEN BEGIN
      OdX:=Log10(OdX); DoX:=Log10(DoX)
   END;
   IF DelOdX=DelDoX THEN BEGIN DelOdX:=OdX; DelDoX:=DoX END
   ELSE IF Xax=LogAxes THEN BEGIN
      DelOdX:=Log10(DelOdX); DelDoX:=Log10(DelDoX)
   END;
   IF DelOdX<OdX THEN DelOdX:=OdX; IF DelDoX>DoX THEN DelDoX:=DoX;

   IF NOT (XnumPos IN [LabBellowH,LabAboveH]) THEN
           XnumPos:= LabBellowH;
   IF NOT (PosLabX IN [LabBellowH,LabAboveH]) THEN
           PosLabX:= LabAboveH;
                                               { velikost znacek na X }
   Xto:= XtickOut; XtoL:= Round(_Ltfactor*Xto);
   Xti:= XtickIn;  XtiL:= Round(_Ltfactor*Xti);
 END;

 IF GridY<>NoGrid THEN
    IF Xax<>NoAxes THEN BEGIN
       grdx1:= UtDx(OdX); grdx2:=UtDx(DoX) END
    ELSE BEGIN
       grdx1:= UtDx(VP_ux1); grdx2:= UtDx(VP_ux2)
    END;

 IF GridX<>NoGrid THEN
    IF Yax<>NoAxes THEN BEGIN
       grdy1:= UtDy(OdY); grdy2:=UtDy(DoY) END
    ELSE BEGIN
       grdy1:= UtDy(VP_uy1); grdy2:= UtDy(VP_uy2)
    END;


 IF Xax<>NoAxes THEN BEGIN
   SetTextStyle(AxFont,HorizDir,FontSize);

   ULine(OdX,YsourX,DoX,YsourX);                    (* nakresli osu *)

   CASE XnumPos OF
      LabBellowH : SetTextJustify(CenterText,TopText);
      LabAboveH  : SetTextJustify(CenterText,BottomText);
   END;
   CASE Xax OF
     LinAxes : DrawLinX;
     LogAxes : DrawLogX;
     ELSE;
   END;

   IF Xlab <> '' THEN                                   (* X label *)
     CASE PosLabX OF
      LabBellowH :
          BEGIN
           SetTextJustify(RightText,TopText);
           p1:=4; IF XtickOut>=0 THEN Inc(p1,XtoL);
           IF XnumPos=LabBellowH THEN Inc(p1,TextHeight('M'));
           OutTextXY(UtDx(DoX)-5,UtDy(YsourX)+p1,Xlab)
          END;
      LabAboveH :
          BEGIN
           SetTextJustify(RightText,BottomText);
           p1:=4; IF XtickIn>=0 THEN Inc(p1,XtiL);
           IF XnumPos=LabAboveH THEN Inc(p1,TextHeight('M'));
           OutTextXY(UtDx(DoX)-5,UtDy(YsourX)-p1,Xlab);
          END;
     END;  (* case *)
 END;    (* Xax -  kresba osy X *)

     (*---------------   kresba osy Y  ---------------*)
 IF Yax<>NoAxes THEN BEGIN

   Yto:= YtickOut; YtoL:= Round(_Ltfactor*Yto);
   Yti:= YtickIn;  YtiL:= Round(_Ltfactor*Yti);

   SetTextStyle(AxFont,HorizDir,FontSize);
   ULine(XsourY,OdY,XsourY,DoY);

   CASE YnumPos OF
     LabLeftH:  SetTextJustify(RightText,CenterText);
     LabRightH: SetTextJustify(LeftText,CenterText);
   END;
   CASE Yax OF
     LinAxes : DrawLinY;
     LogAxes : DrawLogY;
     ELSE ;
   END;

  IF Ylab <> '' THEN
   BEGIN
    CASE PosLabY OF
     LabRightH :
         BEGIN
          SetTextStyle(AxFont,HorizDir,FontSize);
          SetTextJustify(LeftText,TopText);
          p1:=3; IF YTickIn>0 THEN Inc(p1,YtiL);
          IF YnumPos=LabRightH THEN Inc(p1,maxtxt+2);
          OutTextXY(dxsoury+p1,UtDy(DoY)+15,Ylab)
         END;
     LabLeftH:
         BEGIN
          SetTextStyle(AxFont,HorizDir,FontSize);
          SetTextJustify(RightText,TopText);
          p1:=3; IF YTickOut>0 THEN Inc(p1,YtiL);
          IF YnumPos=LabLeftH THEN Inc(p1,maxtxt+2);
          OutTextXY(dxsoury-p1,UtDy(DoY)+15,Ylab)
         END;
     LabRightV:
         BEGIN
          SetTextStyle(AxFont,VertDir,FontSize);
          SetTextJustify(RightText,RightText);
          p1:=4+TextHeight('M');
          IF YtickIn>=0 THEN Inc(p1,YtiL);
          IF YnumPos=LabRightH THEN Inc(p1,maxtxt+3);
          OutTextXY(dxsoury+p1,UtDy(DoY)+5,Ylab)
         END;
     LabLeftV:
         BEGIN
          SetTextStyle(AxFont,VertDir,FontSize);
          SetTextJustify(RightText,RightText);
          p1:=4; IF YtickOut>=0 THEN Inc(p1,YtoL);
          IF YnumPos=LabLeftH THEN Inc(p1,maxtxt+3);
          OutTextXY(dxsoury-p1,UtDy(DoY)+5,Ylab)
         END;
    END  (* case *)
   END  (* if - popis osy Y *);
   IF PosLabY in [LabLeftV..LabAboveV] THEN
       SetTextStyle(AxFont,HorizDir,FontSize);
  END   (*  Yax = True  -  PltYax *);
  SetColor(stocol);
END;   (* PlotAxis *)



PROCEDURE FillRectangle(ix1,iy1,ix2,iy2:INTEGER; FillPatt,Color: WORD);
     (* FillPatt v barve Color do obdelniku (ix1,iy1),(ix2,iy2) *)
 VAR
   stoFill :FillSettingsType;
 BEGIN
   GetFillSettings(stoFill);
   SetFillStyle(FillPatt,Color);
   Bar(ix1,iy1,ix2,iy2);
   SetFillStyle(stoFill.Pattern,stoFill.color);
 END  (* FillRectangle *);

PROCEDURE PltSymbol (number:INTEGER; x,y:FLOAT; size,color:INTEGER);
  VAR
    StartBit,EndBit,NbBits,ix,iy,i,j :INTEGER;
  BEGIN
    IF size<=3 THEN NbBits:=3 ELSE NbBits:=5;
    IF NbBits=5 THEN
       BEGIN StartBit:=7; EndBit:=3 END
    ELSE
       BEGIN StartBit:=2; EndBit:=0 END;
    UMoveTo(x,y); ix:=GetX-1; iy:=GetY-1;
    IF NbBits=5 THEN BEGIN Dec(ix); Dec(iy) END;
    FOR i:=1 TO NbBits DO
      BEGIN
        FOR j:= StartBit DOWNTO EndBit DO
          BEGIN
            IF Bit(j,Symbols[number,i])=1 THEN
               PutPixel(ix,iy,color);
            Inc(ix);
          END; (* for j *)
        Dec(ix,NbBits); Inc(iy);
      END; (* for i *)
  END;  (* PltSymbol *)

PROCEDURE PltText (otext:String; x,y :FLOAT;
                   font,size,FgCol,BkCol: WORD);
 VAR  StoViewPort   :ViewPortType;
      StoCol,StoAPC :WORD;
      StoTxtSet     :TextSettingsType;
      cor           :INTEGER;
 BEGIN
   GetTextSettings(StoTxtSet);
   SetTextStyle(font,StoTxtSet.direction,size);
   StoAPC:= VP_col;
   IF FgCol<>BkCol THEN
      BEGIN
       IF font<>0 THEN cor:= TextHeight('a') DIV 2 ELSE cor:=0;
       FillRectangle(UtDx(x)-2,UtDy(y)-TextHeight(otext)-2,
                     UtDx(x)+TextWidth(otext), UtDy(y)+cor,SolidFill,BkCol);
       StoCol:=GetColor; SetColor(FgCol);
      END;
   SetTextJustify(LeftText,BottomText);
   OutTextXY(UtDx(x),UtDy(y),otext);
   IF FgCol<>BkCol THEN SetColor(StoCol);
   WITH StoTxtSet DO SetTextStyle(font,direction,charsize);
   VP_col:=StoAPC;
 END;  (* PltText *)


PROCEDURE PltChar (ch:CHAR; x,y :FLOAT; font,size,color :WORD);
  VAR  oldcol    :WORD;
       StoTxtSet :TextSettingsType;
  BEGIN
    oldcol:=GetColor; SetColor(color);
    GetTextSettings(StoTxtSet);
    SetTextStyle(Font,HorizDir,size);
    SetTextJustify(CenterText,CenterText);
    OutTextXY(UtDx(x),UtDy(y),ch);
    SetColor(oldcol);
    WITH StoTxtSet DO SetTextStyle(Font,Direction,CharSize);
  END;  (* PltChar *)

PROCEDURE StoreViewPort(VPnb :INTEGER; Frame :BOOLEAN);
  VAR fr,stoVPnb :INTEGER;
      stoVPcl    :BOOLEAN;
  BEGIN
    stoVPnb:= VP_used;  stoVPcl:= VP_clip;
    SelectViewPort(0,FALSE,ClipOff);
    WITH _VPinfo[VPnb] DO BEGIN
       IF Frame AND (VPframecol>=0) THEN
          fr:=1
       ELSE fr:=0;
       _VPsto[VPnb].size:=ImageSize(VP.x1-fr,VP.y1-fr,VP.x2+fr,VP.y2+fr);
       GetMem(_VPsto[VPnb].ptr,_VPsto[VPnb].size);
       GetImage(VP.x1-fr,VP.y1-fr,VP.x2+fr,VP.y2+fr,_VPsto[VPnb].ptr^)
    END;
    SelectViewPort(stoVPnb,FALSE,stoVPcl);
  END;  (* StoreViewPort *)

PROCEDURE RestoreViewPort(VPnb :INTEGER; x,y :INTEGER; BitOper : WORD);
  VAR stoVPnb :INTEGER;
      stoVPcl :BOOLEAN;
  BEGIN
    IF _VPsto[VPnb].ptr<>NIL THEN BEGIN
       stoVPnb:= VP_used;  stoVPcl:= VP_clip;
       SelectViewPort(0,FALSE,ClipOff);
       PutImage(x,y,_VPsto[VPnb].ptr^,BitOper);
       SelectViewPort(stoVPnb,FALSE,stoVPcl);
       VP_clip:=stoVPcl;
    END;
  END;  (* RestoreViewPort *)

PROCEDURE DeleteViewPort(VPnb :INTEGER);
  BEGIN
    WITH _VPsto[VPnb] DO
      IF ptr<>NIL THEN BEGIN
        FreeMem(ptr,size);
        ptr:= NIL; size:= 0;
      END;
  END;  (* DeleteViewPort *)



{++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
(******************** pridal jsem si: *******************)
{++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NtUx ( X: float ): float;
begin NtUx:= x*getmaxx / VP_PixDx + VP_ux1 end;

function NtUy ( Y: float ): float;
begin NtUy:= y*getmaxy / VP_PixDy + VP_uy1 end;

function UtNx ( X: float ): float;
begin UtNx:= (x - VP_ux1) * VP_PixDx / getmaxx  end;

function UtNy ( Y: float ): float;
begin UtNy:= (y - VP_uy1) * VP_PixDy / getmaxy end;

FUNCTION DtUx ( x: integer ): float;
  BEGIN DtUx:= x / VP_PixDx + VP_ux1 END;

FUNCTION DtUy ( y: integer ): float;
  BEGIN  DtUy:= VP_uy2 - y / VP_PixDy END;

function Sxtox ( X: float ): float;
begin
if XisLog then if X>0 then Sxtox:=log10(X) else Sxtox:=log10(_minreal)
  else Sxtox:=X
end;

function Sytoy ( Y: float ): float;
begin
if YisLog then if Y>0 then Sytoy:=log10(Y) else Sytoy:=log10(_minreal)
  else Sytoy:=Y
end;

function StDx ( X: float ): integer;
begin
if XisLog then if X>0 then X:=log10(X) else X:=log10(_minreal);
  { else X:=X }
StDx:=UtDx(X);
end;

function StDy ( Y: float ): integer;
begin
if YisLog then if Y>0 then Y:=log10(Y) else Y:=log10(_minreal);
  { else Y:=Y }
StDy:=UtDy(Y);
end;

PROCEDURE SMoveTo ( x, y: FLOAT );    var A: float;
  BEGIN
  if XisLog then
    if X>0 then X:=log10(X)  {ochrana pred zapornymi cisly a 0}
           else X:=log10(_minreal);
  if YisLog then
    if Y>0 then Y:=log10(Y) else Y:=log10(_minreal);
  MoveTo(UtDx(x),UtDy(y))
  END;

PROCEDURE SLineTo ( x, y: FLOAT );    var A: float;
  BEGIN
  if XisLog then
    if X>0 then X:=log10(X) else X:=log10(_minreal);
  if YisLog then
    if Y>0 then Y:=log10(Y) else Y:=log10(_minreal);
  LineTo(UtDx(x),UtDy(y))
  END;


(********************************************************)
(********************************************************)

          (*-------- Inicializace ---------*)

procedure Graf094inic;
VAR GrDriver,GrMode,GrErr :INTEGER;
BEGIN
  FOR i:= 1 TO _MaxViewPorts DO BEGIN
     _VPinfo[i].VPdefined:=FALSE;
     _VPsto[i].ptr:= NIL;   _VPsto[i].size:= 0;
  END;
   (* Definovano je jen okno 0 - tj. cela obrazovka  *)
   (* a uzivatelske souradnice jsou +----------(1,1) *)
   (*                               |              | *)
   (*                               (0,0)----------+ *)
 if DoDetectMode   { +++ }
   then GrDriver:=Detect
   else begin GrDriver:=TheGrDriver; GrMode:=TheGrMode end;
 InitGraph(GrDriver,GrMode,'');
 GrErr:=GrError;
   IF (GrErr<>grOK) and (GrErr<>-11) THEN { +++ }
     BEGIN
       CloseGraph;
       Write(#7,'GrError=',GrErr,'  ',GraphErrorMsg(GrErr));
       readln; exit
     END;
 DefineViewPort(0,0,0,1.0,1.0,0,0,1.0,1.0,-1,_ScreenBkCol);
 SelectViewPort(0,FALSE,TRUE);
 _VPsto[0].ptr:= NIL; _VPsto[0].size:= 0;
 CloseGraph;
end;

         (*-------- Inicializace ---------*)

BEGIN {+++ inicializace zrusena!!!}

{ Graf094inic; {+++ implicitni inicializace zrusena - maze to puvodni obrazovku! }

END.    (* unit Graf *)

Ver. 0.92
     1.12.1990
     (a) Upraveno kriterium pro popis znacek na osach
     (b) Doplnena procedura RedefineUserUnits (neodladena)
Ver. 0.94
     7.1.1990
     (a) Silne prepracovana procedura PlotAxis (drive PltAxis)
     (b) Zrusena GraphGrid (Grid je v PlotAxis)
     (c) Zrusena HardCopyD100
     (d) Do DefineViewPort normalni souradnice (misto device)
     (e) _Ltfactor do INTERFACE
     (f) novy typ _GridType
