UNIT MujGraf;
{ c Petr Mikulk - Brno - 1991 }
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses crt, graph, printer, Graf094, DefFloat;

const MaxRadaR = 1000;

type RfunkceR  = function ( X: real ): real;
     RfunkceI  = function ( I: integer) : real;
     BlbeTurbo = array[0..MaxInt div 6] of real; { TURBO je hloupe, nema konformni pole }

procedure WriteText ( text: string );
(* vystup stringu a CRLF *)

procedure WriteTextXY ( X, Y: integer; text: string );
(* vystup stringu od mista (X,Y) a CRLF *)

procedure SetCRLF(var X,Y:integer);

procedure Krivka ( F: RfunkceR; A, B: float; N: integer; Color: byte );
(* vykresli graf realne funkce F s realnym parametrem v mezich od [A,B]
   krokem (B-A) / N danou barvou. Funkce je volana jako vzdalena, musi byt
   tedy ohranicena {$F+} {$F-} *)

procedure Cara ( Fx: RfunkceI; K, L: integer;
                 Spojit: boolean; Color: byte; var Rada );
(* vykresli se graf [ Fx(I) , Rada[I] ] pro hodnotu indexu I z [K,L]. Fx je
   realna funkce celeho argumentu, Fy je array [0..aspon L] of real.
   Spojit=true: spojit body *)

procedure GrPress;
(* ceka na stisk klavesy v grafickem rezimu *)

procedure IPltText (Otext:string; X,Y : integer;   { x,y jsou souradnice obrazovky }
                    Font,Size,FgCol,BkCol: word);

procedure CNPltText (otext:string; X,Y :float;     { x,y jsou normalni souradnice obrazovky }
                   font,Size ,FgCol,BkCol: Word);
  (*---------------------------------------------------------------------+
  |  Vystup textu "otext" od bodu (x,y). NASTAVIL JSEM SI CENTERTEXT!    |
  |  Barva textu FgCol na pozadi BkCol (prouzek rozsireny o 2pix)        |
  |  Pro FgCol = BkCol se neprovadi nastaveni barev.                     |
  +---------------------------------------------------------------------*)

procedure LNPltText (otext:string; X,Y :float;     { x,y jsou normalni souradnice obrazovky }
                   font,Size ,FgCol,BkCol: Word);
  { totez, ale lefttext }

IMPLEMENTATION

var N,I: integer;
    A,B,X,Y,H: real;
    X1,X2,Y1,Y2: integer;

procedure SetScale ( X1,Y1,X2,Y2: real; A,B,C,D: integer; BkColor,BorderColor: integer );
var Xmin,Ymin,Xmax,Ymax: real;
begin
Xmin:=(C*X1-A*X2)/(C-A);
Xmax:=Xmin+GetMaxX*(X2-Xmin)/C;
Ymin:=(D*Y1-B*Y2)/(D-B);
Ymax:=Ymin+GetMaxY*(Y2-Ymin)/D;
(* Scale(Xmin,Ymin,Xmax,Ymax,BkColor,BorderColor) *)
end;

procedure SetCRLF(var X,Y:integer); var TXT: TextSettingsType;
 begin
  GetTextSettings(TXT); X:=GetX; Y:=GetY;
  with TXT do
   if Direction=0 then Y:=Y+12*CharSize
                  else X:=X+12*CharSize
 end {writeCRLF};

procedure WriteText(text:string); {vystup stringu a CRLF}
 var Ix,Iy:integer;
 begin
  SetCRLF(Ix,Iy);
  OutText(text); MoveTo(Ix,Iy)
 end {writeText};

procedure WriteTextXY(X,Y:integer; text:string); {Vystup od (X,Y) a CRLF}
 var Ix,Iy:integer;
 begin
  MoveTo(X,Y); SetCRLF(Ix,Iy);
  OutText(text); MoveTo(Ix,Iy)
 end {writeTextXY};

procedure Krivka ( F: RfunkceR; A, B: float; N: integer; Color: byte );
var H,X: float; I: integer; C: byte;
begin
C:=GetColor; SetColor(Color); X:=A; H:=(B-A)/N; UmoveTo(A,F(A));
for I:=1 to N do begin X:=X+H; UlineTo(X,F(X)) end;
SetColor(C) end;

procedure Cara ( Fx: RfunkceI; K, L: integer;
                 Spojit: boolean; Color: byte; var Rada );
var I: integer; C: byte; FY: ^BlbeTurbo;
begin
C:=GetColor; SetColor(Color); FY:=@Rada;
UmoveTo(Fx(K),FY^[K]);
if Spojit then for I:=K to L do UlineTo(Fx(I),FY^[I])
          else for I:=K to L do begin UmoveTo(Fx(I),FY^[I]); OutText('+') end;
SetColor(C) end;

procedure iplttext (otext:string; X,Y : integer;
                    font,Size,FgCol,BkCol: Word);
 var  StoViewPort   :ViewPortType;
      StoCol,StoAPC :Word;
      StoTxtSet     :TextSettingsType;
      cor           :integer;
 begin
   GetTextSettings(StoTxtSet);
   SetTextStyle(font,StoTxtSet.Direction,Size);
   StoAPC:= VP_col;
   if FgCol<>BkCol then
      begin
       if font<>0 then cor:= TextHeight('a') div 2 else cor:=0;
       FillRectangle(X-2,Y-TextHeight(otext)-2,
                     X+TextWidth(otext),Y+cor,SolidFill,BkCol);
       StoCol:=GetColor; SetColor(FgCol);
      end;
   SetTextJustify(LeftText,BottomText);
   OutTextXY(X,Y,otext);
   if FgCol<>BkCol then SetColor(StoCol);
   with StoTxtSet do SetTextStyle(font,Direction,CharSize);
   VP_col:=StoAPC;
 end;  (* IPltText *)

procedure CNPltText (otext:string; X,Y :float;
                   font,Size,FgCol,BkCol: Word);
 var  StoViewPort   :ViewPortType;
      StoCol,StoAPC :Word;
      StoTxtSet     :TextSettingsType;
      cor           :integer;
 begin
   GetTextSettings(StoTxtSet);
   SetTextStyle(font,StoTxtSet.Direction,Size);
   StoAPC:= VP_col;
   if FgCol<>BkCol then
      begin
       if font<>0 then cor:= TextHeight('a') div 2 else cor:=0;
       FillRectangle(NtDx(X)-2,NtDy(Y)-TextHeight(otext)-2,
                     NtDx(X)+TextWidth(otext), NtDy(Y)+cor,SolidFill,BkCol);
       StoCol:=GetColor; SetColor(FgCol);
      end;
   SetTextJustify(CenterText,BottomText);
   OutTextXY(NtDx(X),NtDy(Y),otext);
   if FgCol<>BkCol then SetColor(StoCol);
   with StoTxtSet do SetTextStyle(font,Direction,CharSize);
   VP_col:=StoAPC;
 end;  (* PltText *)

procedure LNPltText (otext:string; X,Y :float;
                   font,Size,FgCol,BkCol: Word);
 var  StoViewPort   :ViewPortType;
      StoCol,StoAPC :Word;
      StoTxtSet     :TextSettingsType;
      cor           :integer;
 begin
   GetTextSettings(StoTxtSet);
   SetTextStyle(font,StoTxtSet.Direction,Size);
   StoAPC:= VP_col;
   if FgCol<>BkCol then
      begin
       if font<>0 then cor:= TextHeight('a') div 2 else cor:=0;
       FillRectangle(NtDx(X)-2,NtDy(Y)-TextHeight(otext)-2,
                     NtDx(X)+TextWidth(otext), NtDy(Y)+cor,SolidFill,BkCol);
       StoCol:=GetColor; SetColor(FgCol);
      end;
   SetTextJustify(LeftText,BottomText);
   OutTextXY(NtDx(X),NtDy(Y),otext);
   if FgCol<>BkCol then SetColor(StoCol);
   with StoTxtSet do SetTextStyle(font,Direction,CharSize);
   VP_col:=StoAPC;
 end;  (* PltText *)



procedure GrPress; var C: integer; const S='Stiskem pokracuj...'; M='                   ';
begin
iplttext(S,(GetMaxX-TextWidth(S)) div 2, trunc(GetMaxY*0.92),0,1,red,black);
repeat until KeyPressed; C:=ord(ReadKey);
iplttext(M,(GetMaxX-TextWidth(S)) div 2,trunc(GetMaxY*0.92),0,1,red,black)
end;

end.
