UNIT PmElFun;
{ c - Petr Mikulk - Brno - 1991 }
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses dos, crt, DefFloat, CompNum;

const crlf = #$D#$A;

type PPole = ^ TPole;
     TPole  = array [ 1 .. 10922 ] of real;

     PPole0 = ^ TPole0;
     TPole0  = array [ 0 .. 10921 ] of real;

procedure Beep;
procedure Beepmsec ( msec: word );
procedure Beepni ( K: byte ); { kolikrat }

procedure Press;

function UpString ( S: string ): string;
function NoSpaces ( S: string ): string;
function NoRoundSpaces ( S: string ): string;
  { vymaze mezery pred a za stringem }
function FileExist ( Name: PathStr ): boolean;
function FileExist2 ( Name: PathStr ): boolean;
function GetExtension ( Name: PathStr ): ExtStr;

function sgn ( X: float ): integer; { vraci signum cisla }
function floor ( X: real ): integer;
  { nejvetsi mensi cele cislo }

procedure Ctgh ( X: complex; var Y: complex );
  { hyperbolicky tangens v complexnim oboru }
procedure Ctg ( X: complex; var Y: complex );
  { tangens v complexnim oboru }
function sinc ( X: float ): float;
procedure Csin ( X: complex; var Y: complex );
procedure Csinc ( X: complex; var Y: complex );
procedure Cixpc ( X: complex; var Y: complex ); { Y=e^(i*X) }
procedure CplusDeiF ( C, D, F: Complex; var X: complex );
  { X:= C + D * e^iFaze }

function VtToRad ( Vt: float ): float;
function DMStoDeg ( DMS: float ): float;
function DegToDMS ( Deg: float ): float;
function DMStoRad ( DMS: float ): float;
function RadToDMS ( Rad: float ): float;
function PackDMS ( St, Min, Vt: float ): float;
procedure UnpackDMS ( DMS: float; var St, Min, Vt: float );

function MaxF ( X,Y: float ): float;
function MinF ( X,Y: float ): float;
function MaxL ( X,Y: longint ): longint;
function MinL ( X,Y: longint ): longint;

function StrLong  ( L: longint; Mist: integer ): string;
function StrFloat ( X: float; Mist, Des: integer ): string;
function StrEng   ( X: float; Mist, Des: integer ): string;

function Zaokrouhli ( X: float; Mist: integer ): float;
  { zaokrouhli realne cislo na dany pocet mist }

function TimeToString ( Time: real ): DirStr;
  { cas je v sekundach }

procedure PrvniDvaRadky ( Name: PathStr; var Line1, Line2: string );
  { vyhodi prvni dva radky textoveho souboru Name }

procedure BlokWrite ( var Out: file; var X; Size: longint );
procedure BlokRead  ( var Out: file; var X; Size: longint );
{ jako u standardnich BlockWrite, BlockRead, ale s rozsirenim
  oboru platnosti na longint }

procedure SaveArrays ( var Out: file; Hodnot: word; var PoleX, PoleY );
procedure LoadArrays ( var Inp: file; Hodnot: word; var PoleX, PoleY );

function NactiDataFile ( FileName: PathStr; var AlokPole: longint; var ZpracHodnot: Word;
  var HodnotyX, HodnotyY: PPole ): boolean;
{ HodnotyX,Y se predpokladaji prazdne. Vyhodi true if nestaci pamet.
  Pokud soubor neexistuje, nic se neprovede.
  Typ vstupnich souboru:
    .DNR = 0-1 byte ... pocet polozek
           od 2. bytu ... realne polozky ulozene pres LoadArrays
    .DPR = 0-1 byte ... pocet polozek
           dalsich 2*6 bytu = realna cisla: Xmin, Xmax
           k-ta polozka na x je
             HodnotyX[k]=Xmin+(k-1)*(Xmax-Xmin)/(Pocet-1)
           Nasleduji realna cisla = y-ove souradnice HodnotyY[k]
}


function StringCislo ( S: PathStr; Im: real ): real;
{ Prevede string na cislo.
  Cislo se predpoklada realne. Je-li uvedeno znakem / => vezme se jeho
  prevracena hodnota.
  Napr.   '/-4'  vyhodi  -0.25
  Je-li ve vstupnim retezci chyba, pipne.
  V parametru Im je implicitni hodnota. }
procedure StringDveCisla ( S: PathStr; var Yplus, Ykrat: real );
{ v retezci S by mela byt 2 cisla oddelena carkou.
  Prvni se da do Yplus a druhe z nich do Ykrat. }
procedure StringCtyriCisla ( var S: PathStr; var Xplus, Xkrat, Yplus, Ykrat: real );
{ v retezci S by mela byt 4 cisla oddelena carkou.
  Prvni se da do Xplus, druhe do Xkrat atd.
  V S bude zbytek (az do carky) }


IMPLEMENTATION

uses ElFun;

procedure Beep;
begin sound(440); delay(10); nosound; delay(5) end;

procedure Beepmsec ( msec: word );
begin sound(440); delay(msec); nosound; delay(5) end;

procedure Beepni ( K: byte ); var I: integer;
begin for I:=1 to K do Beep end;

procedure Press;
begin Delay(10); repeat until KeyPressed; ReadKey end;

function UpString ( S: string ): string;     var I: integer;
begin
for I:=1 to length(S) do S[I]:=UpCase(S[I]); UpString:=S
end;

function NoSpaces ( S: string ): string;     var I: integer;
begin
I:=Pos(' ',S);
while I<>0 do
  begin Delete(S,I,1); I:=Pos(' ',S) end;
NoSpaces:=S
end;

function NoRoundSpaces ( S: string ): string; var I: integer;
begin
while (length(S)>0) and (S[length(S)]=' ') do dec(byte(S[0]));
if length(S)=0 then begin NoRoundSpaces:=''; exit end;
I:=1; while S[I]=' ' do inc(I); { netreba ochrana na I>length }
if I>0 then NoRoundSpaces:=Copy(S,I,255)
       else NoRoundSpaces:=S;
end;

function FileExist2 ( Name: PathStr ): boolean;
var F: file;
begin {$I-} assign(F,Name); reset(F); {$I+}
if IOresult=0 then begin FileExist2:=true; close(F) end
else FileExist2:=false
end;

function FileExist ( Name: PathStr ): boolean;
var F: file;
begin
if Name='' then FileExist:=false
  else FileExist:=FileExist2(Name)
end;

function GetExtension ( Name: PathStr ): ExtStr;
var I: byte;
begin
I:=Pos('.',Name);
if I=0 then GetExtension:=''
  else { take the last point }
    begin
    i:=length(Name);
    while Name[i]<>'.' do dec(i);
    GetExtension:=UpString(Copy(Name,I+1,3))
    end
end;

function sgn ( X: float ): integer; { vraci signum cisla }
begin
if X>0 then sgn:=1 else if X=0 then sgn:=0 else sgn:=-1
end;

function floor ( X: real ): integer;
begin
if (X=int(X)) or (X>0) then floor:=trunc(X)
  else floor:=-trunc(-x+1)
end;


function sinc ( X: float ): float;
begin if X=0 then sinc:=1 else sinc:=sin(X)/X end;

procedure Csin ( X: complex; var Y: complex );
var A,B: float;
begin
A:=exp(X.im); B:=1/A;
Y.re:=sin(X.re) * ( A+B ) /2;
Y.im:=cos(X.re) * ( A-B ) /2
end;

procedure Csinc ( X: complex; var Y: complex );
var XX: complex;
begin
if ( X.re=0 ) and ( X.im = 0 )
  then Cnum( 1, 0, Y )
  else begin Csin( X, XX ); Cdiv( XX, X, Y ) end;
end;

procedure Cixpc ( X: complex; var Y: complex ); { Y=e^(i*X) }
begin
Cixp( X.re, Y );
if X.im < 89  { kvuli floating point error }
  then RCmul( exp(-X.im), Y, Y )
  else begin Beep; Cnum( 1e37, 1e37, Y ) end
end;

procedure Ctgh ( X: complex; var Y: complex );
var E,E2,C,S,P,M: float;
begin
E:=exp(X.re); E2:=1/E; C:=cos(X.im); S:=sin(X.im);
P:=E+E2; M:=E-E2;
Cnum( M*C, P*S, X ); Cnum( P*C, M*S, Y );
Cdiv( X, Y, Y )
end;

procedure Ctg ( X: complex; var Y: complex );
{ tg(x) = -i tgh(ix) }
begin
Cnum( -X.im, X.re, X ); Ctgh( X, Y );
Cnum( Y.im, -Y.re, Y )
end;

procedure CplusDeiF ( C, D, F: Complex; var X: complex );
begin
Cixpc( F, F );
Cmul( D, F, D );
Cadd( C, D, X )
end;

function VtToRad ( Vt: float ): float;
begin VtToRad:=Vt*pi/3600/180 end;

function DMStoDeg ( DMS: float ): float;
var St,Min,Vt: float;
begin
St:=int(DMS); DMS:=Frac(DMS)*100;
Min:=int(DMS); Vt:=Frac(DMS)*100;
DMStoDeg:=St+Min/60+Vt/3600;
end;

function DegToDMS ( Deg: float ): float;
var St,Min,Vt: float;
begin
UnpackDeg(Deg,St,Min,Vt);
DegToDMS:=St+Min/100+Vt/10000;
end;

function DMStoRad ( DMS: float ): float;
begin
DMStoRad:=DegToRad(DMStoDeg(DMS))
end;

function RadToDMS ( Rad: float ): float;
begin
RadToDMS:=DegToDMS ( RadToDeg (Rad) );
end;

procedure UnpackDMS ( DMS: float; var St, Min, Vt: float );
begin
St:=int(DMS); DMS:=DMS*100; Min:=int(DMS); Vt:=Frac(DMS)*100
end;

function PackDMS ( St, Min, Vt: float ): float;
begin
PackDMS:=St+Min/100+Vt/1000;
end;

function MaxF ( X,Y: float ): float;
begin if X>Y then MaxF:=X else MaxF:=Y end;
function MinF ( X,Y: float ): float;
begin if X<Y then MinF:=X else MinF:=Y end;
function MaxL ( X,Y: longint ): longint;
begin if X>Y then MaxL:=X else MaxL:=Y end;
function MinL ( X,Y: longint ): longint;
begin if X<Y then MinL:=X else MinL:=Y end;

function StrLong  ( L: longint; Mist: integer ): string;
var S: string; begin str(L:Mist,S); StrLong:=S end;
function StrFloat ( X: float; Mist, Des: integer ): string;
var S: string; begin str(X:Mist:Des,S); StrFloat:=S end;

function StrEng ( X: float; Mist, Des: integer ): string;
var S,S2: string[50]; E,E2: integer;
begin
if X=0 then E:=0 else E:=trunc(Log10(abs(X)));
E2:=3*(E div 3); if E<=0 then E2:=E2-3;
if (E2=-3) and not( (E=-2) or (E=-3) )
  then StrEng:=StrFloat(X,Mist,Des)
  else begin
    X:=X/ALog10(E2);        { ?leading zeroes? }
    S:=StrFloat(X,1,Des);
    if E2<>0 then S:=S+'e'+StrLong(E2,1); S2:='';
    for E:=1 to Mist-length(S) do S2:=S2+' ';
    StrEng:=S2+S end;
end;

function Zaokrouhli ( X: float; Mist: integer ): float;
var E: integer;
begin
if Mist<=0 then Mist:=25;
if X=0 then E:=0 else E:=trunc(Log10(abs(X)));
if E <= 0 then dec(E);
X:=int(X*ALog10(-E+Mist-1));
X:=X*ALog10(E-Mist+1);
Zaokrouhli:=X
end;

function TimeToString ( Time: real ): DirStr;
  function StrLong  ( L: longint ): DirStr;
  var S: DirStr; begin str(L:2,S); StrLong:=S end;
var S: DirStr; P: integer;
begin
P:=trunc(Time/3600.0);
S:=StrLong(P); Time:=Time-3600.0*P;
S:=S+':';
P:=trunc(Time/60);
S:=S+StrLong(P); Time:=Time-60.0*P;
S:=S+':';
P:=trunc(Time);
S:=S+StrLong(P); Time:=100.0*frac(Time); { 100.0*(Time-P); }
S:=S+'.';
S:=S+StrLong(trunc(Time));
while Pos(' ',S)>0 do S[Pos(' ',S)]:='0';
TimeToString:=S
end;

procedure PrvniDvaRadky ( Name: PathStr; var Line1,Line2: string );
var Inp: text;
begin
Line1:=''; Line2:='';
assign(Inp,Name); {$I-} reset(Inp); if IOresult<>0 then exit;
readln(Inp,Line1); if IOresult=0 then readln(Inp,Line2);
close(Inp) {$I+}
end;

procedure BlokWrite ( var Out: file; var X; Size: longint );
const B = 4096;
var P: Pointer; Z: longint; Kolik: integer;
begin
P:=@X; Z:=0;
while Z < Size do
  begin
  BlockWrite(Out, P^, MinL(b,Size-Z), Kolik );
  inc(Z,Kolik);
  inc( longint(P), B );
  end;
end;

procedure BlokRead  ( var Out: file; var X; Size: longint );
const B = 4096;
var P: Pointer; Z: longint; Kolik: integer;
begin
P:=@X; Z:=0;
while Z < Size do
  begin
  BlockRead(Out, P^, MinL(B,Size-Z), Kolik );
  inc(Z,Kolik);
  inc( longint(P), B );
  end;
end;

procedure SaveArrays ( var Out: file; Hodnot: word; var PoleX, PoleY );
const Sajz = 64;  {=64 polozek typu real}
type Pole = array [1..10921] of real;
var Sect3: array [1..Sajz] of real; Index,Index3: word;
begin
Index:=1; Index3:=0;
while Index<=Hodnot do
  begin
  inc(Index3); Sect3[Index3]:=Pole(PoleX)[Index];
  inc(Index3); Sect3[Index3]:=Pole(PoleY)[Index];
  inc(Index);
  if (Index3=Sajz) or ( Index>Hodnot ) then
    begin BlockWrite(Out,Sect3,SizeOf(real)*Index3);
    Index3:=0 end;
  end;
end;


procedure LoadArrays ( var Inp: file; Hodnot: word; var PoleX, PoleY );
const Sajz = 64;  { =(3*128) div SizeOf(real); }
type Pole = array [1..10921] of real;
var Sect3: array [1..Sajz] of real; Index,Index3: integer; I: longint;
begin
Index:=1; Index3:=1;
while Index<=Hodnot do
  begin
  I:=MinL( SizeOf(Sect3), longint(2*(SizeOf(real))*(Hodnot-Index+1)) );
  BlockRead(Inp,Sect3,I,Index3);
  Index3:=Index3 div SizeOf(real);
  for I:=1 to Index3 do
    if odd(I) then Pole(PoleX)[Index]:=Sect3[I]
              else begin Pole(PoleY)[Index]:=Sect3[I];
                   inc(Index) end;
  end;
end;


function NactiDataFile ( FileName: PathStr; var AlokPole: longint; var ZpracHodnot: Word;
  var HodnotyX, HodnotyY: PPole ): boolean;
{ HodnotyX,Y se predpokladaji prazdne. Vyhodi true if nestaci pamet.
  Pokud soubor neexistuje, nic se neprovede }
var Inp: file; TInp: text; Step: real; I: Word; Name: PathStr;
begin
NactiDataFile:=false; HodnotyX:=nil; HodnotyY:=nil;
if FileName='' then exit;
assign(Inp,FileName); {$I-} reset(Inp,1); {$I+}
if IOresult<>0 then exit;

Name:=GetExtension(FileName);
if (Name='DNR') or (Name='DPR')
  then
    begin
    BlockRead(Inp,ZpracHodnot,2);
    if MemAvail < 512 + Word(12*ZpracHodnot)
      then begin NactiDataFile:=true; close(Inp); exit end;
    AlokPole:=longint(ZpracHodnot)*SizeOf(real);
    GetMem( HodnotyX, AlokPole );
    GetMem( HodnotyY, AlokPole );
    if Name='DNR'
       then LoadArrays(Inp,ZpracHodnot,HodnotyX^,HodnotyY^)
       else { 'DPR' }
         begin
         BlockRead(Inp,HodnotyX^[1],6);
         BlockRead(Inp,HodnotyX^[ZpracHodnot],6);
         BlokRead(Inp,HodnotyY^,AlokPole);
         Step:=(HodnotyX^[ZpracHodnot]-HodnotyX^[1])/(ZpracHodnot-1);
         for I:=2 to ZpracHodnot-1 do
             HodnotyX^[I]:=HodnotyX^[I-1]+Step;
         end;
     { BlokRead(Inp,HodnotyX^,AlokPole);
       BlokRead(Inp,HodnotyX^,AlokPole); }
    close(Inp);
    end {dpr,dnr}
  else {ascii data file}
    begin
    close(Inp);
    assign(TInp,FileName); {$I-} reset(TInp);
    readln(TInp); readln(TInp);
    ZpracHodnot:=0;
    while not eof(TInp) do
      begin inc(ZpracHodnot); readln(TInp) end;
    close(TInp);
    if ZpracHodnot >= 10921 then ZpracHodnot:=10920;
    {$I+}
    if ZpracHodnot = 0 then exit;
    {$I-}
    if MemAvail < 512 + Word(12*ZpracHodnot)
      then begin NactiDataFile:=true; exit end;
    AlokPole:=longint(ZpracHodnot)*SizeOf(real);
    GetMem( HodnotyX, AlokPole );
    GetMem( HodnotyY, AlokPole );
    assign(TInp,FileName); reset(TInp);
    readln(TInp); readln(TInp);
    for I:=1 to ZpracHodnot do
      readln(TInp,HodnotyX^[I],HodnotyY^[I]);
    close(TInp)
    end
end;


function StringCislo ( S: PathStr; Im: real ): real;
var Lom: boolean; X: real; P: integer;
begin
StringCislo:=Im; if S='' then exit;
Lom:=S[1]='/';
if Lom then Delete(S,1,1);
Val(S,X,P);
if P<>0 then begin Beep; exit end;
if Lom then X:=1/X;
StringCislo:=X;
end;

procedure StringDveCisla ( S: PathStr; var Yplus, Ykrat: real );
var S1: PathStr; P: integer;
begin
Yplus:=0; Ykrat:=1;
if S='' then exit;
P:=Pos(',',S);
if P=0 then S1:=S
  else begin S1:=Copy(S,1,P-1); Delete(S,1,P) end;
Yplus:=StringCislo(S1,Yplus);
if S='' then exit;
Ykrat:=StringCislo(S,Ykrat);
end;

procedure StringCtyriCisla ( var S: PathStr; var Xplus, Xkrat, Yplus, Ykrat: real );
{ v retezci S by mela byt 4 cisla oddelena carkou.
  Prvni se da do Xplus, druhe do Xkrat atd. }
var S1,S2: PathStr; P: integer;
begin
Xplus:=0; Xkrat:=1; Yplus:=0; Ykrat:=1;
if S='' then exit;

P:=Pos(',',S);
if P=0 then S1:=S
  else begin S1:=Copy(S,1,P); Delete(S,1,P) end;
P:=Pos(',',S);
if P=0 then S1:=S1+S
  else begin S1:=S1+Copy(S,1,P-1); Delete(S,1,P) end;

P:=Pos(',',S);
if P=0 then S2:=S
  else begin S2:=Copy(S,1,P); Delete(S,1,P) end;
P:=Pos(',',S);
if P=0 then S2:=S2+S
  else begin S2:=S2+Copy(S,1,P-1); Delete(S,1,P) end;

StringDveCisla(S1,Xplus,Xkrat);
StringDveCisla(S2,Yplus,Ykrat);
end;



end. { PMelFun }
