UNIT PMmouse;
{ unita na ovladani mysi z grafiky }
{ c Petr Mikulk - Brno - 1991 }

{ Problem: DtUx, UxDt neni konzistentni s obrazovkou - prepocet
  souradnice mysi na float zavisi na velikosti okna ! }
{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, crt, graph, DefFloat, Graf094, PmElFun, Fibonacci;

type

  TBiosMouse = object
    { zakladni objekt mysi vyuzivajici sluzeb Bios }
    Buttons: shortint;
    constructor Init ( var Butt: integer );
      { vrati Butt = -1 pokud mys neni instalovana }
    destructor Done;
    procedure Show;
    procedure Hide;
    procedure Where ( var X, Y: integer ); virtual;
      { X je horizontalni a Y vertikalni souradnice }
    procedure Move ( X, Y: integer );
      { posune mys na danou pozici }
    function State: byte;  { of buttons }
      { bit 0 .. leve tlacitko  1 .. prave  2 .. prostredni }
    function PocetStisku ( Button: byte; var X, Y: integer ): integer; virtual;
      { od posledniho volani teto funkce }
    procedure DefRoutine ( Maska: byte; P: Pointer );
      { Maska je aditivni. Ukonceni volani rutiny: maska = 0 }
      { !!! vzdy na konci aplikace !!! }
      { bit - akce : }
      { 0 - pohyb mysi
        1 - leve stisknuto
        2 -      uvolneno
        3 - prave stisknuto
        4 -       uvolneno
        5 - prostredni stisknuto
        6 -            uvolneno
        Rutina odzkousena, ale nefunguje. Zalezi to snad na driveru?
      }
    end;


  TKssMouse = object ( TBiosMouse )
    { hodnoty X a Y vraci v kartezske soustave - funguje pro graficky rezim }
    procedure Where ( var X, Y: integer ); virtual;
    function PocetStisku ( Button: byte; var X, Y: integer ): integer; virtual;
    end;


  TKursorMouse = object ( TKssMouse )
    function MouseDown: boolean;
    procedure SWhere ( var X, Y: float );
      { vyhodi to pro float. ale neakceptuje log. osu }
    procedure Loop;
    end;



  TTableMouse = object ( TKssMouse )
    { kresli v casti obrazovky tabulku aktualnich hodnot
      odpovidajici bodum stisku tlacitek mysi }
    Tab: array [0..2,0..2] of integer;
      { kde byly naposled zmacknute cudliky 0..2 mysi }
    constructor Init ( var Butt: integer );
    procedure DrawTable;
    function MouseDown ( P: boolean ): boolean;
      { je-li true, pak se prekresli pres XorPut tabulka }
    procedure Loop;
      { zobrazuje tabulku az do stisku klavesy }
      { kod klavesy je mozno odebrat pres ReadKey }
    end;


const
  TypTabulkyMysi: byte = 3;
    { Jak se bude zobrazovat tabulkova mys: }
    { 0 .. tabulka se zobrazovat nebude }
    { 1 .. pouze se zobrazi poloha x, y kurzoru }
    { 2 .. zobrazi se hodnoty x, y poloh stisku klaves }
    { 3 .. vcetne analyzy na Fibonacciho cisla }

const
  MouseEnableUserUnits: boolean = true;
    { je-li true, budou se zobrazovat i DtUx, DtUy souradnice }
  MouseRelativeUnits: boolean = false;
    { misto user x,y ukazuj relativni souradnice na obrazovce }

const  { polohy tabulky na obrazovce }
  MouseTabX: real = 0.55; { up to July 1994: 0.60 }
  MouseTabY: real = 0.93;


IMPLEMENTATION

  { --- TBiosMouse --- }

constructor TBiosMouse.Init;
var R: Registers;
begin
R.AX:=0; Intr($33,R);
if R.AX=0 then
  begin Butt:=-1; Buttons:=-1; Fail end;
Buttons:=R.BX; Butt:=Buttons; Show;
end;

destructor TBiosMouse.Done;
begin Hide end;

procedure TBiosMouse.Show;
var R: Registers;
begin
R.AX:=1; Intr($33,R);
end;

procedure TBiosMouse.Hide;
var R: Registers;
begin
R.AX:=2; Intr($33,R);
end;

procedure TBiosMouse.Where ( var X, Y: integer );
var R: Registers;
begin
R.AX:=3; Intr($33,R); X:=R.CX; Y:=R.DX;
end;

procedure TBiosMouse.Move ( X, Y: integer );
var R: Registers;
begin
R.AX:=4; R.CX:=X; R.DX:=Y; Intr($33,R);
end;

function TBiosMouse.State: byte;  { of buttons }
var R: Registers;
begin
R.AX:=3; Intr($33,R); State:=R.BX;
end;

function TBiosMouse.PocetStisku ( Button: byte; var X, Y: integer ): integer;
var R: Registers;
begin
R.AX:=5; R.BX:=Button; Intr($33,R);
PocetStisku:=R.BX; X:=R.CX; Y:=R.DX;
end;

procedure TBiosMouse.DefRoutine ( Maska: byte; P: Pointer );
type T = record H, L: Word end;
var R: Registers;
begin
R.CX:=Maska; R.AX:=12; 
R.ES:=T(P).H; R.DX:=T(P).L;
Intr($33,R);
end;

 { --- TKssMouse --- }

procedure TKssMouse.Where ( var X, Y: integer );
begin
TBiosMouse.Where(X,Y);
Y:=GetMaxY-Y;
end;

function TKssMouse.PocetStisku ( Button: byte; var X, Y: integer ): integer;
begin
PocetStisku:=TBiosMouse.PocetStisku(Button,X,Y);
Y:=GetMaxY-Y;
end;

  { --- TTableMouse --- }

constructor TTableMouse.Init ( var Butt: integer );
begin
TKssMouse.Init(Butt);
FillChar(Tab,SizeOf(Tab),#0);
DrawTable;
end;

procedure TTableMouse.DrawTable;
var S:string; Nej,X,Y,Pom:real; A,B,X0,Y0:integer; R:boolean;
const Nic='';

 procedure Pis ( S: string; var X,Y: real );
  var Size, FgCol, BkCol, Font: integer;
  begin
   Size:=1; if R then FgCol:= red else FgCol:=blue;
   BkCol:=black; Font:=DefaultFont; R:=false;
   PltText(S+'           ', NtUx(X), NtUy(Y), Font, Size, FgCol, BkCol);
   Y:=Y-0.03;
  end;

begin  { of DrawTable }
if (TypTabulkyMysi=0) or (TypTabulkyMysi=1) then exit;
SetWriteMode(XorPut);
X:=MouseTabX; Y:=MouseTabY; R:=true;
X0:=Tab[2,1]; Y0:=Tab[2,2];
R:=true; Pis('button        x         y ',X,Y); R:=false;
Y:=Y-0.03;
Pis('left    ' + StrLong(Tab[0,1],8) + StrLong(Tab[0,2],10),X,Y);
Pis('middle  ' + StrLong(X0,8) + StrLong(Y0,10),X,Y);
Pis('right   ' + StrLong(Tab[1,1],8) + StrLong(Tab[1,2],10),X,Y);
R:=true;
if (X0=Tab[1,1]) or (Y0=Tab[1,2])
  then Pis('l/r                                           ',X,Y)
  else Pis('l/r     ' + StrEng( (Tab[0,1]-X0)/(Tab[1,1]-X0),8,4 ) +
    StrEng( (Tab[0,2]-Y0)/(Tab[1,2]-Y0),10,4 ), X, Y);
R:=true;
if (X0=Tab[0,1]) or (Y0=Tab[0,2])
 then Pis('r/l                                                          ',X,Y)
 else Pis('r/l     ' + StrEng( (Tab[1,1]-X0)/(Tab[0,1]-X0),8,4 ) +
     StrEng( (Tab[1,2]-Y0)/(Tab[0,2]-Y0),10,4 ), X, Y);

if TypTabulkyMysi <> 3 then exit;
{ test na Fibonacciho cislo }
if X0<>Tab[1,1]
  then begin
    Pom:=(Tab[0,1]-X0)/(Tab[1,1]-X0);
    AplusBtau( Pom, A, B, Nej );
    Pis('l/r  ' + StrLong(A,1)+' + '+StrLong(B,1)+' tau | '+StrEng(Pom-Nej,1,4), X, Y);
    end
  else Pis(Nic,X,Y);
if X0<>Tab[0,1]
  then begin
    Pom:=(Tab[1,1]-X0)/(Tab[0,1]-X0);
    AplusBtau( Pom, A, B, Nej );
    Pis('r/l  ' + StrLong(A,1)+' + '+StrLong(B,1)+' tau | '+StrEng(Pom-Nej,1,4), X, Y);
    end
  else Pis(Nic,X,Y);
end;


function TTableMouse.MouseDown ( P: boolean ): boolean;
var J,X,Y: integer; B,BB: boolean;
begin
BB:=false;
for J:=0 to 2 do
  begin
  B:=TKssMouse.PocetStisku(J,X,Y)<>0;
  if B then
    begin DrawTable; Tab[J,1]:=X; Tab[J,2]:=Y end;
  BB:=BB or B;
  end;
MouseDown:=BB;
end;

procedure TTableMouse.Loop;
var X,Y,XX,YY: integer; S: string;
begin
repeat
if TypTabulkyMysi <> 0 then
  begin
   TKssMouse.Where(X,Y);
   if (XX<>X) or (YY<>Y) then
     begin
     SetWriteMode(NormalPut);
     S:='screen     x='+(StrLong(X,3)+'     y='+StrLong(Y,3));
     PltText(S,NtUx(MouseTabX),NtUy(MouseTabY+0.03), DefaultFont, 1, red, black);
     if MouseEnableUserUnits then
         if not MouseRelativeUnits then  { skutecne realne jednotky }
         begin
         S:='   x,y     '+(StrEng(DtUx(X-12),1,3)+'    '+StrEng(DtUy(GetMaxY-Y-10),1,3)+'    ');
           { zaporna cisla: DtUx, UxDt neni konzistentni s obrazovkou }
         PltText(S,NtUx(MouseTabX),NtUy(MouseTabY), DefaultFont, 1, red, black);
       end
         else begin
         S:='   rel     '+StrEng(X/graph.GetMaxX,1,3)+'    '+StrEng(Y/GetMaxY,1,3)+'    ';
         PltText(S,NtUx(MouseTabX),NtUy(MouseTabY), DefaultFont, 1, red, black);
         end;
     XX:=X; YY:=Y;
     end;
   if MouseDown(true) then DrawTable;
   end
until KeyPressed;
end;


{ --- TKursorMouse --- }

function TKursorMouse.MouseDown: boolean;
var J,X,Y: integer; B,BB: boolean;
begin
BB:=false;
for J:=0 to 2 do
  begin
  B:=TKssMouse.PocetStisku(J,X,Y)<>0;
  BB:=BB or B;
  end;
MouseDown:=BB;
end;

procedure TKursorMouse.SWhere ( var X, Y: float );
var X1,Y1: integer;
begin
TKssMouse.Where(X1,Y1);
X:=DtUx(X1-12); Y:=DtUy(GetMaxY-Y1-10);
{ zaporna cisla: DtUx, UxDt neni konzistentni s obrazovkou }
end;

procedure TKursorMouse.Loop;
var X,Y,XX,YY: integer; S: string;
begin
repeat
 TKssMouse.Where(X,Y);
 if (XX<>X) or (YY<>Y) then
   begin
   SetWriteMode(NormalPut);
   S:='x='+(StrLong(X,3)+'     y='+StrLong(Y,3));
   PltText(S,NtUx(0.72),NtUy(0.95), DefaultFont, 1, red, black);
   if MouseEnableUserUnits then
     begin
     S:=(StrEng(DtUx(X-12),1,3)+'    '+StrEng(DtUy(GetMaxY-Y-10),1,3)+'    ');
     { zaporna cisla: DtUx, UxDt neni konzistentni s obrazovkou }
     PltText(S,NtUx(0.72),NtUy(0.92), DefaultFont, 1, red, black);
     end;
   XX:=X; YY:=Y;
   end;
until MouseDown or KeyPressed;
end;


end. { PMmouse }
