UNIT TRuzne;
{ c Petr Mikulk - Brno - 1991 }
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses Objects, Drivers, Views, Dialogs, Vstupy, App1;


procedure WriteInView ( var P; X,Y: integer; AText: string; AColor: byte );
  { Procedura napise text AText do view P od pozice X,Y.
    Obchazi se tim procedura draw -> text zustane zachovan,
    nez se sam premaluje pres ReDraw }

type


  PStringView = ^ TStringView;
  TStringView = object ( TView )
    { view zobrazuje string AText v barve Color }
    SText: PString;
    Color: byte;
    constructor Init ( R: TRect; AText: string; AColor: byte );
      { pouzito jen A.X a A.Y, druhy roh pro retezec se spocte
        z jeho delky }
    destructor Done; virtual;
    procedure Draw; virtual;
    end;


  TMyRect = object ( TRect )
    procedure GrowTo ( X,Y: integer );
    procedure MoveGrowTo ( var RR: TRect; X1,Y1,X2,Y2: integer );
    end;


  PMyDialog = ^TMyDialog;
  TMyDialog = object ( TDialog )
    procedure HandleEvent ( var E: TEvent ); virtual;
    end;


  PLongIntDialog = ^ TLongIntDialog;
  TLongIntDialog = object ( TDialog )
    constructor Init ( ATitle, Popis: string; Sirka: integer; Aod, Ado: longint );
      { Sirka - sirka vnitrku zobrazeneho dialogu, nejlepe length(Popis) }
    end;

  PRealDialog = ^ TRealDialog;
  TRealDialog = object ( TDialog )
    constructor Init ( ATitle, Popis: string; Sirka: integer; Aod, Ado: real );
      { Sirka - sirka vnitrku zobrazeneho dialogu, nejlepe length(Popis) }
    end;

 PStringDialog = ^ TStringDialog;
 TStringDialog = object ( TDialog )
    constructor Init ( ATitle, Popis: string; Sirka,History: integer );
    end;

function ExecDialog ( P: PDialog; Data: Pointer): Word;


IMPLEMENTATION

{ --- TMyRect --- }

procedure TMyRect.GrowTo ( X,Y: integer );
begin
inc(B.X,X); inc(B.Y,Y);
end;

procedure TMyRect.MoveGrowTo ( var RR: TRect; X1,Y1,X2,Y2: integer );
begin
A:=RR.A; B:=RR.B; Move(X1,Y1); GrowTo(X2,Y2)
end;

{ --- TMyDialog --- }

procedure TMyDialog.HandleEvent ( var E: TEvent );
begin
TDialog.HandleEvent(E);
if (E.What=evKeyDown) then
  begin
  case E.KeyCode of
    kbUp: E.KeyCode:=kbShiftTab;
    kbDown: E.KeyCode:=kbTab;
    else exit; end;
  TDialog.HandleEvent(E)
  end;
end;

{ --- ExecDialog --- }

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    dispose(P, Done);
  end;
  ExecDialog := Result;
end;

{ --- TStringView --- }

constructor TStringView.Init ( R: TRect; AText: string; AColor: byte );
begin R.B.X:=R.A.X+length(AText); R.B.Y:=R.A.Y+1;
TView.Init(R); SText:=NewStr(AText); Color:=AColor end;

destructor TStringView.Done;
begin DisposeStr(SText); TView.Done end;

procedure TStringView.Draw;
var B: TDrawBuffer;
begin
MoveBuf(B[0],SText^[1],Color,length(SText^));
WriteLine(0,0,length(SText^),1,B[0])
end;

{ --- TLongIntDialog --- }

constructor TLongIntDialog.Init ( ATitle, Popis: string; Sirka: integer; Aod, Ado: longint );
var R: TRect;
begin
if Sirka<23 then Sirka:=23;
R.assign(0,0,Sirka+4,10);
TDialog.Init(R,ATitle);
Options:=Options or ofCentered;
R.assign(2,2,2+Sirka,3);
Insert(new(PStaticText,Init(R,Popis)));
R.assign(Sirka div 2 -5,5,Sirka div 2 +7,6);
Insert(new(PNumInputLine,Init(R,10,Aod,Ado)));
R.assign(Sirka div 2-9,7,Sirka div 2-1 ,9);
Insert(new(PButton,Init(R,'O~K~',cmOK,bfDefault)));
R.assign(Sirka div 2+1,7,Sirka div 2 +11,9);
Insert(new(PButton,Init(R,'Cancel',cmOK,bfNormal)));
SelectNext(false)
end;

{ --- TRealDialog --- }

constructor TRealDialog.Init ( ATitle, Popis: string; Sirka: integer; Aod, Ado: real );
var R: TRect;
begin
if Sirka<23 then Sirka:=23;
R.assign(0,0,Sirka+4,10);
TDialog.Init(R,ATitle);
Options:=Options or ofCentered;
R.assign(2,2,2+Sirka,3);
Insert(new(PStaticText,Init(R,Popis)));
R.assign(Sirka div 2 -5,5,Sirka div 2 +7,6);
Insert(new(PRealInputLine,Init(R,10,Aod,Ado,1,4)));
R.assign(Sirka div 2-9,7,Sirka div 2-1 ,9);
Insert(new(PButton,Init(R,'O~K~',cmOK,bfDefault)));
R.assign(Sirka div 2+1,7,Sirka div 2 +11,9);
Insert(new(PButton,Init(R,'Cancel',cmOK,bfNormal)));
SelectNext(false)
end;

{ --- TStringDialog --- }

constructor TStringDialog.Init ( ATitle, Popis: string; Sirka, History: integer );
var R: TRect; P: pointer;
begin
if Sirka<19 then Sirka:=19;
R.assign(0,0,Sirka+4,10);
TDialog.Init(R,ATitle);
Options:=Options or ofCentered;
R.assign(2,2,2+Sirka,3);
Insert(new(PStaticText,Init(R,Popis)));
R.assign(4,5,Sirka-4,6);
P:=new(PInputLine,Init(R,255)); Insert(P);
if History<>0 then
  begin R.assign(Sirka-3, 5, Sirka, 6);
  Insert(new(PHistory, Init(R, PInputLine(P), History))) end;
R.assign(Sirka div 2-9,7,Sirka div 2-1 ,9);
Insert(new(PButton,Init(R,'O~K~',cmOK,bfDefault)));
R.assign(Sirka div 2+1,7,Sirka div 2 +11,9);
Insert(new(PButton,Init(R,'Cancel',cmOK,bfNormal)));
SelectNext(false)
end;

{ --- WriteInView --- }

procedure WriteInView ( var P; X,Y: integer; AText: string; AColor: byte );
var B: TDrawBuffer;
begin
if longint(P)=0 {cili nil} then exit;
MoveStr( B, AText, AColor );
PView(P)^.WriteLine( X, Y, length(AText), 1, B )
end;


end. { TRuzne }
