UNIT TVFibDat;
{ operace s daty: import a export }
{ c Petr Mikulk - Brno - 1992 }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, crt,
     Objects, Drivers, Memory, Views, Dialogs,
     ZprBox, NormDlg, App1, TRuzne,
     DefFloat, ElFun, PmElFun,
     TVFibDef, TVFibIni;

type

  TLastApp = object ( TFibIniApp ) end;

  TFibDatApp = object ( TLastApp )
    procedure UlozDataJmeno ( Name: PathStr );
    procedure UlozData;
    procedure UlozDataDNR;
    procedure ExportASCII;
    procedure VytahniData;
    end;

const
  Data2line1: PathStr = '';
  Data2line2: PathStr = '';


IMPLEMENTATION


{ --- TFibDatApp --- }

procedure TFibDatApp.UlozDataJmeno ( Name: PathStr );
var Out: file;
begin
assign(Out,Name); rewrite(Out,1);
BlockWrite(Out,ZpracHodnot,2);
{ BlokWrite(Out,HodnotyEtha^,ZpracHodnot*SizeOf(real));
  BlokWrite(Out,HodnotyIntenzity^,ZpracHodnot*SizeOf(real)); }
{ SaveArrays(Out,ZpracHodnot,HodnotyEtha^,HodnotyIntenzity^); }
BlockWrite(Out,HodnotyEtha^[1],6);
BlockWrite(Out,HodnotyEtha^[ZpracHodnot],6);
BlokWrite(Out,HodnotyIntenzity^,ZpracHodnot*SizeOf(real));
close(Out);
end;


procedure TFibDatApp.UlozData;
var FileName: PathStr;
begin
FileName:='*.dpr';
if ExecDialog(new(PFileDialog,Init('*.dpr','Save data DPR','~N~ame',fdOkButton,100)),@FileName) = cmCancel
   then exit;
UlozDataJmeno( FileName )
end;

procedure TFibDatApp.UlozDataDNR;
var FileName: PathStr; Out: file;
begin
FileName:='*.dnr';
if ExecDialog(new(PFileDialog,Init('*.dnr','Save data DNR','~N~ame',fdOkButton,100)),@FileName) = cmCancel
   then exit;
assign(Out,FileName); rewrite(Out,1);
BlockWrite(Out,ZpracHodnot,SizeOf(ZpracHodnot));
SaveArrays(Out,ZpracHodnot,HodnotyEtha^,HodnotyIntenzity^);
close(Out)
end;

procedure TFibDatApp.ExportASCII;
var FileName: PathStr; Out: text; K: word; N,AX,AY: longint; X,Y: real;
begin
FileName:='*.dat';
AX:=1; AY:=-14;
if ExecDialog(new(PFileDialog,Init('*.dat','Save data ASCII','~N~ame',fdOkButton,100)),@FileName) = cmCancel
   then exit;
N:=1;
if ExecDialog(new(PLongIntDialog,Init('','Write only 1/number of data',21,1,MaxLongInt)),@N)=cmCancel then exit;
if ExecDialog(new(PLongIntDialog,Init('Output places for x','>= 0  decimal  < 0  total',27,-256,256)),@AX)=cmCancel
  then exit;
if ExecDialog(new(PLongIntDialog,Init('Output places for y','>= 0  decimal  < 0  total',28,-256,256)),@AY)=cmCancel
  then exit;
assign(Out,FileName); rewrite(Out);
(****  writeln(Out,DialogRec.Pozn); writeln(Out);   *****)
if ZpravaBox('','Write remark to first two lines?',nil,mfYesButton+mfNoButton) <> cmNo then
  begin writeln(Out,Data2line1); writeln(Out,Data2line2) end;
for K:=1 to ZpracHodnot-1 do
  if (N=1) or (K mod N = 1) then
    begin
    X:=3600*RadToDeg(HodnotyEtha^[K]); Y:=HodnotyIntenzity^[K];
    if AX >= 0 then write( Out, X:1:AX, ' ')
               else write( Out, X:-AX, ' ');
    if AY >= 0 then writeln( Out, Y:1:AY, ' ')
               else writeln( Out, Y:-AY, ' ');
    end;
close(Out)
end;


procedure TFibDatApp.VytahniData;
var Inp: file; FileName: PathStr; Pom: integer;
    LPom: longint; Ext: ExtStr;
    S1,S2: PathStr;
begin
FileName:='*.*';
if ExecDialog(new(PFileDialog,Init('*.d*','Load data','~N~ame',fdOpenButton,100)),@FileName) = cmCancel then exit;
if not FileExist(FileName) then exit;
FreeMemBump;
if HodnotyEtha<>nil then
  begin FreeMem(HodnotyEtha,AlokPole); HodnotyEtha:=nil end;
if HodnotyIntenzity<>nil then
  begin FreeMem(HodnotyIntenzity,AlokPole); HodnotyIntenzity:=nil end;
{ !!! if ZpravaBox('','Write remark to first two lines?',nil,mfYesButton+mfNoButton) <> cmNo then
      begin writeln(Out,Data2lines1); writeln(Out,Data2lines2); }
if NactiDataFile ( FileName,AlokPole,ZpracHodnot, HodnotyEtha,HodnotyIntenzity) then
{ begin ZpravaBox('','Nepostacuje pamet na vstup tolika dat',nil,mfError+mfOkButton); }
  begin ZpravaBox('','Not enough memory for these data',nil,mfError+mfOkButton);
  GetMemBump; exit end;
assign(Inp,FileName); reset(Inp,1);
Ext:=GetExtension(FileName);
if (Ext='DPR') or (Ext='DNR')
  then
    begin
    if Ext='DNR' then Seek(Inp,2+ZpracHodnot*12)
       else Seek(Inp, 14+ZpracHodnot*6);
(***    BlockRead(Inp,DialogRec,SizeOf(DialogRec),Pom);
    { nacteni aspon poznamky if record nebyl konzistentni }
    Seek(Inp,FileSize(Inp)-80);
    BlockRead(Inp,DialogRec.Pozn,SizeOf(DialogRec.Pozn));
****)
    close(Inp);
(****
    with DialogRec do if length(Pozn)>79 then Pozn[0]:=#79; { ochrana }
    MainDialogP^.SetData(DialogRec)
****)
    end
  else { ascii data file }
    begin
    for Pom:=1 to  ZpracHodnot do
      HodnotyEtha^[Pom]:=VtToRad(HodnotyEtha^[Pom]);
    PrvniDvaRadky(FileName,Data2line1,Data2line2);
(******
    with DialogRec do begin
      DialogRec.Pozn:=S1+S2;
      if length(Pozn)>79 then Pozn[0]:=#79; { ochrana }
      end;
    MainDialogP^.SetData(DialogRec);
******)
    end;
GetMemBump;
EnableCommands(DataMemoryCommands)
end;


end. { TVFibDat}
