UNIT TVFibDef;
{ definice k TVFIB }
{ c Petr Mikulk - Brno - 1992 }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, DefFloat, PmElFun, App1;


const ZpracHodnot: word    = 0;
      AlokPole: longint    = 0;  { kolik bytu alok. pro HodnotyIntenzity }
      VypisujPo            = 20; { zobrazovani pocitanych dat }
      EpsonMode: longint   = 4;
      MaxGrFiles           = 6;  { max. pocet vstupnich souboru pro graph dialog }
      GrafDialogEnable: boolean = true;  { if graphic dialog }
      YesSaveBeforeDOS: boolean = true;
      GrErrorSkip: longint = 1;
        { true skips error, false stops drawing }
      UseSVGA: longint      = 0;
      MyScreenMode: word    = 25;

var DeleniKrivky: longint;
    HodnotyEtha, HodnotyIntenzity: PPole;
    MaxV, MinV: word;

type

  TDialogGrafRec = record
    KresliXOd, KresliXDo, StepX: real;
    Xzadanov: word;
    XLinLog: word;
    DataNaX: word;
    KresliYOd, KresliYDo, StepY: real;
    YLinLog: word;
    GridStr: string[2];
{   DrawRmax: word;  }
    AngleLabel, IntensLabel: PathStr;
    GrFile: array [1 .. MaxGrFiles ] of PathStr;
    GrafOpts: word;
    GrFileMove: array [1 .. MaxGrFiles ] of PathStr;
    MouseInGraf: word;
    FilyPos: PathStr;
    Nadpis, NadpisPos: PathStr;
    GrafPozn, GrafPoznPos: PathStr;
    end;

const

  DialogGrafRec: TDialogGrafRec = (
    KresliXOd: 0; KresliXDo: 360; StepX: 0;
    Xzadanov: 0; XLinLog: 0; DataNaX: 0;
    KresliYOd: -1;  KresliYDo: 1; StepY: 0;
    YLinLog: 0; GridStr: '00';  { DrawRmax: 0; }
    AngleLabel: 'angle'; IntensLabel: 'intensity';
    GrFile: (':sin(x*deg2rad)','','','','','');
    GrafOpts: 4;
    GrFileMove: ('','','','','','');
    MouseInGraf: 1;
    FilyPos: '.12,.84';
    Nadpis: '' { Diffraction on Superlattice};
    NadpisPos: '.08,.91';
    GrafPozn: ''; GrafPoznPos: '0,.018' );

const cmNormalizuj = 210; cmFreeData = 211;
      cmExportDNR = 212; cmExportASCII = 213;
      cmUloz = 214; cmVynasobx = 215; cmVynasoby = 216;

      DataMemoryCommands =
        [cmExportAscii,cmUloz,cmExportDNR,cmFreeData,cmNormalizuj,
         cmVynasobx,cmVynasoby];

const cmHelp = 1001; cmGraf = 1002;    cmPocitej = 1003;
      cmVytahni = 1005;
      cmDOS = 1006;
      cmKalk = 1007;
      cmEpsonMode = 1011;
      cmHalt = 1017;
      cmNevypinat = 1018;
{      cmShowFile = 1021; }
      cmSwitchOffMin = 1023; cmPrintPCL = 1024;
      cmTextCapture = 1026;
      cmSaveGraphDesk = 1027; cmLoadGraphDesk = 1028;
      cmGraphAutoscale = 1029; cmDOScommand = 1030;
      cmKonec = 1032;
      cmData2lines = 1033;
      cmSaveAll = 1034;
      cmSaveBeforeDOS = 1035;
      cmShowUserScreen = 1036;
      cmIntegration = 1037;
      cmGrErrorSkip = 1038;
      cmGnuplot = 1039;
      cmDos1Graf = 1040; cmDos2Graf = 1041; cmDos3Graf = 1042;
      cmGraphMode = 1043;

      { hcXYZ = 1000;    hcDelBodu = 1002; }
      { hcSirka1 = 1003; hcSvypoct = 1004; }
      hcPosuny = 1005;
      { hcRtgZna = 1006; hcZnamSL = 1007; hcLambda = 1008; }
      { hcRML = 1009; hcRmpC = 1010; }
      { hcSP = 1011; { ted 2 vynechat ! }
      { hcFitGlob = 1014; hcFitVrstva = 1015; }
      { hcRmax = 1016; hcConvZna = 1017; }
      hcGrafSelected = 13333;
      hcGrfFileName  = 13335;
      hcReadToMemory = 13336;
      hcDosGraf12    = 13337;
      hcDosGraf3     = 13338;

      ColorStringView = $79;




const { editor }
  cmOpen       = 27100;
  cmNew        = 27101;
  cmChangeDir  = 27102;
  cmDosShell   = 27103;
  cmCalculator = 27104;
  cmShowClip   = 27105;
  cmHelp2      = 27106;
  cmDosCmd     = 27107;
  cmOpenTeX    = 10066;
  cmDos1       = 27108;
  cmDos2       = 27109;
  cmDos3       = 27110;
  cmDosSet     = 27111;
  cmOpenFor    = 27112;
  cmLatexKbd   = 27113;
  cmKbAlt9     = 27114;
  cmTabSpaces  = 27115;
  cmScreenMode = 27116;

  hlDOS = 50; hlTeX = 51;

procedure FreeData;
procedure AlokData ( Polozek: integer );
procedure NajdiMaximum;
procedure NajdiMinimum;
procedure Normalizuj;

const

  TeXkbdOn: boolean = false;

{ for DosCommands }

type Byte13 = array[1..3] of byte;
     PathStr13 = array[1..3] of PathStr;
const DosCommandI: PathStr13 = ('bat.bat','for sxr >for.lst','mem');
      DosLoadI: PathStr13 = ('NONE','for.lst','NONE');
      DosLoadNum: Byte13 = (1,2,5);


type TBump = array[1..65535] of char;
var Bump,SmallBump: ^ TBump;
var SizeBump,SizeSmallBump: word; { = 65535; }

procedure FreeMemBump;
procedure GetMemBump;


IMPLEMENTATION


procedure FreeData;
begin
if HodnotyEtha<>nil then
  begin FreeMem(HodnotyEtha,AlokPole); HodnotyEtha:=nil end;
if HodnotyIntenzity<>nil then
  begin FreeMem(HodnotyIntenzity,AlokPole); HodnotyIntenzity:=nil end;
AlokPole:=0; ZpracHodnot:=0;
Application^.DisableCommands(DataMemoryCommands);
GetMemBump;
end;

procedure AlokData ( Polozek: integer );
begin
FreeData;
ZpracHodnot:=Polozek;
AlokPole:=Polozek*SizeOf(real);
GetMem(HodnotyEtha,AlokPole);
GetMem(HodnotyIntenzity,AlokPole);
end;

procedure NajdiMaximum; var I: integer;
begin MaxV:=1; for I:=2 to ZpracHodnot do
if HodnotyIntenzity^[MaxV] < HodnotyIntenzity^[I] then MaxV:=I
end;

procedure NajdiMinimum; var I: integer;
begin MinV:=1; for I:=2 to ZpracHodnot do
if HodnotyIntenzity^[MinV] > HodnotyIntenzity^[I] then MinV:=I
end;

procedure Normalizuj; var I: integer; F: float;
begin F:=HodnotyIntenzity^[MaxV]; for I:=1 to ZpracHodnot do
HodnotyIntenzity^[I]:=HodnotyIntenzity^[I]/F end;

(* procedure VypisHodnoty; var I: integer; Vt,Min,St: float;
begin for I:=1 to ZpracHodnot do begin
UnpackDeg(RadToDeg(HodnotyEtha[I]),St,Min,Vt);
write('Etha=',St:1:2,'~ ',Min:1:2,''' ',Vt:5:5,'"',' Abs=',HodnotyIntenzity[I]:1:3);
end; end; *)

procedure FreeMemBump;
begin
if Bump<>nil then
  FreeMem(Bump,SizeBump);
if SmallBump<>nil then
  FreeMem(SmallBump,SizeSmallBump);
Bump:=nil; SmallBump:=nil;
end;

procedure GetMemBump;
begin
SizeBump:=65535;
if MaxAvail>SizeBump+1000.0 then GetMem(Bump,SizeBump)
  else begin
    SizeBump:=20000;
    if MaxAvail>SizeBump+1000.0 then GetMem(Bump,SizeBump)
     else begin
       SizeBump:=2000;
       if MaxAvail>SizeBump+1000.0 then GetMem(Bump,SizeBump)
         else Bump:=nil
       end
    end;
SizeSmallBump:=65535;
if MaxAvail>SizeSmallBump+1000.0 then GetMem(SmallBump,SizeSmallBump)
  else begin
    SizeSmallBump:=20000;
    if MaxAvail>SizeSmallBump+1000.0 then GetMem(SmallBump,SizeSmallBump)
     else begin
       SizeSmallBump:=2000;
       if MaxAvail>SizeSmallBump+1000.0 then GetMem(SmallBump,SizeSmallBump)
         else SmallBump:=nil
       end
    end;
end;

begin
HodnotyEtha:=nil; HodnotyIntenzity:=nil;
GetMemBump;

end. { TVFibDef }
