UNIT TVFibEd;
{ c Petr Mikulk - Brno - 1992/93 }

{$R-,D-,L-,X+,S-,F+,N-,E-,O+}
{  $R+,D+,L+,X+,S-,F+,N-,E-,O+}

INTERFACE

uses dos, crt, Objects, Drivers, Memory, Views, Menus, Dialogs,
     NormDlg, ZprBox, TRuzne, TUnita, App1, Buffers, Kalk, Editor,
     TVFibDef, TVFibHew;

const
  HeapSize = 32 * (1024 div 16);
  cr       = #$D;
  crlf     = #$D#$A;

type

{  TLastApp   = TTimeApp; }
  TLastApp   = TFibHewApp;

  PEditorApp = ^ TEditorApp;
  TEditorApp = object( TLastApp )
    constructor Init;
    destructor Done; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Tiles;
    function OpenEditor(FileName: FNameStr; Visible: boolean): PEditWindow;
      virtual;
  end;

{
function OpenEditor(FileName: FNameStr; Visible: boolean): PEditWindow;
}

IMPLEMENTATION


var ClipWindow: PEditWindow;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    dispose(P, Done);
  end;
  ExecDialog := Result;
end;

function CreateFindDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.assign(0, 0, 38, 12);
  D := new(PDialog, Init(R, 'Find'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.assign(3, 3, 32, 4);
    Control := new(PInputLine, Init(R, 80));
    Insert(Control);
    R.assign(2, 2, 15, 3);
    Insert(new(PLabel, Init(R, '~T~ext to find', Control)));
    R.assign(32, 3, 35, 4);
    Insert(new(PHistory, Init(R, PInputLine(Control), 10)));

    R.assign(3, 5, 35, 7);
    Insert(new(PCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only', nil)))));

    R.assign(14, 9, 24, 11);
    Insert(new(PButton, Init(R, 'O~K~', cmOK, bfDefault)));
    inc(R.A.X, 12); inc(R.B.X, 12);
    Insert(new(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(false);
  end;
  CreateFindDialog := D;
end;

function CreateReplaceDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.assign(0, 0, 40, 16);
  D := new(PDialog, Init(R, 'Replace'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.assign(3, 3, 34, 4);
    Control := new(PInputLine, Init(R, 80));
    Insert(Control);
    R.assign(2, 2, 15, 3);
    Insert(new(PLabel, Init(R, '~T~ext to find', Control)));
    R.assign(34, 3, 37, 4);
    Insert(new(PHistory, Init(R, PInputLine(Control), 10)));

    R.assign(3, 6, 34, 7);
    Control := new(PInputLine, Init(R, 80));
    Insert(Control);
    R.assign(2, 5, 12, 6);
    Insert(new(PLabel, Init(R, '~N~ew text', Control)));
    R.assign(34, 6, 37, 7);
    Insert(new(PHistory, Init(R, PInputLine(Control), 11)));

    R.assign(3, 8, 37, 12);
    Insert(new(PCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only',
      NewSItem('~P~rompt on replace',
      NewSItem('~R~eplace all', nil)))))));

    R.assign(17, 13, 27, 15);
    Insert(new(PButton, Init(R, 'O~K~', cmOK, bfDefault)));
    R.assign(28, 13, 38, 15);
    Insert(new(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(false);
  end;
  CreateReplaceDialog := D;
end;

function DoEditDialog(Dialog: integer; Info: Pointer): Word;
var
  R: TRect;
  T: TPoint;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog := ZpravaBox('','Not enough sufficient memory.',
        nil, mfError + mfOkButton);
    edReadError:
      DoEditDialog := ZpravaBox('','Error reading file %s.',
        @Info, mfError + mfOkButton);
    edWriteError:
      DoEditDialog := ZpravaBox('','Error writing file %s.',
        @Info, mfError + mfOkButton);
    edCreateError:
      DoEditDialog := ZpravaBox('','Error creating file %s.',
        @Info, mfError + mfOkButton);
    edSaveModify:
      DoEditDialog := ZpravaBox('','%s has changed. Save?',
        @Info, mfInformation + mfYesNoCancel);
    edSaveUntitled:
      DoEditDialog := ZpravaBox('','Save untitled file?',
        nil, mfInformation + mfYesNoCancel);
    edSaveAs:
      DoEditDialog := ExecDialog(new(PFileDialog, Init('*.*',
        'Save file as', '~N~ame', fdOkButton, 101)), Info);
    edFind:
      DoEditDialog := ExecDialog(CreateFindDialog, Info);
    edSearchFailed:
      DoEditDialog := ZpravaBox('','String not found.',
        nil, mfError + mfOkButton);
    edReplace:
      DoEditDialog := ExecDialog(CreateReplaceDialog, Info);
    edReplacePrompt:
      begin
        { Avoid placing the dialog on the same line as the cursor }
        R.assign(0, 1, 40, 8);
        R.Move((DeskTop^.Size.X - R.B.X) div 2, 0);
        DeskTop^.MakeGlobal(R.B, T);
        inc(T.Y);
        if TPoint(Info).Y <= T.Y then
          R.Move(0, DeskTop^.Size.Y - R.B.Y - 2);
        DoEditDialog := ZpravaBoxRect(R, '','Replace this occurence?',
          nil, mfYesNoCancel + mfInformation);
      end;
  end;
end;

function UpString(S:string):string; var K:integer;
begin for K:=1 to length(S) do S[K]:=UpCase(S[K]);
UpString:=S end;

function TEditorApp.OpenEditor(FileName: FNameStr; Visible: boolean): PEditWindow;
var P: PWindow; R: TRect; I,pom: integer;
begin
  I:=0;
  repeat inc(I);
  P:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(I))
  until P=nil;
  if not Visible then I:=0;
  DeskTop^.GetExtent(R);
  pom:=I-1; if pom<0 then pom:=0 else if pom>15 then pom:=16;
  inc(R.A.Y,pom);
  { if UpString(Copy(FileName,length(FileName)-2,3))='TEX' then R.B.X:=66; }
  PView(P) := Application^.ValidView(new(PEditWindow,
    Init(R, FileName, I { WinNumber wnNoNumber} )));
  if not Visible then P^.Hide;
  DeskTop^.Insert(P);
  OpenEditor := PEditWindow(P);
  { P^.Zoom; }
end;



constructor TEditorApp.Init;
var
  H: Word;
  R: TRect;
begin
  H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
  if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
  InitBuffers;
  TLastApp.Init;
  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]);
  EditorDialog := DoEditDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
  R.Assign(58,0,0,0);
  Insert(new(PStringView,Init( R,'PM graph&editor',red )))
end;

destructor TEditorApp.Done;
begin
  TLastApp.Done;
  DoneBuffers;
end;

procedure TEditorApp.Tiles;
var R: TRect;
begin
Desktop^.GetExtent(R); Desktop^.Tile(R);
end;


procedure TEditorApp.HandleEvent(var Event: TEvent);

procedure FileOpen;
var
  FileName: FNameStr; B: boolean;
begin
  FileName := '*.*';
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
  B:=ExecDialog(New(PFileDialog, Init('*.*', 'Open file',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel;
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
  if B then OpenEditor(FileName, True);
end;

procedure TeXOpen;
var FileName: FNameStr; B: boolean;
begin
FileName := '*.tex';
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
B:=ExecDialog(New(PFileDialog, Init('*.tex', 'Open file',
  '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel;
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
if B then OpenEditor(FileName, True);
end;
procedure ForOpen;
var ForName: FNameStr; B: boolean;
begin
ForName := '*.for';
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
B:=ExecDialog(New(PFileDialog, Init('*.for', 'Open file',
  '~N~ame', fdOpenButton, 100)), @ForName) <> cmCancel;
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
if B then OpenEditor(ForName, True);
end;

procedure FileNew;
begin
  OpenEditor('', True);
end;

procedure ChangeDir;
begin
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
  ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
end;


procedure RunDosI (I: integer);
var W: PWindow; E: boolean; R: TRect;
begin
DosCommand(DosCommandI[I], '', true );
if ((length(DosLoadI[I])>3) and (UpString( Copy(DosLoadI[I],Length(DosLoadI[I])-3,4) )='NONE'))
   or ((length(DosLoadI[I])>4) and (UpString( Copy(DosLoadI[I],Length(DosLoadI[I])-4,5) )='NONE.'))
   or (DosLoadI[I]='') then exit;
E:=false;
if DosLoadNum[I]>0
   then begin
   W:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(DosLoadNum[I]));
   E:=W<>nil;
   if E then
     begin
     { W^. Select; }
     R.A:=W^.Origin; R.B.X:=R.A.X+W^.Size.X; R.B.Y:=R.A.Y+W^.Size.Y;
     W^.Close;
     end;
   end;
if (not E) or (DosLoadNum[I]<1) then begin DeskTop^.GetExtent(R);
   if DosLoadNum[I]>0 then inc(R.A.Y,DosLoadNum[I]-1) end;
PView(W) := Application^.ValidView(new(PEditWindow,
  Init(R, DosLoadI[I], DosLoadNum[I] )));
DeskTop^.Insert(W);
end;

procedure DosSet;
var XDosCommandI, XDosLoadI: PathStr13;
    XDosLoadNum: Byte13;
    I: integer; J: longint; Pom2,Pom3: PathStr;
begin
J:=1; XDosCommandI:=DosCommandI; XDosLoadI:=DosLoadI; XDosLoadNum:=DosLoadNum;
if ExecDialog(new(PLongIntDialog,Init(' Set DOS commands','Dos Command Number (1..3)',22,0,3)),@J)
  = cmCancel then begin DosCommandI:=XDosCommandI; DosLoadI:=XDosLoadI; DosLoadNum:=XDosLoadNum;
                  exit end;
I:=J; DosCommandI:=XDosCommandI; DosLoadI:=XDosLoadI; DosLoadNum:=XDosLoadNum;
ExecDialog(new(PStringDialog,Init('Set DOS commands','Command:',42,hlDOS)),@DosCommandI[I]);
XDosCommandI[I]:=DosCommandI[I]; J:=XDosLoadNum[I];
ExecDialog(new(PLongIntDialog,Init('Set DOS commands','Re-open file in window',24,0,255)),@J);
XDosLoadNum[I]:=J; DosLoadI[I]:=XDosLoadI[I];
ExecDialog(New(PFileDialog, Init('*.*', 'Re-open file in window nb. '+chr(DosLoadNum[I]+ord('0')),
  '~N~ame', fdOpenButton, 102)), @DosLoadI[I]);
XDosLoadI[I]:=DosLoadI[I];
DosCommandI:=XDosCommandI; DosLoadI:=XDosLoadI; DosLoadNum:=XDosLoadNum;
end;

procedure ShowClip;
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure Calculator;
begin
  DeskTop^.Insert(ValidView(New(PCalculatorWAE, Init(Random(59),Random(10)))))
end;

procedure HandleString ( S: string );
var E: TEvent; K: integer;
begin
for K:=1 to length(S) do with E do begin
  What:=evKeyDown; ScanCode:=0; CharCode:=S[K];
  Application^.HandleEvent(E) end
end;

procedure TexControl ( S1,S2: NameStr; Popis: PathStr );
const S: string = '';
begin
if ExecDialog(new(PStringDialog,Init('TeX',Popis,60,hlTeX)),@S) = cmCancel then exit;
HandleString( S1+S+S2 )
end;

procedure TexControl1 ( S1,S2: NameStr );
var C: char;
begin
repeat until KeyPressed; C:=ReadKey;
if ord(C) > 32 then HandleString( S1+C+S2 )
end;

procedure SizeEnviron;
const Sirka = 24; Delka = 17; Sajz: word = 4; Num = 9;
S: array[0..Num] of string[14]=('~t~iny','s~c~riptsize','~f~ootnotesize','~s~mall','~n~ormalsize',
     'large','~L~arge','LARGE','~h~uge','Huge');
var D: PDialog; R: TRect; SS: string[14];
begin
R.assign(0,0,Sirka,Delka);
D:=new( PDialog, Init(R,'Size') );
with D^ do begin
  Options:=Options or ofCentered; R.Assign(3,2,Sirka-3,Num+4);
  Insert(new(PRadioButtons,Init(R,NewSItem(S[0],NewSItem(S[1],NewSItem(S[2],NewSItem(S[3],NewSItem(S[4],NewSItem(S[5],
    NewSItem(S[6],NewSItem(S[7],NewSItem(S[8],NewSItem(S[9],nil)))))))))))));
  R.assign(Sirka div 2-10,Delka-3,Sirka div 2-2 ,Delka-1);
  Insert(new(PButton,Init(R,'O~K~',cmOK,bfDefault)));
  R.assign(Sirka div 2,Delka-3,Sirka div 2 +10,Delka-1);
  Insert(new(PButton,Init(R,'Cancel',cmOK,bfNormal)));
  SelectNext(false) end;
if ExecDialog(D,@Sajz) <> cmCancel then
  begin
  SS:=S[Sajz]; while Pos('~',SS)<>0 do system.Delete(SS,Pos('~',SS),1);
  HandleString('{\'+SS)
  end
end;

procedure BeginEnviron;
const Sirka = 26; Delka = 21; Num = 16;
S: array[0..Num] of string[13]=('flush~l~eft','~c~enter','flush~r~ight',
     'eqnarray','~e~quation',
     'array','~t~abular','table','tabbing','e~n~umerate','~i~temize','~d~escription',
     'displaymath','~p~icture','~f~igure','~v~erbatim','document');
var D: PDialog; R: TRect; SS: string[13]; Sajz: word; E: TEvent;
begin
R.assign(0,1,Sirka,Delka+1); Sajz:=4;
D:=new( PDialog, Init(R,' \begin  +  \end ') );
with D^ do begin
  Options:=Options or ofCentered; R.Assign(4,2,Sirka-4,Num+1);
  Insert(new(PRadioButtons,Init(R,NewSItem(S[0],NewSItem(S[1],NewSItem(S[2],NewSItem(S[3],NewSItem(S[4],NewSItem(S[5],
    NewSItem(S[6],NewSItem(S[7],NewSItem(S[8],NewSItem(S[9],
    NewSItem(S[10],NewSItem(S[11],NewSItem(S[12],NewSItem(S[13],
    NewSItem(S[14],NewSItem(S[15],NewSItem(S[16],
    nil))))))))))))))))))));
  R.assign(Sirka div 2-10,Delka-3,Sirka div 2-2 ,Delka-1);
  Insert(new(PButton,Init(R,'O~K~',cmOK,bfDefault)));
  R.assign(Sirka div 2,Delka-3,Sirka div 2 +10,Delka-1);
  Insert(new(PButton,Init(R,'Cancel',cmOK,bfNormal)));
  SelectNext(false) end;
if ExecDialog(D,@Sajz) <> cmCancel then
  begin
  SS:=S[Sajz]; while Pos('~',SS)<>0 do system.Delete(SS,Pos('~',SS),1);
  HandleString('\begin{' +SS+ '}'+CR+CR+'\end{' +SS+ '}'+CR)
  end;
for Sajz:=1 to 2 do
  with E do begin What:=evKeyDown; KeyCode:=kbUp;
    Application^.HandleEvent(E) end;
end;


procedure GreekMode;
const GreekABC: array['A'..'Z'] of string[7] =
('alpha','beta','chi','delta','epsilon','phi','gamma','eta','iota','psi','kappa','lambda','mu','nu','omega',
'pi','theta','rho','sigma','tau','upsilon','','','ksi','upsilon','zeta');
var C: char; S: string[7];
begin
repeat until KeyPressed; C:=ReadKey;
if not( UpCase(C) in ['A'..'Z'] ) then exit;
S:=GreekABC[UpCase(C)];
if C <= 'Z' then S[1]:=UpCase(S[1]);
HandleString('\'+S)
end;


label 1;
begin  { - HandleEvent - }
if TeXkbdOn then
  if Event.What = evKeyDown then
  begin
  case Event.KeyCode of
    kbAltA: TexControl1('{\bf ','}');
    kbAltB: TexControl('{\bf ','}','bold face');
    kbAltC: TexControl('{\sc ','}','small caps');
    kbAltE: TexControl('^{','}','upperscript');
    kbAltG: GreekMode;
    kbAltI: TexControl('{\it ','}','italic');
    kbAltJ: TexControl('{\cal ','}','caligraphic');
    kbAltK: HandleString('_{\perp}');
    kbAltL: TexControl('{\sl ','}','slanted');
    kbAltP: HandleString('_{\parallel}');
    kbAltR: TexControl('{\rm ','}','roman');
    kbAltS: TexControl('{\sf ','}','sans serif');
    kbAltT: TexControl('{\tt ','}','typewriter');
    kbAltV: HandleString('\vec ');
    kbAltW: SizeEnviron;
    kbAltX: TexControl('_{','}','subscript');
    kbAltZ: BeginEnviron;
     else goto 1;
  end;
  ClearEvent(Event); exit
  end;
1:
  TLastApp.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen;
        cmOpenTeX: TeXOpen;
        cmOpenFor: ForOpen;
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmDosShell: DosShell;
        cmDosCmd: DosCommandX;
        cmCalculator: Calculator;
        cmShowClip: ShowClip;
        cmTile: Tiles;
        cmCascade: Cascade;
        cmHelp2: Help2;
        cmDos1: RunDosI(1);
        cmDos2: RunDosI(2);
        cmDos3: RunDosI(3);
        cmDosSet: DosSet;
        cmkbAlt9: GrafDialogP^.Select;
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;


end.
