UNIT TVFibGra;
{ c Petr Mikulk - Brno - 1992/94 }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses TVFibDef;
{$IFDEF TVFIB}
const GrErrorSkip {: longint} = 1;
        { true skips error, false stops drawing }
{$ENDIF}
{ for PMGRAF, it is defined in TVFibDef }

const MaxTheLine = 99;

var MaxColumn: integer;
    TheLine: array [0..MaxTheLine] of real;
    notFormula: boolean;
    FormulaX, FormulaY, FormulaZ: ^string;

function ReadFormTheLine ( var Inp: text ): byte;

procedure DoDraw3DFormulae
  ( var Posuny: string; var Draw3D: boolean );


type TFromFormula = record
       FromX, ToX, StepX, FromY, ToY, StepY: real;
       IX,IY,MaxX,MaxY: integer;
       Draw3D: boolean;
       end;

var FromFormula: ^ TFromFormula;

const isFromFile = 1; isFromFormula = 2;
var isFromWhich: byte;

procedure DoFromFormula
  ( var Name: string; Xodod,Xdodo, Yodod,Ydodo: real; DrawIt3D: boolean;
    aMaxX, aMaxY: integer );


IMPLEMENTATION

uses pmelfun, pmparser;

function ReadFormTheLine ( var Inp: text ): byte;
var K: integer; FormX,FormY: real; label LabelFormula;
begin
{$I-}
ReadFormTheLine:=0;
if isFromWhich=isFromFormula then goto LabelFormula;
for K:=1 to MaxColumn do
  begin read(Inp,TheLine[K]);
  if IOresult<>0 then if boolean(GrErrorSkip)
    then begin readln(Inp); ReadFormTheLine:=1; exit;
         { goto ReadNextLine } end
    else begin ReadFormTheLine:=2; exit end; { goto Konec; }
  if (K<MaxColumn) then
    if eoln(Inp)
      then begin ReadFormTheLine:=1; exit
           { goto ReadNextLine } end
      else if eof(Inp) then begin ReadFormTheLine:=2; exit end; { goto Konec; }
  end;
{$I+}
if notFormula then exit;
{ recalculate TheLine[1],[2],[3] according to the formula }
if FormulaX<>nil then FormX:=FormulaParserDollars(FormulaX^,TheLine);
if FormulaY<>nil then FormY:=FormulaParserDollars(FormulaY^,TheLine);
if FormulaZ<>nil then TheLine[3]:=FormulaParserDollars(FormulaZ^,TheLine);
if FormulaX<>nil then TheLine[1]:=FormX;
if FormulaY<>nil then TheLine[2]:=FormY;
exit;

LabelFormula:
with FromFormula^ do
  begin
  if Draw3D
    then begin
         TheLine[2]:=FromY+IY*StepY;
         if IY>=MaxY
           then begin IY:=1; TheLine[2]:=FromY;
                inc(IX); TheLine[1]:=FromX+IX*StepX;
                end
           else begin inc(IY); TheLine[1]:=FromX+IX*StepX end
         end
    else begin { normal, not 3D }
         TheLine[1]:=FromX+IX*StepX;
         inc(IX)
         end;
  if IX>MaxX then begin ReadFormTheLine:=2; exit end;
  if FormulaX<>nil then FormX:=FormulaParserDollars(FormulaX^,TheLine)
    else FormX:=0;
  if Draw3D then TheLine[3]:=FormX else TheLine[2]:=FormX;
  end;
end;


procedure DoDraw3DFormulae
  ( var Posuny: string; var Draw3D: boolean );
var I,Pos1,Pos11: integer;
begin
I:=pos('"',Posuny);
Draw3D:=(Posuny<>'') and (I<>0);
  if Draw3D then system.delete( Posuny,I,1 );

{ read formulae }
FormulaX:=nil; FormulaY:=nil; FormulaZ:=nil; Pos1:=0; {pocet pruchodu}
i:=Pos(':',Posuny); if i>0 then begin
Pos1:=1; system.delete(Posuny,I,1);
Pos11:=Pos(':',Posuny); if Pos11=0 then Pos11:=length(Posuny)+1;
if Pos11<>i then
  begin GetMem(FormulaX,Pos11-i+2);
  FormulaX^:=Copy(Posuny,i,Pos11-i) end;
system.delete(Posuny,i,Pos11-i);
{ i:=Pos(':',Posuny); } if Posuny[i]=':' then begin
system.delete(Posuny,I,1);
Pos11:=Pos(':',Posuny); if Pos11=0 then Pos11:=length(Posuny)+1;
if Pos11<>i then
  begin GetMem(FormulaY,Pos11-i+2); FormulaY^:=Copy(Posuny,i,Pos11-i);
  Pos1:=2 end;
system.delete(Posuny,i,Pos11-i);
{ i:=Pos(':',Posuny); } if Posuny[i]=':' then begin
system.delete(Posuny,I,1);
Pos11:=Pos(':',Posuny); if Pos11=0 then Pos11:=length(Posuny)+1;
if Pos11<>i then
  begin GetMem(FormulaZ,Pos11-i+2); FormulaZ^:=Copy(Posuny,i,Pos11-i);
  Pos1:=3 end;
system.delete(Posuny,i,Pos11-i+1);
end end;
if Pos1=0
  then notFormula:=true
  else begin notFormula:=false;
       case Pos1 of
         1: if Draw3D then begin FormulaZ:=FormulaX; FormulaX:=nil end
                      else begin FormulaY:=FormulaX; FormulaX:=nil end;
         2: if Draw3D then begin FormulaZ:=FormulaY; FormulaY:=FormulaX;
                                 FormulaX:=nil end;
         end;
       end;
if FormulaX<>nil then
  begin FormulaParserPreProcess(FormulaX^);
  MaxColumn:=MaxL(MaxColumn,FormulaParserGetMaxParam(FormulaX^)) end;
if FormulaY<>nil then
  begin FormulaParserPreProcess(FormulaY^);
  MaxColumn:=MaxL(MaxColumn,FormulaParserGetMaxParam(FormulaY^)) end;
if FormulaZ<>nil then
  begin FormulaParserPreProcess(FormulaZ^);
  MaxColumn:=MaxL(MaxColumn,FormulaParserGetMaxParam(FormulaZ^)) end;
if MaxColumn>MaxTheLine
  then begin Beepni(7); MaxColumn:=MaxTheLine end;
end;
end;


procedure DoFromFormula
  ( var Name: string; Xodod,Xdodo, Yodod,Ydodo: real; DrawIt3D: boolean;
    aMaxX, aMaxY: integer );
{ it must be Name[1]=':' }
begin
GetMem(FormulaX,length(Name)+2);
FormulaX^:=Copy(Name,2,length(Name)-1);
if FormulaX=nil then exit;
FormulaParserPreProcess(FormulaX^);
new(FromFormula); if FromFormula=nil then exit;
if (Xodod<-1e10) or (Xodod>Xdodo) then Xodod:=-10;
if (Xdodo>1e10) or (Xdodo<Xodod)  then Xdodo:=10;
if (Yodod<-1e10) or (Yodod>Ydodo) then Yodod:=-10;
if (Ydodo>1e10) or (Ydodo<Yodod)  then Ydodo:=10;
with FromFormula^ do
  begin
  IX:=0; IY:=0;
(*
  if Draw3D then begin MaxX:=181; MaxY:=181; {211 ok, 5 debug} end
            else begin MaxX:=211; MaxY:=211; {211 ok, 5 debug} end;
*)
  MaxX:=MaxL(aMaxX,4); MaxY:=MaxL(aMaxY,4);
  FromX:=Xodod; ToX:=Xdodo; FromY:=Yodod; ToY:=Ydodo;
  StepX:=(Xdodo-Xodod)/(MaxX-1);
  StepY:=(Ydodo-Yodod)/(MaxY-1);
  Draw3D:=DrawIt3D;
  end;
isFromWhich:=isFromFormula;
end;


end. { TVFibGra }
