UNIT TVFibGrf;
{ c Petr Mikulk - Brno - 1992/95 }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

{ $DEFINE TVFib}
  { This switch is for compiling my program XRDSL for the calculation of 
    X-ray diffraction curves on superlattices (see my WWW homepage for 
    more information about it). 
    This must be undefined for the compilation of pmgraf }

{$DEFINE PMGraf}

{$IFDEF PMGraf}
{$DEFINE DRAW3D}
  { for the 3D color scale }
{$ENDIF}


INTERFACE

{ Interni pozn: horizont. osa = x, vertikalni = y jde dolu }

{$IFDEF TVFib}
uses dos, crt, graph, BGIload,
     DefFloat, PmElFun, ElFun, CompNum, Graf094, PMmouse, Print,
     Drivers, Memory, Views, Dialogs, ZprBox, TUnita, TRuzne,
     MujGraf, App1, TVFibDef, TVFibPoc, KrystLat, DefKryst,
     TVFibGra;

type TLastApp = object ( TFibPocApp ) end;
{$ENDIF}

{$IFDEF PMGraf}
uses dos, crt, graph, BGIload,
     DefFloat, PmElFun, ElFun, CompNum, Graf094, PMmouse, Print,
     Drivers, Memory, Views, Dialogs, ZprBox, TUnita, TRuzne,
     MujGraf, App1, TVFibDef, TVFibDat, TVFibGra;

type TLastApp = object ( TFibDatApp ) end;
{$ENDIF}


  TFibGrafApp = object ( TLastApp )
    procedure KresliGraf;
    end;

function GrafOn
  ( A,VA, B,VB: float; HString, VString: string; TypX, TypY: byte;
    StepX, StepY, SourceY0, SourceX0: float; Border: boolean;
    GridX, GridY: _GridType; NoPlotAxis: boolean;
    OnlyRedrawAxis: boolean ): boolean;
   { zavede grafiku + vyhodi true if doslo k chybe }

const HaltGraphics: boolean = false;
   { provede Halt po vykresleni grafu }

const Pozadi: byte  = 0;
      Popredi: byte = white;
      BlackWhite: boolean = false;
      MouseLabelCounter: integer = 50;

var BarZero: real;


IMPLEMENTATION

{$IFDEF DRAW3D}
uses buffers, pmparser;
{$ENDIF}

{ $I svga16.inc}
{ $I svgautil.inc}

var PomIfClipA1, PomIfClipVA1,PomIfClipB1,PomIfClipVB2: integer;
      { if je clip, tak se tam da rozmer ramecku }

var isClipping: boolean; { je/neni clipping rezim }

function GrafOn
  ( A,VA, B,VB: float; HString, VString: string; TypX, TypY: byte;
    StepX, StepY, SourceY0, SourceX0: float; Border: boolean;
    GridX, GridY: _GridType; NoPlotAxis: boolean;
    OnlyRedrawAxis: boolean  ): boolean;
var X,Y,A1,VA1,B1,VB1: float; I,J: integer;
begin
if not OnlyRedrawAxis then
 if UseSVGA=1 then begin RegisterSVGA16; TheGrDriver:=16 end
              else RegisterEGAVGA;
{ DetectGraph(I,J); { if (I=EGA) and (TheGrMode>2) then TheGrMode:=2; }
BarZero:=VA;
if TypX=0 then begin A1:=A; B1:=B end
          else begin A1:=Log10(A); B1:=Log10(B) end;
if TypY=0 then begin VA1:=VA; VB1:=VB end
          else begin VA1:=Log10(VA); VB1:=Log10(VB) end;
if A>0 then A:=A*(1-_sqrteps) else A:=A*(1+_sqrteps); {aby  se vzdy vypsaly i krajni body na ose}
if B>0 then B:=B*(1+_sqrteps) else B:=B*(1-_sqrteps);
if VA>0 then VA:=VA*(1-_sqrteps) else VA:=VA*(1+_sqrteps);
if VB>0 then VB:=VB*(1+_sqrteps) else VB:=VB*(1-_sqrteps);
if (SourceY0>=A) and (SourceY0<=B) then X:=SourceY0 else X:=A;
  { vrazi osu y kam patri - vlevo ci do nuly }
if (SourceX0>=VA) and (SourceX0<=VB) then Y:=SourceX0 else Y:=VA;
{ if (0>=VA) and (0<=VB) then Y:=0 else Y:=VA;  ... old }
GrafOn:=true;
if not OnlyRedrawAxis then
  begin
  if EnterGraphic then exit;
  DefineViewPort(0, 0.02,0.02, 0.98,0.98,  A1-(B1-A1)*0.10, VA1-(VB1-VA1)*0.10,
     B1+(B1-A1)*0.10, VB1+(VB1-VA1)*0.10, black,black);
  SelectViewPort(0,true,ClipOff);
  end;
GrafOn:=false;
if StepX<(B-A)/200 then StepX:=0;
if StepY<(VB-VA)/200 then StepY:=0;
if StepX<=0 then StepX:=Zaokrouhli( (B-A)/9, 1);
if StepY<=0 then StepY:=Zaokrouhli( (VB-VA)/9, 1);
{ if (0>=VA) and (0<=VB) then Y:=0 else Y:=VA; ... old }
if not NoPlotAxis then
PlotAxis( _AxesType(1+TypX), A,B, A,B, StepX/2, StepX {krok popisu}, LabBellowH,
              2, 2, GridX, HString, LabBellowH,
          X,Y,
          _AxesType(1+TypY),  VA, VB, VA, VB, StepY/2, StepY, LabLeftV,
              2, 2, GridY, VString, LabLeftV,
          red, 0, 0, blue, 0 );
if Border then
  begin SetColor(red); UMoveTo(A1,VA1); ULineTo(A1,VB1);
  ULineTo(B1,VB1); ULineTo(B1,VA1); ULineTo(A1,VA1) end;

MouseTabX:=0.60; MouseTabY:=0.92;

{ if (DialogGrafRec.GrafOpts and 8) = 0 then }
if not isClipping then
  begin XisLog:=TypX=1; YisLog:=TypY=1; exit end;

{ cut off, clip off }
if not OnlyRedrawAxis then
DefineViewPort(1, UtNx(A1)+0.02,UtNy(VA1)+0.02,UtNx(B1)+0.02,UtNy(VB1)+0.02,
                  A1,VA1, B1, VB1, black, black );
{
DefineViewPort(1, 0.02,0.02, 0.98,0.98,  A1-(B1-A1)*0.10, VA1-(VB1-VA1)*0.10,
   B1+(B1-A1)*0.10, VB1+(VB1-VA1)*0.10, black,black);
}
SelectViewPort(1,false,ClipOff);
MouseTabX:=MouseTabX-0.05; MouseTabY:=MouseTabY-0.1;
PomIfClipA1:=UtDx(A1); PomIfClipVA1:=UtDy(VA1);
PomIfClipB1:=UtDx(B1); PomIfClipVB2:=UtDy(VB1);
XisLog:=TypX=1; YisLog:=TypY=1;
end;


procedure SetPattern ( Pat: word );
var L: LineSettingsType; Patrn: word;
begin
GetLineSettings(L);
case Pat of 3: begin Pat:=UserBitLn; Patrn:=$F3F3 end;
            4: begin Pat:=UserBitLn; Patrn:=$D6D6 end;
            5: begin Pat:=UserBitLn; Patrn:=($D6D6) xor $FFFF end;
            else Patrn:=L.Pattern;
            end;
with L do SetLineStyle(Pat,Patrn,Thickness);
end;

{ --- }


procedure TFibGrafApp.KresliGraf;
var J,I,Kolik: integer;
    Color,Pattern: word;
    X,Y,KoefX,Xodod,Xdodo,Yodod,Ydodo: float;
    PisX,PisY: real;
    PisX1,PisY1: integer;
    C: Complex;
    S,Note: PathStr; CC: char;
    E: TEvent;
    Mouse: TTableMouse; DoMouse,IsMouse: boolean;
    RedrawAxis: boolean;

 function NA ( X: float ): float;
 { nasobeni dat na ose X koeficientem }
  begin NA:= X*KoefX end;

 procedure Pis ( S: string; var X,Y: real );
  const Size=1; var XX, YY: real;
  begin
  if NoSpaces(S)='' then exit;
{ if (DialogGrafRec.GrafOpts and 8) = 0 { Tohle je korekce na blbost. Na ci? }
  if not isClipping
    then begin XX:=X; YY:=Y end         { Za vse muze pocitac ! ktery programuje hloupy clovek... }
    else begin XX:=X-0.08; YY:=Y-0.09 end; { At zije Murphy ! }
  if (DialogGrafRec.GrafOpts and 1)<>0 then
    begin PltText('',NtUx(XX),NtUy(YY),DefaultFont,Size,graph.GetColor,black);
    UMoveTo(NtUx(XX),NtUy(YY)); MoveRel(-18,0); LineRel(18,0) end;
  PltText(S,NtUx(XX),NtUy(YY),DefaultFont,Size,graph.GetColor,black);
  Y:=Y-0.03;
  end;

procedure NastavClip;
begin
{ if DialogGrafRec.GrafOpts and 8 = 0 then exit; }
if not isClipping then exit;
{ SelectViewPort(1); }
VPclip(ClipOn);
SetViewPort(PomIfClipA1,PomIfClipVA1,PomIfClipB1,PomIfClipVB2,ClipOn);
end;

procedure UkonciClip;
begin
VPclip(ClipOff);
exit;
{ if DialogGrafRec.GrafOpts and 8 = 0 then exit; }
if not isClipping then exit;
{ ClearViewPort; }
end;


procedure GrafFromFile ( Name, Posuny: PathStr; Odkud, Kam: real; var Color, Pattern: word );
{ Zobrazeni grafu ze souboru - zavisi na typu souboru }
{ Soubory musi mit data z osy x setridene vzestupne - kvuli zrychleni
  cteni z disku ! }

var CurveType: char;
    Points: boolean;
    IsFirst: boolean;
    IsShow,IsWait,IsWaitScan,Skip2lines,DrawIt3D: boolean;
    K,Pos1,Pos11: integer;
    ShowVer,ShowAndWait: byte;
    PointSize: integer;
    ColumnX,ColumnY,IndFrom,IndTo,EveryNth,ThisEveryNth: integer;
    FromLine,FromScan: longint;
    Xplus,Xkrat,Yplus,Ykrat,mulXplus,mulXkrat,mulYplus,mulYkrat: real;

procedure DrawPoint ( X,Y: float );
var Mouse: TKursorMouse; XX,YY: real;
begin
dec(ThisEveryNth);
if ThisEveryNth<>0 then exit;
ThisEveryNth:=EveryNth;
case CurveType of
  'B': begin
       SMoveTo(X,BarZero);
       SLineTo(X,Y) end;
  'N': SMoveTo(X,Y);
  { else }
  'C':if IsFirst then begin SMoveTo(X,Y); IsFirst:=false end
                 else SLineTo(X,Y);
  end;
if Points then PltSymbol( 1+Color mod 10, Sxtox(X),Sytoy(Y), PointSize, Color );
if IsWait
  then begin
  if IsMouse then
    begin Mouse.Init(I); { TypTabulkyMysi:=1; }
    Mouse.Move(GetX+8,Gety) end;
  if IsMouse then Mouse.LOOP else repeat until KeyPressed;
  if not KeyPressed then delay(50);
  if IsMouse then Mouse.Done;
  if KeyPressed and (ReadKey=#27) then IsWait:=false;
  SMoveTo(X,Y);
  end
end;


procedure GrafFromDNR;
{ Tvar vstupniho souboru: nejdrive word = pocet hodnot, pak
  data ulozena pomoci SaveArrays. V poslednich 80 bytech je
  ulozena poznamka typu PathStr }
var Y,X: real; { v tomto poradi ! }
var Index,Hodnot: word;
    Inp: file;
begin
assign(Inp,Name); {$I-} reset(Inp,1); {$I+}
if IOresult<>0 then exit;
BlockRead(Inp,Hodnot,2);
repeat BlockRead(Inp,X,12); X:=NA(X); until X>=Odkud;
if X>Kam then begin close(Inp); exit end;
NastavClip;
DrawPoint(NA(X),Y); Index:=1;
while (not eof(Inp)) and (Index<Hodnot) and (X<=Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  BlockRead(Inp,X,12); X:=NA(X); DrawPoint(X,Y); inc(Index);
  end;
UkonciClip;
Seek(Inp,FileSize(Inp)-80); { nacteni poznamky }
BlockRead(Inp,Note,SizeOf(Note),I);
if length(Note)<80 then Pis(Note,PisX,PisY);
close(Inp);
end;

(* verze bez posunu
procedure GrafFromDPR;
{ Tvar vstupniho souboru: nejdrive word = pocet hodnot, pak
  prvni hodnota X, posledni hodnota X (typu real) a predpoklada
  se tedy ekvidistantni rozlozeni X.
  Pak nasleduji prislusna Y typu real.
  V poslednich 80 bytech je ulozena poznamka typu PathStr }
var Y,X: real; { v tomto poradi ! }
var Index,Hodnot: word; Step: real; Inp: file;
begin
assign(Inp,Name); {$I-} reset(Inp,1); {$I+}
if IOresult<>0 then exit;
BlockRead(Inp,Hodnot,2);
BlockRead(Inp,X,12);  { EthaOd, EthaDo }
if (X > Kam) or ( Y < Odkud ) then begin close(Inp); exit end;
NastavClip;
Step:=(Y-X)/(Hodnot-1);
if X>=Odkud then Index:=0 else Index:=trunc((Odkud-X)/Step);
X:=X+Index*Step;
Seek( Inp, 14+6*Index );  inc(Index);
BlockRead(Inp,Y,6);
DrawPoint(NA(X),Y);
while (not eof(Inp)) and (Index<Hodnot) and (X<=Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  BlockRead(Inp,Y,6); X:=X+Step;
  DrawPoint(NA(X),Y); inc(Index)
  end;
UkonciClip;
Seek(Inp,FileSize(Inp)-80); { nacteni poznamky }
BlockRead(Inp,Note,SizeOf(Note),I);
if length(Note)<80 then Pis(Note,PisX,PisY);
close(Inp);
end;
*)

procedure GrafFromDPR ( Xnas: float );
{ Tvar vstupniho souboru: nejdrive word = pocet hodnot, pak
  prvni hodnota X, posledni hodnota X (typu real) a predpoklada
  se tedy ekvidistantni rozlozeni X.
  Pak nasleduji prislusna Y typu real.
  V poslednich 80 bytech je ulozena poznamka typu PathStr }
var Y,X: real; { v tomto poradi ! }
var Index,Hodnot: word; Step: real; Inp: file;
begin
assign(Inp,Name); {$I-} reset(Inp,1); {$I+}
if IOresult<>0 then exit;
BlockRead(Inp,Hodnot,2);
BlockRead(Inp,X,12);  { EthaOd, EthaDo }
{ pro posuny }
Xplus:=Xplus*Xnas;
X:=(X+Xplus)*Xkrat; Y:=(Y+Xplus)*Xkrat;
X:=NA(X); Y:=NA(Y);
if (X > Kam) or ( Y < Odkud ) then begin close(Inp); exit end;
NastavClip;
Step:=(Y-X)/(Hodnot-1);
if X>=Odkud then Index:=0 else Index:=trunc((Odkud-X)/Step);
X:=X+Index*Step;
Seek( Inp, 14+6*Index );  inc(Index);
BlockRead(Inp,Y,6);
DrawPoint(X,Y*Ykrat+Yplus);
while (not eof(Inp)) and (Index<Hodnot) and (X<=Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  BlockRead(Inp,Y,6); X:=X+Step;
  DrawPoint(X,Y*Ykrat+Yplus); inc(Index)
  end;
UkonciClip;
Seek(Inp,FileSize(Inp)-80); { nacteni poznamky }
BlockRead(Inp,Note,SizeOf(Note),I);
if length(Note)<80 then Pis(Note,PisX,PisY);
close(Inp);
end;


procedure GrafFromASCII ( Xnas: float );
{ Xkrat - koef., kterym musim vynasobit data na ose X, abych
  je prevedl na radiany }
var Inp: text; Note,Note2: string; Pom,K: integer;
    Y,X,R: real; 
label ReadNextLine,Konec;
begin
assign(Inp,Name); {$I-} reset(Inp); 
if IOresult<>0 then exit;
if not Skip2lines then { na prvnich dvou radcich nejsou data }
  begin readln(Inp,Note); readln(Inp,Note2);
  Note:=Note+' '+Note2;
  if Note<>'' then Pis(Note,PisX,PisY)
  end;
(* drive repeat readln(Inp,X,Y); X:=(X+Xplus)*Xkrat*Xnas
        until (X>=Odkud*(1-_sqrteps)) or eof(Inp); *)
repeat
ReadNextLine:
(* K:=1;
   repeat
   if eoln(Inp) then
     begin K:=1; repeat readln(Inp) until eof(Inp) or not(eoln(Inp)) end;
     if not eof(Inp) then
     begin read(Inp,R); if K=ColumnX then X:=R;
     if K=ColumnY then Y:=R; inc(K) end
   until ((K>ColumnX) and (K>ColumnY)) or eoln(Inp);
*)
case ReadFormTheLine(Inp) of
  1: goto ReadNextLine;
  2: goto Konec
  end;
X:=TheLine[ColumnX]; Y:=TheLine[ColumnY];
X:=(X+Xplus)*Xkrat*Xnas
until (X>=Odkud*(1-_sqrteps)) or eof(Inp);
if (X>Kam) or eof(Inp) then begin close(Inp); exit end;
{ SMoveTo(NA((X+Xplus)*Xkrat),Y*Ykrat+Yplus); }
NastavClip;
(* drive  for Pom:=3 to ColumnY do read(Inp,Y); *)
SMoveTo(NA(X),Y*Ykrat+Yplus);
X:=X/Xnas/Xkrat-Xplus;
while (not eof(Inp)) and ((X+Xplus)*Xkrat*Xnas<Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  (* drive  read(Inp,X,Y);
    for Pom:=3 to ColumnY do read(Inp,Y); readln(Inp); *)
  repeat
  if eoln(Inp) then
    begin K:=1; repeat readln(Inp) until eof(Inp) or not(eoln(Inp)) end;
  if not eof(Inp) then
    begin read(Inp,R); if K=ColumnX then X:=R;
    if K=ColumnY then Y:=R; inc(K) end
  until ((K>ColumnX) and (K>ColumnY)) or eoln(Inp);
  DrawPoint(NA((X+Xplus)*Xkrat*Xnas),Y*Ykrat+Yplus);
  if not eoln(Inp) then readln(Inp);
  if eoln(Inp) then IsFirst:=true; {nespojuj body if free line}
  end;
Konec:
UkonciClip;
close(Inp); {$I+}
end;


procedure GrafFromTilo ( Xnas: float );
{ Xkrat - koef., kterym musim vynasobit data na ose X, abych
  je prevedl na radiany }
var Inp: text; Note,Note2: string; Y,X: real;
Ytmp: real; I: integer;
Item: longint;
begin
assign(Inp,Name); {$I-} reset(Inp); 
if IOresult<>0 then exit;
if not Skip2lines then { na prvnich dvou radcich nejsou data }
  begin readln(Inp,Note); readln(Inp,Note2);
  Note:=Note+' '+Note2;
  if Note<>'' then Pis(Note,PisX,PisY)
  end;
(*
repeat readln(Inp,X); X:=(X+Xplus)*Xkrat*Xnas;
until (X>=Odkud*(1-_sqrteps)) or eof(Inp);
if (X>Kam) or eof(Inp) then begin close(Inp); exit end;
*)
{ SMoveTo(NA((X+Xplus)*Xkrat),Y*Ykrat+Yplus); }
Item:=ZpracHodnot;
readln(Inp,X);
for I:=2 to Item do readln(Inp,Y);
for I:=Item+1 to 5 do readln(Inp,Ytmp);
NastavClip;
SMoveTo(NA(X),Y*Ykrat+Yplus);
X:=X/Xnas/Xkrat-Xplus;
while (not eof(Inp)) and ((X+Xplus)*Xkrat*Xnas<Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  readln(Inp,X);
  for I:=2 to Item do readln(Inp,Y);
  for I:=Item+1 to 5 do readln(Inp,Ytmp);
  DrawPoint(NA((X+Xplus)*Xkrat*Xnas),Y*Ykrat+Yplus);
  end;
UkonciClip;
close(Inp); {$I+}
end;


procedure GrafFromNoAngle ( Xnas: float );
{ Xkrat - koef., kterym musim vynasobit data na ose X, abych
  je prevedl na radiany }
var Inp: text; Note,Note2: string; Y,X: real;
Ytmp: real; I: integer;
Item: longint;
begin
if Xkrat=0 then exit;
assign(Inp,Name); {$I-} reset(Inp); 
if IOresult<>0 then exit;
if not Skip2lines then { na prvnich dvou radcich nejsou data }
  begin readln(Inp,Note); readln(Inp,Note2);
  Note:=Note+' '+Note2;
  if Note<>'' then Pis(Note,PisX,PisY)
  end;
(*
repeat readln(Inp,X); X:=(X+Xplus)*Xkrat*Xnas;
until (X>=Odkud*(1-_sqrteps)) or eof(Inp);
if (X>Kam) or eof(Inp) then begin close(Inp); exit end;
*)
{ SMoveTo(NA((X+Xplus)*Xkrat),Y*Ykrat+Yplus); }
X:=0;
readln(Inp,Y);
NastavClip;
SMoveTo(NA((X+Xplus)*Xkrat*Xnas),Y*Ykrat+Yplus);
{ X:=X/Xnas/Xkrat-Xplus; }
while (not eof(Inp)) and ((X+Xplus)*Xkrat*Xnas<Kam) and
      not(KeyPressed and (ReadKey=#$1B)) do
  begin
  readln(Inp,Y);
  X:=X+1;
  DrawPoint(NA((X+Xplus)*Xkrat*Xnas),Y*Ykrat+Yplus);
  end;
UkonciClip;
close(Inp); {$I+}
end;


procedure GrafFromIND ( Xnas: float );
{ Xkrat - koef., kterym musim vynasobit data na ose X, abych
  je prevedl na radiany }
var Inp: text; Note,Note2: string; S: string;
    Y,X,R: real; Pom,A,B,C,M1,M2,K: integer;
    Mouse: TKursorMouse; LL: longint;
    IsFirstScan: boolean;
 function DoWaitScan: boolean;
 begin
 if IsMouse then
   begin TypTabulkyMysi:=1; Mouse.Init(I);
   Mouse.Move(A+15,M2-15) end;
 if IsMouse then Mouse.LOOP else repeat until KeyPressed;
 if not KeyPressed then delay(50);
 if IsMouse then Mouse.Done;
 DoWaitScan:=KeyPressed and (ReadKey=#27); { then goto Konec; }
 end;
label ReadNextLine, Konec;
begin
{$I-}
if isFromWhich=isFromFile then begin
 assign(Inp,Name); reset(Inp);
 if IOresult<>0 then exit;
 if not Skip2lines then { na prvnich dvou radcich nejsou data }
   begin readln(Inp,Note); readln(Inp,Note2);
   Note:=Note+' '+Note2;
   if Note<>'' then Pis(Note,PisX,PisY)
   end;
 if eof(Inp) then goto Konec;
 for LL:=1 to FromLine-1 do
   begin
   readln(Inp);
   if eof(Inp) then goto Konec;
   end;
 for LL:=1 to FromScan-1 do
   begin
   while eoln(Inp) do begin readln(Inp);
         if eof(Inp) then goto Konec end;
   while not eoln(Inp) do begin readln(Inp);
         if eof(Inp) then goto Konec end;
   end;
 end;
NastavClip; IsFirstScan:=true;
while ((isFromWhich=isFromFormula) or ((isFromWhich=isFromFile) and not eof(Inp)))
        and not(KeyPressed and (ReadKey=#$1B)) do
  begin
  ReadNextLine:
  if (isFromWhich=isFromFile) and eof(Inp) then goto Konec;
  (** drive read(Inp,X,Y); { X:=X*Xnas; }
     for Pom:=3 to ColumnY do read(Inp,Y); **)
(**K:=1;
  repeat
  if eoln(Inp) then
    begin K:=1; repeat readln(Inp) until eof(Inp) or not(eoln(Inp));
    if not(eof(Inp)) and not(IsFirstScan) and IsWaitScan then
      begin
      if IsMouse then
        begin TypTabulkyMysi:=1; Mouse.Init(I);
        Mouse.Move(A+15,M2-15) end;
      if IsMouse then Mouse.LOOP else repeat until KeyPressed;
      if not KeyPressed then delay(50);
      if IsMouse then Mouse.Done;
      if KeyPressed and (ReadKey=#27) then goto Konec;
      end;
    end;
  IsFirstScan:=false;
  if not eof(Inp) then
    begin read(Inp,R); if K=ColumnX then X:=R;
    if K=ColumnY then Y:=R; inc(K) end;
  until ((K>ColumnX) and (K>ColumnY)) or eoln(Inp);
**)
(**
  for K:=1 to MaxColumn do
    begin read(Inp,TheLine[K]);
    if IOresult<>0 then if boolean(GrErrorSkip) then
      begin readln(Inp); goto ReadNextLine end else goto Konec;
    if (K<MaxColumn) then
      if eoln(Inp) then goto ReadNextLine
        else if eof(Inp) then goto Konec;
    end;
**)
  case ReadFormTheLine(Inp) of
    1: goto ReadNextLine;
    2: goto Konec;
    end;
  X:=TheLine[ColumnX]; Y:=TheLine[ColumnY];
  X:=NA((X+Xplus)*Xkrat*Xnas); Y:=Y*Ykrat+Yplus;
  S:=''; readln(Inp,S); S:=NoRoundSpaces(S); C:=graph.GetColor;
  DrawPoint(X,Y);
  if (isFromWhich=isFromFile) and eoln(Inp) then
    begin
    IsFirst:=true; {nespojuj body if free line}
    repeat readln(Inp) until eof(Inp) or not(eoln(Inp));
    if not(eof(Inp)) and not(IsFirstScan) and IsWaitScan then
      if DoWaitScan then goto Konec;
    end;
  IsFirstScan:=false;
  if IsShow and (S<>'') and (GetX>5) and (GetX<GetMaxX-5) then
    begin
    i:=Pos(#9,S); while (i<>0) do begin S[i]:=' '; i:=Pos(#9,S) end;
    M1:=GetX; M2:=Gety;
    if Gety > GetMaxY then graph.MoveTo(GetX,70 {GetMaxY div 2});
    if (Gety > GetMaxY) and (CurveType<>'N') then MoveRel(0,-35);
    A:=GetX; B:=Gety; C:=graph.GetColor; SetColor(yellow);
    if ShowVer<>0
      then begin
           SetTextStyle( 0,VertDir,1 );
           SetTextJustify( CenterText, BottomText ); OutText( S );
           SetTextStyle( 0,HorizDir,1 );
           end
      else begin
           SetTextStyle( 0,HorizDir,1 );
           SetTextJustify( CenterText, CenterText ); OutText( S );
           end;
    if ShowAndWait=0 then
      begin
      if IsMouse then
        begin TypTabulkyMysi:=1; Mouse.Init(I);
        Mouse.Move(A+15,M2-15) end;
      if IsMouse then Mouse.LOOP else repeat until KeyPressed;
      if not KeyPressed then delay(50);
      if IsMouse then Mouse.Done;
      if KeyPressed and (ReadKey=#27) then IsShow:=false;
      end;
    graph.MoveTo(A,B); SetColor(1+C);
    if ShowVer<>0
      then begin
           SetTextStyle( 0,VertDir,1 );
           SetTextJustify(CenterText, BottomText); OutText( S );
           SetTextStyle( 0,HorizDir,1 );
           end
      else begin
           SetTextStyle( 0,HorizDir,1 );
           SetTextJustify(CenterText, CenterText); OutText( S );
           end;
    SetColor(C); graph.MoveTo(M1,M2);
    end;
  end;
Konec: UkonciClip;
if isFromWhich=isFromFile then close(Inp);
if IsWaitScan then DoWaitScan;
{$I+}
end;


{$IFDEF DRAW3D}
procedure GrafFrom3D ( Xnas: float );
{ Xkrat - koef., kterym musim vynasobit data na ose X, abych
  je prevedl na radiany }
var Inp: text; Note,Note2: string; S: string;
    Y,X,R: real; Pom,A,B,C,M1,M2,K: integer;
    Mouse: TKursorMouse;
    IsFirstScan: boolean;
{ special for 3d: }
{ local variables: }
const MaxA: integer = 2000; { max. nb. of points in one scan }
{ type PPole0 = ^array [0..10920] of real; }
var Ax,Ay,Az,Bx,By,Bz: PPole0;
    Color,MaxColor,StartColor,W,ColorsPal: integer;
    GX1,GY1,GX2,GY2,GX3,GY3,GX4,GY4: integer;
    ai,bi,aimax,bimax: word;
    sign: pointer;
    Inp3d: text;
    Error: string[20];
const Gray50 : FillPatternType = ($AA, $55, $AA,
  $55, $AA, $55, $AA, $55);
const Gray : FillPatternType = ($FF, $FF, $FF,
  $FF, $FF, $FF, $FF, $FF);
var UsedGray: FillPatternType;
{ supplied variables }
var isZlinlog: boolean;
    Zzero,Zmax,Zstep,key3dx,key3dy: real;
    columnZ: integer;
    Algor, TypPal: byte;
const
  Pal1: array[0..15] of byte = (
     Black, DarkGray, Brown, LightGray, White, LightCyan, Cyan,
     LightGreen, Green, LightMagenta, Magenta,
     Blue, LightBlue, Yellow, LightRed, Red );
  { mam to testovany na pocet barev - aby to nepretykalo 15.
    Takze kdyz pouziji jinou paletu, musi se to cislo zmenit
    za promennou }

procedure Swap3d ( var GX3,GY3, GX1,GY1: word);
var Tmp: word;
begin W:=GX3; GX3:=GX1; GX1:=GX3;
W:=GY3; GY3:=GY1; GY1:=GY3 end;

function Get3dColor ( Z: real ): word;
var W: word;
begin
if Z<Zzero then W:=StartColor
  else if Z>Zmax then W:=MaxColor
(*    else W:= StartColor+( trunc( (Z-Zzero)/Zstep ) mod ColorsPal ) +1; *)
    else W:= StartColor+( trunc( (Z-Zzero)/Zstep ) mod ColorsPal );
      { tady nize to pretykalo s tou +1 }
if TypPal=1 then if W<16 then W:=Pal1[W] else W:=Pal1[15] {pretyka to!}
   else {TypPal=0} { W:=W };
Get3dColor:=W;
end;

function Get3dColori ( ai, bi: word ): word;
begin
Get3dColori:=Get3dcolor( ( Az^[ai]+Az^[ai+1]+Bz^[bi]+Bz^[bi+1] ) / 4 );
end;

procedure DoKeyOfDraw3D;
var Z: real;
begin
Z:=zzero;
if isClipping then
  begin VPclip(ClipOff); key3dx:=key3dx-0.08; key3dy:=key3dy+0.07 end;
key3dx:=key3dx-0.05;
key3dy:=key3dy+0.05;
while (Z<zmax+zstep*1.5) do
  begin
(*
  Color:=Get3Dcolor(Z-zstep/2); SetColor(Color);
  { MoveTo(NtDx(key3dx),NtDy(key3dy)); }
  graph.MoveTo( round(key3dx*GetMaxX), round(GetMaxY*(1-key3dy)) );
  LineRel(-16,0); LineRel(0,8); LineRel(32,0); LineRel(0,-8); LineRel(-16,0);
  MoveRel(0,1);
  SetFillPattern(UsedGray,Color); FloodFill(GetX,GetY,Color);
  if (z<zmax+zstep/4) then begin
    key3dy:=key3dy-0.06;
    graph.MoveTo( round(key3dx*GetMaxX), round(GetMaxY*(1-key3dy)) );
    SetColor(red);
    OutTextXY(GetX-20,GetY,StrFloat(Z,1,3));
    key3DY:=key3DY-0.02;
*)
  Color:=Get3Dcolor(Z-zstep/2); SetColor(Color);
  { MoveTo(NtDx(key3dx),NtDy(key3dy)); }
  graph.MoveTo( round(key3dx*GetMaxX)+3, round(GetMaxY*(1-key3dy)) );
  LineRel(-19,0); LineRel(0,4); LineRel(38,0); LineRel(0,-4); LineRel(-19,0);
  MoveRel(0,1);
  SetFillPattern(UsedGray,Color); FloodFill(GetX,GetY,Color);
  if (z<zmax+zstep/4) then begin
    key3dy:=key3dy+0.004;
    graph.MoveTo( round(key3dx*GetMaxX), round(GetMaxY*(1-key3dy)) );
    SetColor(red);
    OutTextXY(GetX-20,GetY,StrFloat(Z,1,3));
    key3DY:=key3DY+0.035;
    end;
  Z:=Z+zstep;
  end;
if isClipping then VPclip(ClipOn);
end;

procedure ReadZerothScan ( var Konec: boolean );
{ read the zero-th whole scan }
var K: integer;
label xxReadNextLine;
begin
ai:=0; Konec:=false; ThisEveryNth:=EveryNth;
if isFromWhich=isFromFile then while eoln(Inp) do readln(Inp);
while ((isFromWhich=isFromFile) and not eoln(Inp))
  or ((isFromWhich=isFromFormula) and (FromFormula^.IY<FromFormula^.MaxY) and (FromFormula^.IX=0))
  do begin
  xxReadNextLine:
  if ((isFromWhich=isFromFile) and eof(Inp)) or (ai>MaxA)
    then begin Konec:=true; exit end;
  (**
  for K:=1 to MaxColumn do
    begin
    read(Inp,TheLine[K]);
    if IOresult<>0 then if boolean(GrErrorSkip) then
      begin readln(Inp); goto xxReadNextLine end else begin Konec:=true; exit end;
    if (K<MaxColumn) then
      if eoln(Inp) then goto xxReadNextLine
        else if eof(Inp) then begin Konec:=true; exit end;
    end;
  **)
  case ReadFormTheLine(Inp) of
    1: goto xxReadNextLine;
    2: begin Konec:=true; exit end;
    end;
  if isFromWhich=isFromFile then readln(Inp);
  X:=TheLine[ColumnX]; Y:=TheLine[ColumnY];
  dec(ThisEveryNth);
  if ThisEveryNth=0 then begin
    ThisEveryNth:=EveryNth;
    AX^[ai]:=NA((X+Xplus)*Xkrat*Xnas);
    AY^[ai]:=Y*Ykrat+Yplus;
    AZ^[ai]:=TheLine[ColumnZ];
    if isZlinlog then
      if AZ^[ai]>0 then AZ^[ai]:=log10(AZ^[ai])
      else AZ^[ai]:=-38;
    inc(ai);
    end;
  end;
aimax:=ai-1;
end;

{ var Out: text; }
var Bool, Bool1: boolean; LL: longint;
label bbReadNextLine,ReadNextLine,
      TryMaxA,NoMemory,Konec;
begin
if isFromWhich=isFromFile then begin
  assign(Inp,Name); {$I-} reset(Inp);
  if IOresult<>0 then exit;
  end;
SetPattern(0);
UsedGray:=Gray50; Mark(sign);
ColorsPal:=16; {standard graphics}
{ assign(Out,'debug.3d'); rewrite(Out); }

assign(Inp3d,'pmgraf.3d'); reset(Inp3d);
if IOresult<>0 then
  begin Error:='No file PMGRAF.3D'; goto NoMemory end;
Error:='Error in PMGRAF.3D';
readln(inp3d,ColumnZ,zzero,zmax,zstep,W,ai,Algor,TypPal,StartColor, key3Dx,key3Dy );
if IOresult<>0 then begin close(inp3d); goto NoMemory end;
close(inp3d);
isZlinlog:=W<>0;
if ai=0 then UsedGray:=Gray50 else UsedGray:=Gray;
Error:='Not enough memory';
if isFromWhich=isFromFile then
if not Skip2lines then { na prvnich dvou radcich nejsou data }
   begin readln(Inp,Note); readln(Inp,Note2);
   if IOresult<>0 then goto Konec;
   Note:=Note+' '+Note2;
   if Note<>'' then Pis(Note,PisX,PisY)
   end;
{ if MaxAvail < MaxA*sizeof(real)*6.0 + 200 then goto NoMemory; }
MaxA:= trunc( (MaxAvail-256.0) / (6.0*sizeof(real)) );
TryMaxA:
W:=MaxA*sizeof(real);
GetMem(Ax,W); if MaxAvail<W+200.0 then goto NoMemory;
GetMem(Ay,W); if MaxAvail<W+200.0 then goto NoMemory;
GetMem(Az,W); if MaxAvail<W+200.0 then goto NoMemory;
GetMem(Bx,W); if MaxAvail<W+200.0 then goto NoMemory;
GetMem(By,W); if MaxAvail<W+200.0 then goto NoMemory;
GetMem(Bz,W);
if Zstep=0 then Zstep:=-50;
if Zmax<=Zzero then Zmax:=10*Zzero+10;
if isZlinlog then
  if (Zmax>0) and (Zzero>0) then
    begin Zmax:=log10(zmax); zzero:=log10(zzero) end
    else begin Beepni(11); Zzero:=1e-8; Zmax:=1e8 end;
if Zstep<0 then Zstep:=(Zmax-Zzero)/(-Zstep) { nb. of levels -> step of levels }
 else if isZlinlog then zstep:=log10(zstep);

MaxColor:=StartColor+( trunc( (Zmax-Zzero)/Zstep ) mod 16 ) +1;
if (isFromWhich=isFromFile) and eof(Inp) then goto Konec;
DoKeyOfDraw3D;
if isFromWhich=isFromFile then
for LL:=1 to FromLine-1 do
  begin
  readln(Inp);
  if eof(Inp) then goto Konec;
  end;
for LL:=1 to FromScan-1 do
  begin
  while eoln(Inp) do begin readln(Inp);
        if eof(Inp) then goto Konec end;
  while not eoln(Inp) do begin readln(Inp);
        if eof(Inp) then goto Konec end;
  end;
MaxColumn:=MaxL(MaxColumn,ColumnZ);
NastavClip; IsFirstScan:=true;

repeat
ReadZerothScan(Bool);
if (ai>MaxA) then goto NoMemory;
if Bool then goto Konec;
until ai>2;

while ((isFromWhich=isFromFormula) or ((isFromWhich=isFromFile) and not eof(Inp))) and not(KeyPressed and (ReadKey=#$1B)) do
  begin
  if isFromWhich=isFromFile then
    while eoln(Inp) do begin
    if eof(Inp) then goto Konec; readln(inp) end;
  ThisEveryNth:=EveryNth;
  ReadNextLine:
  { read the zero-th whole scan }
  bi:=0; Bool1:=true;
  while ((isFromWhich=isFromFormula) and (Bool1 or (FromFormula^.IY<FromFormula^.MaxY)))
        or ((isFromWhich=isFromFile) and not eoln(Inp))
    do begin
    Bool1:=false;
    if bi>MaxA then goto NoMemory;
    bbReadNextLine:
    if (isFromWhich=isFromFile) and eof(Inp) then goto Konec;
    (**
    for K:=1 to MaxColumn do
      begin
      read(Inp,TheLine[K]);
      if IOresult<>0 then if boolean(GrErrorSkip) then
      begin readln(Inp); goto bbReadNextLine end else goto Konec;
      if (K<MaxColumn) then
        if eoln(Inp) then goto bbReadNextLine
          else if eof(Inp) then goto Konec;
      end;
    **)
    case ReadFormTheLine(Inp) of
      1: goto bbReadNextLine;
      2: goto Konec
      end;
    if isFromWhich=isFromFile then readln(Inp);
    X:=TheLine[ColumnX]; Y:=TheLine[ColumnY];
    dec(ThisEveryNth);
    if ThisEveryNth=0 then begin
      ThisEveryNth:=EveryNth;
      BX^[bi]:=NA((X+Xplus)*Xkrat*Xnas); BY^[bi]:=Y*Ykrat+Yplus;
      BZ^[bi]:=TheLine[ColumnZ];
      if isZlinlog then if BZ^[bi]>0 then BZ^[bi]:=log10(BZ^[bi])
        else BZ^[bi]:=-38;
      inc(bi);
      end;
    end;
  bimax:=bi-1;
  if bi<=2 then
    begin
    repeat ReadZerothScan(Bool);
    if (ai>MaxA) then goto NoMemory;
    if Bool then goto Konec;
    until aimax>2; goto ReadNextLine;
    end;

  for ai:=0 to MinL(aimax,bimax)-1 do begin
  bi:=ai;
  { for each point of A scan (the prev. scan) }
  Color:=Get3dcolori(ai,bi);
  SetColor(Color);
  isFirst:=true;
  GX1:=StDx(AX^[ai]); GY1:=StDy(AY^[ai]);
  GX2:=StDx(BX^[bi]); GY2:=StDy(BY^[bi]);
  GX3:=StDx(BX^[bi+1]); GY3:=StDy(BY^[bi+1]);
  GX4:=StDx(AX^[ai+1]); GY4:=StDy(AY^[ai+1]);
  { now bound the "rectangle" }
  if Algor=2 then
      begin
      SetFillPattern(UsedGray,Color);
      if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX3)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY3)<2)) ) then
        begin
        graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX1,GY1);
        FloodFill( (GX1+GX2+GX3) div 3,(GY1+GY2+GY3) div 3,Color);
        SetColor(Color+1);
        graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX1,GY1);
        SetColor(Color);
        end;
      if not( ((abs(GX1-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY1-GY3)<2) and (abs(GY3-GY4)<2)) ) then
        begin
        graph.MoveTo(GX1,GY1); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX1,GY1);
        FloodFill( (GX1+GX3+GX4) div 3,(GY1+GY3+GY4) div 3,Color);
        SetColor(Color+1);
        graph.MoveTo(GX1,GY1); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX1,GY1);
        SetColor(Color);
        end;
      if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX4)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY4)<2)) ) then
        begin
        graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX4,GY4); LineTo(GX1,GY1);
        FloodFill( (GX1+GX2+GX4) div 3,(GY1+GY2+GY4) div 3,Color);
        SetColor(Color+1);
        graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX4,GY4); LineTo(GX1,GY1);
        SetColor(Color);
        end;
      if not( ((abs(GX2-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY2-GY3)<2) and (abs(GY3-GY4)<2)) ) then
        begin
        graph.MoveTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX2,GY2);
        FloodFill( (GX2+GX3+GX4) div 3,(GY2+GY3+GY4) div 3,Color);
        SetColor(Color+1);
        graph.MoveTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX2,GY2);
        SetColor(Color);
        end;
        graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3);
          LineTo(GX4,GY4); LineTo(GX1,GY1); LineTo(GX3,GY3);
        graph.MoveTo(GX2,GY2); LineTo(GX4,GY4);
{      repeat until keypressed; readkey; }
{      write(Out,'  G1=',GX1,',',GY1); write(Out,'  G2=',GX2,',',GY2);
      write(Out,'  G3=',GX3,',',GY3); writeln(Out,'  G4=',GX4,',',GY4); }
      end else
  if Algor=1 then
      begin
      (* if GY3<GY1 then Swap3d(GX3,GY3, GX1,GY1);
      if GY3<GY2 then Swap3d(GX2,GY2, GX3,GY3)
       else if GY2<GY1 then Swap3d(GX1,GY1, GX2,GY2);
      { central point is number 2 } *)
(* Prvni verze, jez nevybarvuje nektere trojuhelniky:
      graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3);
      LineTo(GX4,GY4); LineTo(GX1,GY1); LineTo(GX3,GY3);
      graph.MoveTo(GX2,GY2); LineTo(GX4,GY4);
      SetFillPattern(UsedGray,Color);
       if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX3)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY3)<2)) ) then
         FloodFill( (GX1+GX2+GX3) div 3,(GY1+GY2+GY3) div 3,Color);
       if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX4)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY4)<2)) ) then
         FloodFill( (GX1+GX2+GX4) div 3,(GY1+GY2+GY4) div 3,Color);
       if not( ((abs(GX1-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY1-GY3)<2) and (abs(GY3-GY4)<2)) ) then
         FloodFill( (GX1+GX3+GX4) div 3,(GY1+GY3+GY4) div 3,Color);
       if not( ((abs(GX2-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY2-GY3)<2) and (abs(GY3-GY4)<2)) ) then
         FloodFill( (GX2+GX3+GX4) div 3,(GY2+GY3+GY4) div 3,Color);
*)
      graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX1,GY1);
      SetFillPattern(UsedGray,Color);
       if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX3)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY3)<2)) ) then
         FloodFill( (GX1+GX2+GX3) div 3,(GY1+GY2+GY3) div 3,Color);
      graph.MoveTo(GX1,GY1); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX1,GY1);
       if not( ((abs(GX1-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY1-GY3)<2) and (abs(GY3-GY4)<2)) ) then
         FloodFill( (GX1+GX3+GX4) div 3,(GY1+GY3+GY4) div 3,Color);
      graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX4,GY4); LineTo(GX1,GY1);
       if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX4)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY4)<2)) ) then
         FloodFill( (GX1+GX2+GX4) div 3,(GY1+GY2+GY4) div 3,Color);
      graph.MoveTo(GX2,GY2); LineTo(GX3,GY3); LineTo(GX4,GY4); LineTo(GX2,GY2);
       if not( ((abs(GX2-GX3)<2) and (abs(GX3-GX4)<2)) or ((abs(GY2-GY3)<2) and (abs(GY3-GY4)<2)) ) then
         FloodFill( (GX2+GX3+GX4) div 3,(GY2+GY3+GY4) div 3,Color);
{      repeat until keypressed; readkey; }
{      write(Out,'  G1=',GX1,',',GY1); write(Out,'  G2=',GX2,',',GY2);
      write(Out,'  G3=',GX3,',',GY3); writeln(Out,'  G4=',GX4,',',GY4); }
      end
    else {Algor=0}
      begin
      graph.MoveTo(GX1,GY1); LineTo(GX2,GY2); LineTo(GX3,GY3);
      LineTo(GX4,GY4); LineTo(GX1,GY1);
      { go to the central point }
      { if not( ((abs(GX1-GX2)<2) and (abs(GX2-GX3)<2)) or ((abs(GY1-GY2)<2) and (abs(GY2-GY3)<2)) ) }
      if not( ((GX1=GX2) and (GX2=GX3)) or ((GY1=GY2) and (GY2=GY3)) )
         then begin GX1:=GX1+GX2+GX3; GY1:=GY1+GY2+GY3 end
         else begin GX1:=GX1+GX3+GX4; GY1:=GY1+GY3+GY4 end;
      SetFillPattern(UsedGray,Color);
      FloodFill(GX1 div 3,GY1 div 3,Color);
      end;
  end; { for each ai }
  isFirstScan:=false;
  { make A:=B }
  aimax:=bimax;
  w:=longint(sizeof(real))*(aimax+1);
  Move(Bx^,Ax^,w); Move(By^,Ay^,w); Move(Bz^,Az^,w);
  if ((isFromWhich=isFromFormula) or ((isFromWhich=isFromFile) and not(eof(Inp)))) and not(IsFirstScan) and IsWaitScan then
    begin
    if IsMouse then
      begin TypTabulkyMysi:=1; Mouse.Init(I);
      Mouse.Move(GetMaxX div 2,GetMaxY div 2) end;
    if IsMouse then Mouse.LOOP else repeat until KeyPressed;
    if not KeyPressed then delay(50);
    if IsMouse then Mouse.Done;
    if KeyPressed and (ReadKey=#27) then goto Konec;
    end;
  { IsFirstScan:=false; }
{  writeln(Out); }
  end; { for all scans }
Konec:
Release(sign);
UkonciClip; if isFromWhich=isFromFile then close(Inp); {$I+}
{ FreeMem(Ax,MaxA*sizeof(real)); FreeMem(Ay,MaxA*sizeof(real)); FreeMem(Az,MaxA*sizeof(real));
  FreeMem(Bx,MaxA*sizeof(real)); FreeMem(By,MaxA*sizeof(real)); FreeMem(Bz,MaxA*sizeof(real));
}
{ close(Out); }
exit;
NoMemory:
Beepni(30); SetColor(red);
SetTextStyle(DefaultFont, HorizDir, 3);
{ OutTextXY(80,120,'No memory for 3d.'); }
OutTextXY(80,120,Error);
goto Konec;
end;
{$ENDIF}  { of Draw3D }



var Ext: ExtStr; ii,PosInd: integer; MulPoprve,B1: boolean; PomStr: string;
    Halda: pointer; 
label Konec;
begin  { -- GrafFromFile -- }
if Name='' then exit;
mark(Halda);
ColumnX:=1; ColumnY:=2; PointSize:=1;
PosInd:=pos('#',Name);
if (PosInd<>0) then begin
  system.delete(Name,PosInd,1);
  if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
    begin
    ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1);
    if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
      begin ColumnX:=ColumnY;
      ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1) end;
  end end;
MaxColumn:=MaxL(ColumnX,ColumnY); TheLine[0]:=0;
if Name[1]<>'-'
  then Skip2lines:=false
  else begin system.Delete(Name,1,1); Skip2lines:=true end;

DoDraw3DFormulae(Posuny,DrawIt3D);

Pos1:=0; Pos11:=Pos('??',Name); if Pos11=0 then Pos1:=Pos('?',Name);
IndFrom:=0; if Pos1<>0 then IndTo:=9 else if Pos11<>0 then IndTo:=99;
(* if (Pos1=0) and (Pos('*',Name)<>0) then
  begin Pos1:=Pos('*',Name); Name[Pos1]:='?' end;
if (Pos1=0) and (Pos('/',Name)<>0) then
  begin Pos1:=Pos('/',Name); Name[Pos1]:='?' end; *)

PosInd:=Pos('|',Name);
if PosInd>0 then
  begin PomStr:=Copy(Name,PosInd+1,255); Name[0]:=chr(PosInd-1);
  StringDveCisla(NoSpaces(PomStr),Xplus,Xkrat);
  IndFrom:=round(Xplus); IndTo:=round(Xkrat) end
 else if Name[1]=':' then
  if DrawIt3D
    then begin IndFrom:=181; IndTo:=181; {211 ok, 5 debug} end
    else begin IndFrom:=211; IndTo:=211; {211 ok, 5 debug} end;

if Name[1]=':'  { FROM FORMULA }
  then DoFromFormula ( Name, Xodod,Xdodo, Yodod,Ydodo, DrawIt3D, IndFrom,IndTo )
  else begin
    if (Pos('?',Name)=0) (* and (Pos('*',Name)=0) and (Pos('/',Name)=0) *) then
      begin if IOresult<>0 then;
      if not FileExist(Name) then goto Konec end;
    isFromWhich:=isFromFile;
    end;

CurveType:=' '; IsShow:=false; IsWait:=false; IsWaitScan:=false;
Posuny:=UpString(Posuny);
ShowVer:=Pos('V',Posuny);
if ShowVer<>0 then system.delete(Posuny,ShowVer,1); {and ShowVertically is non-zero}
ShowAndWait:=Pos('H',Posuny);
if ShowAndWait<>0 then system.delete(Posuny,ShowAndWait,1);
EveryNth:=Pos('(',Posuny); ThisEveryNth:=Pos(')',Posuny);
if not ((EveryNth>0) and (ThisEveryNth>EveryNth))
  then EveryNth:=1
  else begin PomStr:=Copy(Posuny,EveryNth+1,ThisEveryNth-EveryNth-1);
       system.delete(Posuny,EveryNth,ThisEveryNth-EveryNth+1);
       val(PomStr,EveryNth,ThisEveryNth) end;
ThisEveryNth:=1; FromLine:=1;
FromLine:=Pos('[',Posuny); ii:=Pos(']',Posuny);
if not ((FromLine>0) and (ii>FromLine))
  then FromLine:=1
  else begin PomStr:=Copy(Posuny,FromLine+1,ii-FromLine-1);
       system.delete(Posuny,FromLine,ii-FromLine+1);
       val(PomStr,FromLine,ii) end;
FromScan:=1;
FromScan:=Pos('{',Posuny); ii:=Pos('}',Posuny);
if not ((FromScan>0) and (ii>FromScan))
  then FromScan:=1
  else begin PomStr:=Copy(Posuny,FromScan+1,ii-FromScan-1);
       system.delete(Posuny,FromScan,ii-FromScan+1);
       val(PomStr,FromScan,ii) end;
I:=pos('P',Posuny);
(* not like that, there are only 2 point sizes
  if (Posuny='') or (I=0)   { Posuny[1]<>'P' }
  then Points:=false
  else begin Points:=true; 
  if I<length(Posuny) then
    if (Posuny[I+1]>='0') and (Posuny[I+1]<='9') then
      begin PointSize:=integer(Posuny[I+1])-48; system.delete(Posuny,I+1,1);
            PointSize:=2*PointSize; end;
  system.delete(Posuny,I,1);
  end;
*)
I:=pos('P',Posuny); if I=0 then I:=pos('O',Posuny);
if (Posuny='') or (I=0)   { 'P' small points, 'O' large points }
  then Points:=false
  else begin Points:=true;
  if I<length(Posuny) then
    if (Posuny[I+1]>='0') and (Posuny[I+1]<='9') then
      begin PointSize:=integer(Posuny[I+1])-48; system.delete(Posuny,I+1,1);
            PointSize:=2*PointSize; end;
  if Posuny[I]='O' then PointSize:=9;
  system.delete(Posuny,I,1);
  end;
if Points then CurveType:='N' else CurveType:='C';
I:=pos('C',Posuny); if I<>0 then CurveType:='C' else begin
  I:=pos('B',Posuny); if I<>0 then CurveType:='B' else begin
    I:=pos('N',Posuny); if I<>0 then CurveType:='N'; end end;
if I<>0 then system.delete(Posuny,I,1);
I:=pos('S',Posuny);
IsShow:=I<>0; if IsShow then system.delete( Posuny,I,1 );
if ShowAndWait<>0 then IsShow:=true;
I:=pos('W',Posuny);
IsWait:=(S<>'') and (I<>0);
  if IsWait then system.delete( Posuny,I,1 );
I:=pos('T',Posuny);
IsWaitScan:=(S<>'') and (I<>0);
  if IsWaitScan then system.delete( Posuny,I,1 );

if (length(Posuny)<>0) and (Posuny[length(Posuny)]<>',')
  then Posuny:=Posuny+',';
StringCtyriCisla ( Posuny, Xplus, Xkrat, Yplus, Ykrat );
if Posuny=''
  then begin mulXplus:=0; mulXkrat:=1; mulYplus:=0; mulYkrat:=1 end
  else StringCtyriCisla ( Posuny, mulXplus, mulXkrat, mulYplus, mulYkrat );

PosInd:=-1; MulPoprve:=false;
if Pos1<>0 then Name[Pos1]:=#47;
if Pos11<>0 then begin Name[Pos11]:=#48; Name[Pos11+1]:=#47 end;
repeat
B1:=true;
if isFromWhich=isFromFile then
if (Pos1=0) and (Pos11=0) then if not FileExist(Name) then goto Konec else
  else
  repeat inc(PosInd);
  if Pos1<>0 then inc(byte(Name[Pos1])) else
    { if Pos11<>0 then }
    if Name[Pos11+1]='9'
      then begin inc(byte(Name[Pos11])); Name[Pos11+1]:='0' end
      else inc(byte(Name[Pos11+1]));
  if PosInd>IndTo then goto Konec;
  B1:=FileExist(Name);
  until (PosInd>=IndFrom) and ( ((Pos1<>0) or (Pos11<>0)) and (PosInd<=IndTo)) and B1;

if MulPoprve then
  begin Xplus:=Xplus+mulXplus; Xkrat:=Xkrat*mulXkrat;
  Yplus:=Yplus+mulYplus; Ykrat:=Ykrat*mulYkrat;
  inc(Color); if Color=Pozadi then inc(Color) end;
MulPoprve:=true;

if B1 then
  begin
  IsFirst:=true;
  if ((Pos1<>0) and (PosInd>1)) or ((Pos11<>0) and (PosInd>1))
    then begin inc(Color); if Color=Pozadi then inc(Color) end;
  SetColor(Color);  SetPattern(Pattern);
  Ext:=GetExtension(Name);
{$IFDEF DRAW3D}
  if DrawIt3D then
    begin GrafFrom3D ( pi/(180*3600) ); RedrawAxis:=true end
  else
{$ENDIF}
  if Ext='DIQ'
   then GrafFromASCII ( pi/(180*3600) ) { vt->rad }
   else if Ext='IND' then GrafFromIND ( pi/(180*3600) )
    else if Ext='DPR' then GrafFromDPR ( 1 )
     else if Ext='DNR' then GrafFromDNR
{      else if Ext='TIL' then GrafFromTilo ( pi/(180*3600) )
}
      else if Ext='NOX' then GrafFromNoAngle ( pi/(180*3600) )
       else if Ext='NOA' then GrafFromNoAngle ( 1 )
         else GrafFromIND ( pi/(180*3600) )
   end;
if (Pos1<>0) and (PosInd=IndTo) then Pos1:=0;
if (Pos11<>0) and (PosInd=IndTo) then Pos11:=0;
until (Pos1=0) and (Pos11=0);
Konec: release(Halda);
end;

procedure KresliZPameti;
begin
if (ZpracHodnot<>0) and (HodnotyEtha<>nil) and (HodnotyIntenzity<>nil) then
begin  { -- nakresleni krivky z pameti -- }
NastavClip;
I:=1;
while NA(HodnotyEtha^[I]) < Xodod do inc(I);
if I=1 then I:=2;
X:=NA(HodnotyEtha^[I-1]);  Y:=HodnotyIntenzity^[I-1];
SMoveTo(X,Y); SetPattern(0); SetColor(white);
repeat
  X:=NA(HodnotyEtha^[I]); Y:=HodnotyIntenzity^[I];
  SLineTo( X,Y );
  inc(I);
until (I>ZpracHodnot) or (NA(HodnotyEtha^[I]*(1-_sqrteps)) > Xdodo) or
  (KeyPressed and (ReadKey=#$1B));
UkonciClip;
end end; { kresli z pameti }

procedure BlackShow; var J: integer;
{ zobrazeni cernobileho rezimu }
begin SetPalette(0,black);
for J:=1 to MaxColors do SetPalette(J,Popredi)
end;

var LButton,RButton,LX,LY,RX,RY: integer; Out: text; 
    Cpom: char; Smouse: string;

procedure InsertMouseClick ( Button: integer );
var X,Y: real;
begin
if RButton in [0..2] then begin
  X:=DtUx( RX-12 ); Y:=DtUy(GetMaxY-RY-10);
  if XisLog then X:=ALog10(X); if YisLog then Y:=ALog10(Y);
  case RButton of
    0: writeln(Out,X:1:6,' ',Y:14,' ',Smouse);
    1: writeln(Out,'xx ',X:1:6,',',Y:14,' yy',Smouse);
    2: begin writeln(Out,'set label ', { MouseLabelCounter:1, }
         ' "',Smouse,'" at ',
         X:1:6,',',Y:14,' c');
       inc(MouseLabelCounter) end;
    end end;
RButton:=Button; RX:=LX; RY:=LY; Smouse:='';
end;


var Palette: PaletteType; StepXX: float;
    isXLinLog, isYLinLog: boolean;
    whichMouse: integer;
label ReDrawIt, NewDraw, GoUntil, DoneKonec;

begin  { --- TFibApp.KresliGraf --- }

if GrafDialogP^.Valid(cmOK)=false then exit;
{ writeln('!!! Start of grf: ',MemAvail,'  ',MaxAvail,'  !!!');
  readln; }
GrafDialogP^.GetData(DialogGrafRec);
with DialogGrafRec do begin { odted implicitni ! }
if (KresliXDo<=KresliXOd) or (KresliYDo<=KresliYOd) then begin
 ZpravaBox('','Bad boundaries of the interval',nil,mfError+mfOkButton);
 exit end;
if ((KresliXOd<=0) and (XLinLog=1)) or ((KresliYOd<=0) and (YLinLog and 1=1)) then begin
 ZpravaBox('','Log. axis must be > 0',nil,mfError+mfOkButton);
 exit end;

{$IFDEF TVFib}
if (DrawRmax and 1) <> 0 { pro nakresleni maxima }
  then begin
  if not NaplnKrystalRec then exit;
  InicFC end;
{$ENDIF}

case DataNaX of
  0: begin KoefX:=180*3600/pi; S:='' end;
  1: begin KoefX:=180/pi; S:=' [deg]' end;
  2: begin KoefX:=180/pi*60; S:=' [min]' end;
  3: begin KoefX:=180/pi*3600; S:=' [sec]' end;
  end;
S:=AngleLabel+S;
DoneSysError; DoneEvents; DoneVideo; DoneMemory;
{$IFDEF PMGRAF}
SetMemTop(Ptr(BufHeapPtr, 0));
FreeMemBump;
{$ENDIF}

isYLinLog:=(YLinLog and 1)=1;
isXLinLog:=(XLinLog and 1)=1;

isClipping:=(DialogGrafRec.GrafOpts and 8) <> 0;
whichMouse:=MouseInGraf;
DoMouse:=MouseInGraf <> 0;
IsMouse:=DoMouse;
{ MouseEnableUserUnits:=(DialogGrafRec.GrafOpts and 8) = 0; }
{ MouseRelativeUnits:=(DialogGrafRec.GrafOpts and 8) <> 0; }
MouseRelativeUnits:=isClipping;
  { aby sla mys i v clipping rezimu, musel bych najit prepocty }
  { jak jsem v pmmouse.pas napsal, chodi to jen v jistem rezimu }

ReDrawIt:
if (Xzadanov=0) and (DataNaX<>0)
  then begin Xodod:=DMStoRad(KresliXOd);
       Xdodo:=DMStoRad(KresliXDo);
       StepXX:=DMStoRad(StepX) end
  else begin Xodod:=DegToRad(KresliXOd/3600);
       Xdodo:=DegToRad(KresliXDo/3600);
       StepXX:=DegToRad(StepX/3600) end;

Yodod:=KresliYOd; Ydodo:=KresliYDo;
Xodod:=NA(Xodod); Xdodo:=NA(Xdodo);

NewDraw:

if GrafOpts and 2 <> 0 then
  begin X:=0; Y:=0 end else begin X:=Xodod; Y:=Yodod end;
if GrafOn ( Xodod,Yodod, Xdodo,Ydodo,
            S,IntensLabel, ord(isXLinLog), ord(isYLinLog),
            Na(StepXX), StepY, X, Y, (GrafOpts and 4)<>0,
            _GridType(ord(GridStr[1])-48),_GridType(ord(GridStr[2])-48),
            {NoPlotAxis} GrafOpts and 16<>0, false )
  { then begin Application^.Redraw; exit end; }
  then goto DoneKonec;
RedrawAxis:=false;

{ if DataNaX=0 then KoefX:=KoefX*3600; }

StringDveCisla(NoSpaces(NadpisPos),PisX,PisY);
{ if (DialogGrafRec.GrafOpts and 8) <> 0  { to je ta korekce na blbost }
if isClipping
   then begin PisX:=PisX-0.08; PisY:=PisY-0.09 end;
 PltText(Nadpis,NtUx(PisX),NtUy(PisY),3{DefaultFont},2{Size},green,black);
StringDveCisla(NoSpaces(GrafPoznPos),PisX,PisY);
{ if (DialogGrafRec.GrafOpts and 8) <> 0  { to je ta korekce na blbost }
if isClipping
   then begin PisX:=PisX-0.08; PisY:=PisY-0.09 end;
PltText(GrafPozn,NtUx(PisX),NtUy(PisY),0{DefFont},0{Size},green,black);

StringDveCisla(FilyPos,PisX,PisY);
PisX:=PisX; PisY:=PisY; SetColor(white);

{$IFDEF TVFib}
MainDialogP^.GetData(DialogRec);
Pis(DialogRec.Pozn,PisX,PisY);
{$ENDIF}

SetPalette(0,Pozadi); graph.GetPalette(Palette);
if BlackWhite then
  begin SetPalette(0,black);
  for J:=1 to MaxColors do SetPalette(J,Popredi) end;

KresliZPameti;

{ -- zobrazeni dalsich filu -- }

Color:=1; Pattern:=0;
if (ZpracHodnot<>0) and ((GrafOpts and 1) <> 0) then Pattern:=1;

for J:=1 to MaxGrFiles do
  begin
  inc(Color);
  GrafFromFile(GrFile[J],GrFileMove[J],Xodod,Xdodo,Color,Pattern);
  if ((GrafOpts and 1) <> 0) and (GrFile[J]<>'') then inc(Pattern);
  end;

{$IFDEF TVFib}
SetPattern(SolidLn); SetColor(red);
if (DrawRmax and 1) <> 0
  then with Krystal^.Substrat do
  begin
  X:=GetEthaMax; { nakresleni maxima }
  SetColor(5); SMoveTo(NA(X),0); SLineTo(NA(X),GetRmax);
  X:=GetEthaStred; { nakresleni etha od lomu }
  SetColor(6); SMoveTo(NA(X),0); SLineTo(NA(X),BraggNekRefl(X));
  Y:=GetSirka; { nakresleni polosirky }
  SetColor(6); SMoveTo(NA(X-Y/2),BraggNekRefl(X)/2);
  SLineTo(NA(X+Y/2),BraggNekRefl(X)/2);
  end;
{$ENDIF}

if YLinLog and 2 <> 0 then
  begin SetColor(white); KresliZPameti end;

if RedrawAxis then
if GrafOn ( Xodod,Yodod, Xdodo,Ydodo,
            S,IntensLabel, ord(isXLinLog), ord(isYLinLog),
            Na(StepXX), StepY, X, Y, (GrafOpts and 4)<>0,
            _GridType(ord(GridStr[1])-48),_GridType(ord(GridStr[2])-48),
            {NoPlotAxis} GrafOpts and 16<>0,
            true )
  then goto DoneKonec;
RedrawAxis:=false;


SetPalette(0,Pozadi);
if HaltGraphics then Halt;

{ --- mys + cekani na stisk klavesy --- }

if IsMouse
  then begin TypTabulkyMysi:=whichMouse; Mouse.Init(I) end;

repeat

if not IsMouse then repeat until KeyPressed else Mouse.LOOP;
CC:=UpCase(ReadKey);
if (CC=#0) and (KeyPressed and (ReadKey=#$19)) { kbAltP }
  then begin FullHardCopyEPSON ( false, EpsonMode ); CC:=#0 end
  else
{ Indexovani }
case CC of
     '+': if not BlackWhite
            then begin inc(Pozadi); SetPalette(0,Pozadi) end
            else begin inc(Popredi); BlackShow end;
     '-': if not BlackWhite
            then begin dec(Pozadi); SetPalette(0,Pozadi) end
            else begin dec(Popredi); BlackShow end;
     'B': if not BlackWhite
            then begin Pozadi:=0; SetPalette(0,Pozadi) end
            else begin Popredi:=white; BlackShow end;
     'W': begin
          if BlackWhite { vraceni barev }
             then SetAllPalette ( Palette )
             else BlackShow;
          BlackWhite:=not(BlackWhite)
          end;
     'Z': if IsMouse then begin
          sound(220); delay(159); nosound;
          LButton:=0; RButton:=0;
          repeat
          if LButton=0 then LButton:=Mouse.PocetStisku(0,LX,LY);
          if RButton=0 then RButton:=Mouse.PocetStisku(1,RX,RY);
          if (KeyPressed and (ReadKey=#$1B)) then goto GoUntil;
          until (LButton and RButton)<>0;
          if (LX=RX) or (LY=RY) then goto GoUntil;
          Xodod:=DtUx( MinL(LX,RX)-12 );
          Xdodo:=DtUx( MaxL(LX,RX)-12 );
          if XisLog then begin Xodod:=ALog10(Xodod); Xdodo:=ALog10(Xdodo) end;
          Yodod:=DtUy(GetMaxY-MinL(LY,RY)-10);
          Ydodo:=DtUy(GetMaxY-MaxL(LY,RY)-10);
          if YisLog then begin Yodod:=ALog10(Yodod); Ydodo:=ALog10(Ydodo) end;
          if IsMouse then Mouse.Done;
          LeaveGraphic;
          goto NewDraw;
          end;
     'R': begin LeaveGraphic; goto ReDrawIt end;
     'M': if IsMouse and MouseEnableUserUnits then
          begin
          sound(220); delay(159); nosound;
          {$I-}
          assign(Out,'mouse.dat'); append(Out);
          if IOresult<>0 then rewrite(Out);
          Cpom:=#0; RButton:=-1;
          {v RButton, RX, RY je predchozi button a jeho pozice}
          repeat
          with Mouse do
          if PocetStisku(0,LX,LY)<>0 then InsertMouseClick(0) else
          if PocetStisku(1,LX,LY)<>0 then InsertMouseClick(1) else
          if PocetStisku(2,LX,LY)<>0 then InsertMouseClick(2) else
             if keypressed then
               begin Cpom:=ReadKey;
               if (Cpom<>#$1B) and (length(Smouse)<255) then Smouse:=Smouse+Cpom;
               end;
          until Cpom=#$1B;
          InsertMouseClick(RButton);
          close(Out); {$I+}
          end;
     'L': if (isYLinLog) or (not(isYLinLog) and (Yodod>0))
            then begin isYLinLog:=not(isYLinLog);
                 LeaveGraphic; goto NewDraw end
            else Beep;
     'S': begin
          KresliXOd:=Xodod; KresliXDo:=Xdodo; { StepX }
          KresliYOd:=Yodod; KresliYDo:=Ydodo; { StepY }
          YLinLog:=(YLinLog and $FE) or (ord(isYLinLog));
          GrafDialogP^.SetData(DialogGrafRec);
          end;
     'H': begin
          if DoMouse then begin IsMouse:=not IsMouse;
          if IsMouse
            then begin TypTabulkyMysi:=whichMouse; Mouse.Init(I) end
            else begin LeaveGraphic; goto NewDraw end
          end end;
     'C': begin IsClipping:=not IsClipping;
          MouseRelativeUnits:=isClipping;
          LeaveGraphic; goto NewDraw end;
     'K': begin J:=whichMouse; whichMouse:=1; TypTabulkyMysi:=whichMouse;
          if not isMouse then begin isMouse:=true; Mouse.Init(I) end
            else if J<>1 then begin LeaveGraphic; goto NewDraw end
          end;
     'P': begin J:=whichMouse; whichMouse:=2; TypTabulkyMysi:=whichMouse;
          if isMouse
            then if J<2 then begin Mouse.Done; Mouse.Init(I) end else
            else begin isMouse:=true; LeaveGraphic; goto NewDraw end;
          end;
     end;

if Pozadi>=128 then
  begin dec(Pozadi,128); SetPalette(0,Pozadi) end;

GoUntil:
until (CC=#$1B) or (CC='Q') or (CC='X');

if IsMouse then Mouse.Done;
LeaveGraphic;

{$IFDEF PMGRAF}
GetMemBump;
{$ENDIF}
DoneKonec:
{$IFDEF PMGRAF}
SetMemTop(Ptr(BufHeapEnd, 0));
{$ENDIF}
InitMemory; InitVideo; InitEvents; InitSysError;
{ writeln('!!! Start of grf: ',MemAvail,'  ',MaxAvail,'  !!!');
  readln; }
if MyScreenMode=43
   then begin SetScreenMode(259);  end
   else begin SetScreenMode(smCO80); end;
ScreenMode:=MyScreenMode;
Application^.Redraw;
end end;


{ --- inicialization --- }
var GraphDriver, GraphMode: Integer;
begin
DetectGraph(GraphDriver,GraphMode);
if GraphResult <> grOk
 then BlackWhite:=false
 else BlackWhite := (GraphDriver = CGA) or (GraphDriver = MCGA) or
      (GraphDriver = EGAMono) or (GraphDriver = HercMono);
end. { TVFibGrf }
