UNIT TVFibHew;
{ c Petr Mikulk - Brno - 1992 }
{ (lokalni) procedury pro handle event }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, crt,
     Objects, Drivers, Memory, Views, Dialogs, Buffers,
     ZprBox, NormDlg, TRuzne, TUnita, Kalk, {FViewU,} App1,
     DefFloat, ElFun, PmElFun, Graf094,
     TVFibDef, TVFibIni, TVFibDat, {TVFibEd,} TVFibGrf, Editor,
     TVFibGra, pmparser, TVFibHev;


type

  TLastApp = object ( TFibHevApp ) end;

  PFibHewApp = ^ TFibHewApp;
  TFibHewApp = object ( TLastApp )
    procedure ChangeEpsonMode;
    procedure PrintPCL;
    procedure SaveGraphDeskGDT ( Name: PathStr );
    procedure SaveGraphDesk;
    procedure LoadGraphDeskGDT ( Name: PathStr );
    procedure LoadGraphDesk;
    procedure GraphAutoScale;
    procedure MakeIntegration;
    procedure DoGnuplot;
    procedure ChangeGraphModeText;
    procedure AskChangeGraphMode;
    end;


IMPLEMENTATION

{ --- TFibHewApp --- }

procedure TFibHewApp.ChangeEpsonMode;
begin
ExecDialog(new(PLongIntDialog,Init('','Enter Epson Mode',16,0,255)),@EpsonMode)
end;

procedure TFibHewApp.PrintPCL;
const Name: PathStr='OBR*.DAT';
var Inp, Out: file; Blok: string[255]; K,L: word;
begin
if ExecDialog(new(PFileDialog,Init('OBR*.DAT','Print (PCL) file: copy /b file prn','~N~ame',fdOpenButton,100)),@Name)
  = cmCancel then exit;
if not(FileExist(Name)) then exit;
DosCommand('copy /b '+Name+' prn','Printing...',false);
end;


procedure TFibHewApp.SaveGraphDeskGDT ( Name: PathStr );
var Out: file; W,WW: word;
begin
if GrafDialogP<>nil then GrafDialogP^.GetData(DialogGrafRec); W:=0;
{$I-} assign(Out,Name); rewrite(Out,1);
WW:=IOresult;
{ if WW<>0 then exit; }
(*
if (DialogGrafRec.GrafOpts and 16)=0
  then DialogGrafRec.GrafOpts:=DialogGrafRec.GrafOpts or word(16)
  else DialogGrafRec.GrafOpts:=DialogGrafRec.GrafOpts and not word(16);
*)
BlockWrite(Out,DialogGrafRec,word(SizeOf(DialogGrafRec)),W);
BlockWrite(Out,EpsonMode,word(SizeOf(EpsonMode)),W);
BlockWrite(Out,DosCommandI,word(SizeOf(DosCommandI)),W);
BlockWrite(Out,DosLoadI,word(SizeOf(DosLoadI)),W);
BlockWrite(Out,DosLoadNum,word(SizeOf(DosLoadNum)),W);
BlockWrite(Out,TabSpaces,word(SizeOf(TabSpaces)),W);
BlockWrite(Out,TeXkbdOn,word(SizeOf(TeXkbdOn)),W);
BlockWrite(Out,Pozadi,SizeOf(Pozadi));
BlockWrite(Out,Popredi,SizeOf(Popredi));
BlockWrite(Out,BlackWhite,SizeOf(BlackWhite));
BlockWrite(Out,YesSaveBeforeDOS,SizeOf(YesSaveBeforeDOS));
BlockWrite(Out,GrErrorSkip,SizeOf(GrErrorSkip));
BlockWrite(Out,TheGrMode,SizeOf(TheGrMode));
BlockWrite(Out,UseSVGA,SizeOf(UseSVGA));
close(Out);
WW:=IOresult; {$I+}
end;

procedure TFibHewApp.SaveGraphDesk;
const Name: PathStr='*.gdt'; var Out: file; B: boolean;
begin
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
B:=ExecDialog(new(PFileDialog,Init('*.gdt','Save graph desktop','~N~ame',fdOpenButton,100)),@Name) = cmCancel;
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
if B then exit;
SaveGraphDeskGDT ( Name )
end;

procedure TFibHewApp.LoadGraphDeskGDT (Name: PathStr );
var Inp: file; W: word;
begin
{$I-} assign(Inp,Name); reset(Inp,1); W:=0;
if IOresult<>0 then exit;
BlockRead(Inp,DialogGrafRec,word(SizeOf(DialogGrafRec)),W);
(*
if (DialogGrafRec.GrafOpts and 16)=0
  then DialogGrafRec.GrafOpts:=DialogGrafRec.GrafOpts or word(16)
  else DialogGrafRec.GrafOpts:=DialogGrafRec.GrafOpts and not word(16);
*)
BlockRead(Inp,EpsonMode,word(SizeOf(EpsonMode)),W);
BlockRead(Inp,DosCommandI,word(SizeOf(DosCommandI)),W);
BlockRead(Inp,DosLoadI,word(SizeOf(DosLoadI)),W);
BlockRead(Inp,DosLoadNum,word(SizeOf(DosLoadNum)),W);
BlockRead(Inp,TabSpaces,word(SizeOf(TabSpaces)),W);
BlockRead(Inp,TeXkbdOn,word(SizeOf(TeXkbdOn)),W);
MakeLatexKbd(false); MakeLatexKbd(false);
BlockRead(Inp,Pozadi,SizeOf(Pozadi));
BlockRead(Inp,Popredi,SizeOf(Popredi));
BlockRead(Inp,BlackWhite,SizeOf(BlackWhite));
BlockRead(Inp,YesSaveBeforeDOS,SizeOf(YesSaveBeforeDOS));
BlockRead(Inp,GrErrorSkip,SizeOf(GrErrorSkip));
MakeSaveBeforeDOS; MakeSaveBeforeDOS;
MakeGrErrorSkip; MakeGrErrorSkip;
if not eof(Inp) then begin
  BlockRead(Inp,TheGrMode,SizeOf(TheGrMode));
  ChangeGraphModeText;
  BlockRead(Inp,UseSVGA,SizeOf(UseSVGA));
  end;
{ ScreenMode se nezapisuje ! }
close(Inp); {$I+}
if GrafDialogP<>nil then GrafDialogP^.SetData(DialogGrafRec);
end;

procedure TFibHewApp.LoadGraphDesk;
const Name: PathStr='*.gdt'; var Inp: file; B: boolean;
begin
FreeMemBump; SetMemTop(Ptr(BufHeapPtr, 0));
B:=ExecDialog(new(PFileDialog,Init('*.gdt','Load graph desktop','~N~ame',fdOpenButton,100)),@Name) = cmCancel;
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
if B then exit;
LoadGraphDeskGDT ( Name )
end;


procedure TFibHewApp.GraphAutoScale;
var X,Xmin,Xmax,Y,Ymin,Ymax,Z,Zmin,Zmax: float;
I,IndFrom,IndTo,PosInd,Pos1,Pos11,ColumnX,ColumnY,ColumnZ: integer;
PomStr,Name: PathStr; Skip2lines,B1,Draw3D,Was3D: boolean;
FromLine,FromScan: longint;
const RadToVt = 3600*180/pi;
 procedure AutoScaleDPR;
 var Inp: file; I: integer;
 begin if not FileExist(Name) then exit;
 assign(Inp,Name); reset(Inp,1);
 BlockRead(Inp,ZpracHodnot,2);
 BlockRead(Inp,X,6); Xmin:=MinF(Xmin,X);
 BlockRead(Inp,X,6); Xmax:=MaxF(Xmax,X);
 for I:=1 to ZpracHodnot do
   begin BlockRead(Inp,X,6);
   Ymin:=MinF(Ymin,X); Ymax:=MaxF(Ymax,X) end;
 close(Inp) end;

 procedure AutoScaleInd;
 var AInp: text; K: integer; LL: longint;
 R: float; label Skoncime, ReadNextLine;
 begin
 if Draw3D then Was3D:=true;
 if (isFromWhich=isFromFormula) or ((isFromWhich=isFromFile) and FileExist(Name))
 then begin
 {$I-} assign(AInp,Name); reset(AInp);
 if not Skip2lines then begin readln(AInp); readln(AInp) end;
 for LL:=1 to FromLine-1 do
   begin
   readln(AInp);
   if eof(AInp) then goto Skoncime;
   end;
 for LL:=1 to FromScan-1 do
   begin
   while eoln(AInp) do begin readln(AInp);
         if eof(AInp) then goto Skoncime end;
   while not eoln(AInp) do begin readln(AInp);
         if eof(AInp) then goto Skoncime end;
   end;
 if Draw3D then MaxColumn:=MaxL(MaxColumn,ColumnZ);
 TheLine[0]:=0;
 while not eof(AInp) and not(KeyPressed and (ReadKey=#$1B)) do
  begin
  ReadNextLine:
  if eof(AInp) then goto Skoncime;
  (*
  K:=1;
  repeat
  if eoln(AInp) then
    begin K:=1; repeat readln(AInp) until eof(AInp) or not(eoln(AInp)) end;
  if not eof(AInp) then
    begin read(AInp,R);
    if IOresult<>0 then goto Skoncime;
    if K=ColumnX then X:=R;
    if K=ColumnY then Y:=R; inc(K) end;
  until ((K>ColumnX) and (K>ColumnY)) or eoln(AInp);
  *)
  (**
  for K:=1 to MaxColumn do
    begin read(AInp,TheLine[K]);
    if IOresult<>0 then if boolean(GrErrorSkip) then
      begin readln(AInp); goto ReadNextLine end else goto Skoncime;
    if (K<MaxColumn) then
      if eoln(AInp) then goto ReadNextLine
        else if eof(AInp) then goto Skoncime;
    end;
  **)
  case ReadFormTheLine(AInp) of
    1: goto ReadNextLine;
    2: goto Skoncime;
    end;
  readln(AInp);
  X:=TheLine[ColumnX]; Y:=TheLine[ColumnY];
  Xmin:=MinF(Xmin,X); Xmax:=MaxF(Xmax,X);
  Ymin:=MinF(Ymin,Y); Ymax:=MaxF(Ymax,Y);
  if Draw3D then
    begin
    Z:=TheLine[ColumnZ];
    Zmin:=MinF(Zmin,Z); Zmax:=MaxF(Zmax,Z);
    end;
  end;
 Skoncime: close(AInp) {$I+}
 end end;

var Inp3d: text; iii: integer; Posuny: PathStr;
    Halda: pointer; Bool1: boolean;
label NextFor, Konec;
begin
{$I-}
HighVideo; TextBackground(black); TextColor(blink+yellow);
Posuny:='                ';
gotoxy(34,10); write(Posuny); gotoxy(34,12); write(Posuny);
gotoxy(34,11); system.write(' AUTOSCALING... ');
{$I+}
DeskTop^.HideCursor;
GrafDialogP^.GetData(DialogGrafRec);
Xmin:=_maxflt; Xmax:=-_maxflt;
Ymin:=_maxflt; Ymax:=-_maxflt;
Zmin:=_maxflt; Zmax:=-_maxflt;
Was3D:=false; Mark(Halda);
if (ZpracHodnot<>0) and (HodnotyEtha<>nil) and (HodnotyIntenzity<>nil) then
  for I:=1 to ZpracHodnot do  { AutoScaleZPameti }
    begin Xmin:=MinF(Xmin,RadToVt*HodnotyEtha^[I]); Xmax:=MaxF(Xmax,RadToVt*HodnotyEtha^[I]);
    Ymin:=MinF(Ymin,HodnotyIntenzity^[I]); Ymax:=MaxF(Ymax,HodnotyIntenzity^[I])
    end;
with DialogGrafRec do
for I:=1 to MaxGrFiles do
begin
Name:=GrFile[I];
ColumnX:=1; ColumnY:=2;
PosInd:=pos('#',Name);
if (PosInd<>0) then begin
  system.delete(Name,PosInd,1);
  if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
    begin
    ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1);
    if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
      begin ColumnX:=ColumnY;
      ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1) end;
  end end;
MaxColumn:=MaxL(ColumnX,ColumnY);
IndFrom:=0; if Pos1<>0 then IndTo:=9 else if Pos11<>0 then IndTo:=99;
PosInd:=Pos('|',Name);
if PosInd>0 then
  begin PomStr:=Copy(Name,PosInd+1,255); Name[0]:=chr(PosInd-1);
  StringDveCisla(NoSpaces(PomStr),X,Y);
  IndFrom:=round(X); IndTo:=round(Y) end
 else if Name[1]=':' then
  if Draw3D
    then begin IndFrom:=181; IndTo:=181; {211 ok, 5 debug} end
    else begin IndFrom:=211; IndTo:=211; {211 ok, 5 debug} end;
if Name[1]<>'-'
  then Skip2lines:=false
  else begin system.Delete(Name,1,1); Skip2lines:=true end;

Draw3D:=false;
Posuny:=GrFileMove[I];
FromLine:=1;
FromLine:=Pos('[',Posuny); iii:=Pos(']',Posuny);
if not ((FromLine>0) and (iii>FromLine))
  then FromLine:=1
  else begin PomStr:=Copy(Posuny,FromLine+1,iii-FromLine-1);
       system.delete(Posuny,FromLine,iii-FromLine+1);
       val(PomStr,FromLine,iii) end;
FromScan:=1;
FromScan:=Pos('{',Posuny); iii:=Pos('}',Posuny);
if not ((FromScan>0) and (iii>FromScan))
  then FromScan:=1
  else begin PomStr:=Copy(Posuny,FromScan+1,iii-FromScan-1);
       system.delete(Posuny,FromScan,iii-FromScan+1);
       val(PomStr,FromScan,iii) end;
DoDraw3DFormulae( Posuny, Draw3D );

if Name[1]=':'  { FROM FORMULA }
  then DoFromFormula ( Name, Xmin,Xmax, Ymin, Ymax, Draw3D, IndFrom,IndTo )
  else begin
    if (Pos('?',Name)=0) (* and (Pos('*',Name)=0) and (Pos('/',Name)=0) *) then
      if not FileExist(Name) then goto NextFor;
    isFromWhich:=isFromFile;
    end;

if isFromWhich=isFromFile then begin
PosInd:=-1;
Pos1:=0; Pos11:=Pos('??',Name); if Pos11=0 then Pos1:=Pos('?',Name);
IndFrom:=0; if Pos1<>0 then IndTo:=9 else if Pos11<>0 then IndTo:=99;
if Pos1<>0 then Name[Pos1]:=#47;
if Pos11<>0 then begin Name[Pos11]:=#48; Name[Pos11+1]:=#47 end;
if GrFile[I]<>'' then begin
end end;

Bool1:=true;
repeat
B1:=true;
if isFromWhich=isFromFile then
if (Pos1=0) and (Pos11=0) then if not FileExist(Name) then goto NextFor else
  else
  repeat inc(PosInd);
  if Pos1<>0 then inc(byte(Name[Pos1])) else
    { if Pos11<>0 then }
    if Name[Pos11+1]='9'
      then begin inc(byte(Name[Pos11])); Name[Pos11+1]:='0' end
      else inc(byte(Name[Pos11+1]));
  if PosInd>IndTo then goto NextFor;
  B1:=FileExist(Name);
  until (PosInd>=IndFrom) and ( ((Pos1<>0) or (Pos11<>0)) and (PosInd<=IndTo)) and B1;
if B1 then
  begin
  if Draw3D and Bool1 then
     if isFromWhich=isFromFormula then ColumnZ:=3 else
     begin
     assign(Inp3d,'pmgraf.3d'); reset(Inp3d);
     if IOresult<>0 then
       begin ZpravaBox('','File PMGRAF.3D not found.',nil,mfYesButton+mfNoButton);
       goto Konec end;
     readln(inp3d,ColumnZ);
     if IOresult<>0 then
       begin ZpravaBox('','Bad Z column in file PMGRAF.3D',nil,mfYesButton+mfNoButton);
       close(inp3d);
       goto Konec end;
     close(inp3d);
     end;
  Bool1:=false;
  if GetExtension(Name)='DPR' then AutoScaleDPR
    else AutoScaleInd;
    end;
if (Pos1<>0) and (PosInd=IndTo) then Pos1:=0;
if (Pos11<>0) and (PosInd=IndTo) then Pos11:=0;
if isFromWhich=isFromFormula then goto NextFor;
until (Pos1=0) and (Pos11=0);
NextFor:
end;
if Xmin > Xmax then begin Xmin:=0; Xmax:=1 end; {no file given}
if Ymin > Ymax then begin Ymin:=0; Ymax:=1 end;
GrafDialogP^.GetData(DialogGrafRec);
with DialogGrafRec do begin
KresliXOd:=Xmin; KresliXDo:=Xmax;
KresliYOd:=Ymin; KresliYDo:=Ymax;
if (KresliXOd<=0) and (XLinLog=1) then
  begin KresliXOd:=1e-8;
  if KresliXDo<KresliXOd then KresliXDo:=1 end;
if (KresliYOd<=0) and (YLinLog=1) then
  begin KresliYOd:=1e-8;
  if KresliYDo<KresliYOd then KresliYDo:=1 end;
if (Xzadanov=0) and (DataNaX<>0)
  then begin KresliXOd:=DegToDMS(KresliXOd/3600);
  KresliXDo:=DegToDMS(KresliXDo/3600) end;
StepX:=0; StepY:=0;
GrafDialogP^.SetData(DialogGrafRec);
if Was3D then
  ZpravaBox('Refresh PMGRAF.3D yourself',
    'Z data:'#$D+
    'minimum = '+StrEng(Zmin,1,6)+#$D+
    'maximum = '+StrEng(Zmax,1,6) { +#$D#3+  }
    ,nil,mfOkButton);
end;
Konec: release(Halda);
DeskTop^.ReDraw;
end;


procedure TFibHewApp.MakeIntegration;
begin
ZpravaBox('Sorry','To be done in future (?)',nil,mfOKButton);
end;


procedure TFibHewApp.DoGnuplot;
function StrOut ( X: real ): PathStr;
var S: PathStr; I,K: integer; Halda: pointer;
begin S:=StrEng(X,1,6);
I:=Pos('e',S);
if I=0 then begin while S[length(S)]='0' do dec(byte(S[0]));
            if S[length(S)]='.' then dec(byte(S[0])) end
  else begin
  K:=i-1;
  if S[K]='0' then
    begin
    while S[K-1]='0' do dec(K);
    if S[K-1]='.' then dec(K);
    repeat S[K]:=S[i]; inc(K); inc(i)
    until i>length(S);
    S[0]:=char(K-1);
    end
  end;
StrOut:=S
end;
const FileName: PathStr='*.gnu';
const GnuL: longint=3;
var Out: text; X,Y: real;
BigSizeRequest, Skip2lines, DrawIt3D, B1: boolean;
Name,S,PomStr: string;
I,PlotNumber,ColumnX,ColumnY,PosInd,IndFrom,IndTo,Pos1,Pos11: integer;
var CurveType: char; Posuny: PathStr;
isFormula,MulPoprve,IsLinTransf,IsShow,IsWait,IsWaitScan,Points: boolean;
ShowVer,ShowAndWait,EveryNth,ThisEveryNth,ii: integer;
FromLine,FromScan: longint;
Xplus,Xkrat,Yplus,Ykrat,mulXplus,mulXkrat,mulYplus,mulYkrat: real;
C: char; Halda: pointer;
label NextFor,LabFormula;
begin
if GrafDialogP<>nil then GrafDialogP^.GetData(DialogGrafRec);
if ExecDialog(new(PFileDialog,Init('*.gnu','gnuplot file','~N~ame',fdOpenButton,100)),@FileName) = cmCancel then exit;
assign(Out,FileName);
{$I-} rewrite(Out); if IOresult<>0 then exit;
mark(Halda);
BigSizeRequest:=false;
writeln(Out,'#set output "x.out"');
S:='#set terminal ';
writeln(Out,S,'emtex',crlf,S,'latex',crlf,S,'pcl',crlf,
  S,'hpgl',crlf,S,'postscript');
with DialogGrafRec do
  begin
  writeln(Out,'set nozero');
  writeln(Out,'set xrange [ ',StrOut(KresliXOd),' : ',StrOut(KresliXDo),' ]');
  if StepX<>0 then writeln(Out,'set xtics ',StrOut(KresliXOd),',',StrOut(StepX));
  if boolean(XLinLog) then writeln(Out,'set log x');
  writeln(Out,'set yrange [ ',StrOut(KresliYOd),' : ',StrOut(KresliYDo),' ]');
  if StepY<>0 then writeln(Out,'set ytics ',StrOut(KresliYOd),',',StrOut(StepY));
  if YLinLog and 1=1 then writeln(Out,'set log y');
  if GridStr<>'00' then writeln(Out,'set grid');
(*  if {!isClipping} (DialogGrafRec.GrafOpts and 8) = 0 then writeln(Out,'set noclip')
    else writeln(Out,'set clip points; set clip one');
*)
  writeln(Out,'set clip points; set clip one');
  if AngleLabel<>'' then writeln(Out,'set xlabel "',AngleLabel,'"');
  if IntensLabel<>'' then writeln(Out,'set ylabel "',IntensLabel,'"');
  if Nadpis<>'' then writeln(Out,'set title "',Nadpis,'"');
{   at    NadpisPos: '.08,.91' }
{ writeln(Out,'set key ',X*640,',',Y*480); }
  StringDveCisla(GrafPoznPos,X,Y);
  if GrafPozn<>'' then begin
    write(Out,'set label "',GrafPozn,'" at ');
    if XlinLog and 1=0 then X:=KresliXod+X*(KresliXdo-KresliXod)
      else X:=alog10(log10(KresliXod)+X*(log10(KresliXdo)-log10(KresliXod)));
    write(Out,StrOut(X),',');
    if YlinLog and 1=0 then Y:=KresliYod+Y*(KresliYdo-KresliYod)
      else
      Y:=alog10(log10(KresliYod)+Y*(log10(KresliYdo)-log10(KresliYod)));
    writeln(Out,StrOut(Y));
    end;
  StringDveCisla(FilyPos,X,Y);  write(Out,'set key ');
  if XlinLog and 1=0 then X:=KresliXod+X*(KresliXdo-KresliXod)
    else X:=alog10(log10(KresliXod)+X*(log10(KresliXdo)-log10(KresliXod)));
  write(Out,StrOut(Y),',');
  if YlinLog and 1=0 then Y:=KresliYod+Y*(KresliYdo-KresliYod)
    else Y:=alog10(log10(KresliYod)+Y*(log10(KresliYdo)-log10(KresliYod)));
  writeln(Out,StrOut(Y));

{ -- now plot files -- }
PlotNumber:=0;
for I:=1 to MaxGrFiles do
begin
Name:=GrFile[I]; Posuny:=GrFileMove[I];
ColumnX:=1; ColumnY:=2;
PosInd:=pos('#',Name);
if (PosInd<>0) then begin
  system.delete(Name,PosInd,1);
  if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
    begin
    ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1);
    if (PosInd<=length(Name)) and (Name[PosInd] in ['0'..'9']) then
      begin ColumnX:=ColumnY;
      ColumnY:=ord(Name[PosInd])-48; system.delete(Name,PosInd,1) end;
  end end;
IndFrom:=0; if Pos1<>0 then IndTo:=9 else if Pos11<>0 then IndTo:=99;
PosInd:=Pos('|',Name);
if PosInd>0 then
  begin PomStr:=Copy(Name,PosInd+1,255); Name[0]:=chr(PosInd-1);
  StringDveCisla(NoSpaces(PomStr),X,Y);
  IndFrom:=round(X); IndTo:=round(Y) end;
if Name[1]<>'-'
  then Skip2lines:=false
  else begin system.Delete(Name,1,1); Skip2lines:=true end;
PosInd:=-1;
Pos1:=0; Pos11:=Pos('??',Name); if Pos11=0 then Pos1:=Pos('?',Name);
IndFrom:=0; if Pos1<>0 then IndTo:=9 else if Pos11<>0 then IndTo:=99;
if Pos1<>0 then Name[Pos1]:=#47;
if Pos11<>0 then begin Name[Pos11]:=#48; Name[Pos11+1]:=#47 end;

IsShow:=false; IsWait:=false; IsWaitScan:=false; CurveType:=' '; 
Posuny:=UpString(Posuny);
MaxColumn:=2; { pri autoscale ale neni treba }
if Name[1]<>':' then DoDraw3DFormulae(Posuny,DrawIt3D);
ShowVer:=Pos('V',Posuny);
if ShowVer<>0 then system.delete(Posuny,ShowVer,1); {and ShowVertically is non-zero}
ShowAndWait:=Pos('H',Posuny);
if ShowAndWait<>0 then system.delete(Posuny,ShowAndWait,1);
EveryNth:=Pos('(',Posuny); ThisEveryNth:=Pos(')',Posuny);
if not ((EveryNth>0) and (ThisEveryNth>EveryNth))
  then EveryNth:=1
  else begin PomStr:=Copy(Posuny,EveryNth+1,ThisEveryNth-EveryNth-1);
       system.delete(Posuny,EveryNth,ThisEveryNth-EveryNth+1);
       val(PomStr,EveryNth,ThisEveryNth) end;
ThisEveryNth:=1; FromLine:=1;
FromLine:=Pos('[',Posuny); ii:=Pos(']',Posuny);
if not ((FromLine>0) and (ii>FromLine))
  then FromLine:=1
  else begin PomStr:=Copy(Posuny,FromLine+1,ii-FromLine-1);
       system.delete(Posuny,FromLine,ii-FromLine+1);
       val(PomStr,FromLine,ii) end;
FromScan:=1;
FromScan:=Pos('{',Posuny); ii:=Pos('}',Posuny);
if not ((FromScan>0) and (ii>FromScan))
  then FromScan:=1
  else begin PomStr:=Copy(Posuny,FromScan+1,ii-FromScan-1);
       system.delete(Posuny,FromScan,ii-FromScan+1);
       val(PomStr,FromScan,ii) end;
ii:=pos('P',Posuny);
if ii=0 then
  begin ii:=pos('O',Posuny);
  BigSizeRequest:=BigSizeRequest or (ii<>0) end;
if (Posuny='') or (ii=0)   { Posuny[1]<>'P' }
  then Points:=false
  else begin Points:=true; system.delete(Posuny,ii,1) end;
if Points then CurveType:='N' else CurveType:='C';
ii:=pos('C',Posuny); if ii<>0 then CurveType:='C' else begin
  ii:=pos('B',Posuny); if ii<>0 then CurveType:='B' else begin
    ii:=pos('N',Posuny); if ii<>0 then CurveType:='N'; end end;
if ii<>0 then system.delete(Posuny,ii,1);
ii:=pos('S',Posuny);
IsShow:=I<>0; if IsShow then system.delete( Posuny,ii,1 );
if ShowAndWait<>0 then IsShow:=true;
ii:=pos('W',Posuny);
IsWait:=(Posuny<>'') and (ii<>0);
  if IsWait then system.delete( Posuny,ii,1 );
ii:=pos('T',Posuny);
IsWaitScan:=(Posuny<>'') and (ii<>0);
  if IsWaitScan then system.delete( Posuny,ii,1 );
{ manage linear transformation }
if length(Posuny)=0
  then begin IsLinTransf:=false;
    mulXplus:=0; mulXkrat:=1; mulYplus:=0; mulYkrat:=1 end
  else
  begin IsLinTransf:=true;
  if (length(Posuny)<>0) and (Posuny[length(Posuny)]<>',')
    then Posuny:=Posuny+',';
  StringCtyriCisla ( Posuny, Xplus, Xkrat, Yplus, Ykrat );
  StringCtyriCisla ( Posuny, mulXplus, mulXkrat, mulYplus, mulYkrat );
  end;
PosInd:=-1; MulPoprve:=false;

if DrawIt3D then
  begin
  end
  else {!}
repeat  { ** vypis jeden ci vsechny fily ** }
B1:=true; isFormula:=false;
if Name[1]=':' then { formula }
  begin isFormula:=true; system.Delete(Name,1,1); goto LabFormula end;
if (Pos1=0) and (Pos11=0) then if not FileExist(Name) then goto NextFor else
  else
  repeat inc(PosInd);
  if Pos1<>0 then inc(byte(Name[Pos1])) else
    { if Pos11<>0 then }
    if Name[Pos11+1]='9'
      then begin inc(byte(Name[Pos11])); Name[Pos11+1]:='0' end
      else inc(byte(Name[Pos11+1]));
  if PosInd>IndTo then goto NextFor;
  B1:=FileExist(Name);
  until (PosInd>=IndFrom) and ( ((Pos1<>0) or (Pos11<>0)) and (PosInd<=IndTo)) and B1;
if MulPoprve then
  begin Xplus:=Xplus+mulXplus; Xkrat:=Xkrat*mulXkrat;
  Yplus:=Yplus+mulYplus; Ykrat:=Ykrat*mulYkrat;
  end;
MulPoprve:=true;

if B1 then
{  if GetExtension(Name)='DPR' then AutoScaleDPR
    else               }
   begin { Do it ! }
   Name:='"'+Name+'"';
   LabFormula:
   inc(PlotNumber);
   if PlotNumber=1 then write(Out,'plot')
                   else write(Out,',\',CRLF,'    ');
   write(Out,' ',Name,' ');
(**
if not IsLinTransf then
     begin  if (columnx<>1) or (columny<>2) then write(Out,'using ',columnX:1,':',columnY:1,' ');
     end
  else
     write(Out,'( ($',ColumnX:1,'+',StrOut(Xplus),')*',StrOut(Xkrat),
               ' ):( $',ColumnY:1,'*',StrOut(Ykrat),'+',StrOut(Yplus),' )  ');
  {  X:=NA((X+Xplus)*Xkrat*Xnas); Y:=Y*Ykrat+Yplus;  }
**)
if notFormula then
  if not IsLinTransf then
       begin  if (columnx<>1) or (columny<>2) then write(Out,'using ',columnX:1,':',columnY:1,' ');
       end
    else
    {  X:=NA((X+Xplus)*Xkrat*Xnas); Y:=Y*Ykrat+Yplus;  }
    {   write(Out,'using ( ($',ColumnX:1,'+',StrOut(Xplus),')*',StrOut(Xkrat),
                  ' ):( $',ColumnY:1,'*',StrOut(Ykrat),'+',StrOut(Yplus),' )  ')
    } { this is ok, but let's simplify the .gnu writing }
    begin
    write(Out,'using ');
    if Xplus=0 then
        if Xkrat=1 then write(Out,ColumnX:1) else
          write(Out,'($',ColumnX:1,'*',StrOut(Xkrat),')')
        else if Xkrat=1 then write(Out,'($',ColumnX:1,'+',StrOut(Xplus),')')
          else write(Out,'($',ColumnX:1,'+',StrOut(Xplus),')*',StrOut(Xkrat));
    write(Out,':');
    if Ykrat=1 then
        if Yplus=0 then write(Out,ColumnY:1) else
          write(Out,'($',ColumnY:1,'+',StrOut(Yplus),')')
        else if Yplus=0 then write(Out,'($',ColumnY:1,'*',StrOut(Ykrat),')')
          else write(Out,'($',ColumnY:1,'*',StrOut(Ykrat),')+',StrOut(Yplus));
(*                  ' ):( $',ColumnY:1,'+',StrOut(Yplus),'*',StrOut(Ykrat),' )  ')
 *)
   end
 else { with formula }
   if not isFormula then
   begin
   write(Out,'using ');
   case ColumnX of
     1: if FormulaX=nil then S:='$1' else S:=FormulaX^;
     2: if FormulaY=nil then S:='$2' else S:=FormulaY^;
     3: if FormulaZ=nil then S:='$3' else S:=FormulaZ^;
     else S:='$'+char(ColumnX+48);
     end;
   if (length(S)=2) and (S[1]='$')
     then write(Out,S[2])
     else begin
       if not IsLinTransf then write(Out,'( ',S,' )')
         else write(Out,'( ($',S,'+',StrOut(Xplus),')*',StrOut(Xkrat),' )');
       end;
   write(Out,':');
   case ColumnY of
     1: if FormulaX=nil then S:='$1' else S:=FormulaX^;
     2: if FormulaY=nil then S:='$2' else S:=FormulaY^;
     3: if FormulaZ=nil then S:='$3' else S:=FormulaZ^;
     else S:='$'+char(ColumnX+48);
     end;
   if (length(S)=2) and (S[1]='$')
     then write(Out,S[2])
     else begin
       if not IsLinTransf then write(Out,'( ',S,' )')
         else write(Out,'( ($',S,'+',StrOut(Xplus),')*',StrOut(Xkrat),' )');
       end;
   end;

   if not(isFormula) and ((EveryNth<>1) or (FromLine<>1)) then
     begin
     write(Out,' every ');
     if EveryNth<>1 then write(Out,EveryNth);
     if FromLine<>1 then
       begin write(Out,'::'); write(Out,FromLine) end;
     end;

   if not(isFormula) then write(Out,' title ',Name);

   write(Out,' with ');
   S:='';
   case CurveType of
     'C': begin C:='l'; if Points then S:='inesp' end;
     'B': C:='i'; 'N': C:='p';
     end;
   write(Out,C,S,'  ');
   end;
if (Pos1<>0) and (PosInd=IndTo) then Pos1:=0;
if (Pos11<>0) and (PosInd=IndTo) then Pos11:=0;
until (Pos1=0) and (Pos11=0);
NextFor:
end;

(*    GrFile: ('','','','','','');
    GrafOpts: 4;
    GrFileMove: ('','','','','','');
*)
  end;
writeln(Out);
close(Out); {$I+}
release(Halda);
if ExecDialog(new(PLongIntDialog,Init('Final action','1 gnuplot, 2 edit, 3 both',28,1,3)),@GnuL)
   = cmCancel then exit;
if (GnuL and 1)=1  then DosCommand ( 'gnuplot '+FileName, '', false);
if (GnuL and 2)<>0 then OpenEditor(FileName, True);
if BigSizeRequest then
  ZpravaBox('Big size requested','Please add "set pointsize x" as you prefer',nil,mfOkButton);
end;


procedure TFibHewApp.ChangeGraphModeText;
var GraphModeText: string[20];
const x320='320x200'; x200='640x200'; x350='640x350'; x480='640x480';
begin
if ItemGraphMode=nil then exit;
DisposeStr(ItemGraphMode^.Name);
if UseSVGA=1
  then begin
    case TheGrMode of
      0: GraphModeText:=x320; 1: GraphModeText:=x200;
      2: GraphModeText:=x350; 3: GraphModeText:=x480;
      4: GraphModeText:='800x600'; 5: GraphModeText:='1024x768'; end;
    GraphModeText:=GraphModeText+' (SVGA)'
    end
  else
    case TheGrMode of
    0: GraphModeText:=x320; 1: GraphModeText:=x350;
    2: GraphModeText:=x480; end;
ItemGraphMode^.Name:=NewStr( 'Graph ~m~ode '+GraphModeText );
end;

procedure TFibHewApp.AskChangeGraphMode;
var M: integer;
begin
if ExecDialog(new(PLongIntDialog,Init('Graphic driver',
'Enter  0 for EGAVGA,  1 for SVGA',32,0,1)),@UseSVGA)
   = cmCancel then exit;
if UseSVGA=1 then begin
  if ExecDialog(new(PLongIntDialog,Init('Enter graphic mode',
    '0=320x200 1=640x200 2=640x350 3=640x480 4=800x600 5=1024x768',
    60,0,5)),@TheGrMode) = cmCancel then exit end
 else begin
  if TheGrMode>2 then TheGrMode:=2;
  if ExecDialog(new(PLongIntDialog,Init('Enter graphic mode',
'0=640x200  1=640x350  2=640x480',31,0,2)),@TheGrMode)
   = cmCancel then exit; end;
ChangeGraphModeText;
end;

end. { TVFibHew }
