UNIT TVFibHlp;
{ c Petr Mikulk - Brno - 1992/4 }
{ (lokalni) procedury pro help od handle event }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, crt,
     Objects, Drivers, Memory, Views, Dialogs, Buffers,
     ZprBox, NormDlg, TRuzne, TUnita, Kalk, App1,
     DefFloat, ElFun, PmElFun,
     TVFibDef, TVFibIni, TVFibDat, {TVFibEd,} TVFibGrf, Editor;


{ Read-only window: }

type
  PROEditWindow = ^TROEditWindow;
  TROEditWindow = object(TEditWindow)
    isReadOnly: boolean;
    constructor Init(var Bounds: TRect;
      FileName: FNameStr; ANumber: integer);
    { procedure close; virtual; }
    { Load a Store not provided }
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure SetState(AState: Word; Enable: boolean); virtual;
  end;


type

  TLastApp = object ( TFibGrafApp ) end;

  PFibHlpApp = ^ TFibHlpApp;
  TFibHlpApp = object ( TLastApp )
    function OpenROEditor(FileName: FNameStr; Visible: boolean): PROEditWindow;
    procedure Help ( Proh: boolean );
    procedure Help2;
    end;


IMPLEMENTATION

constructor TROEditWindow.Init(var Bounds: TRect;
      FileName: FNameStr; ANumber: integer);
begin
TEditWindow.Init(Bounds,FileName,ANumber);
isReadOnly:=true;
Palette:=wpCyanWindow;
end;

procedure TROEditWindow.HandleEvent(var Event: TEvent);
begin
if isReadOnly then
  with Editor^ do
  begin Modified:=false; { Modified:=Modified and not isReadOnly; }
  if State=2163 then SetCmdState(cmSave, false);
  end;
with Event do
if isReadOnly and ((What=evKeyDown) and
    (CharCode in [#9,#$A,#$D,#32..#255,^g,^T,^Y,^H]))
    or ((What=evKeyDown) and (KeyCode=kbDel))
    or ((What=evCommand) and ((Command=cmSave) or (Command=cmCut)
         or (Command=cmClear) or (Command=cmPaste)))
  then ClearEvent(Event)
  else TEditWindow.HandleEvent(Event);
end;

procedure TROEditWindow.SetState(AState: Word; Enable: boolean);
begin
TEditWindow.SetState(AState, Enable);
case AState of
      sfActive: Editor^.SetCmdState(cmSave, false);
{     sfFocused: Editor^.SetCmdState(cmSave, false);
      sfExposed: Editor^.SetCmdState(cmSave, false);
      if Enable then Unlock; }
     end;
end;


function TFibHlpApp.OpenROEditor(FileName: FNameStr; Visible: boolean): PROEditWindow;
{ identicke to TEditorApp.OpenEditor }
var P: PWindow; R: TRect; I: integer;
begin
  I:=0;
  repeat inc(I);
  P:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(I))
  until P=nil;
  if not Visible then I:=0;
  DeskTop^.GetExtent(R); inc(R.A.Y,I-1);
  PView(P) := Application^.ValidView(new(PROEditWindow,
    Init(R, FileName, I { WinNumber wnNoNumber} )));
  if not Visible then P^.Hide;
  DeskTop^.Insert(P);
  OpenROEditor := PROEditWindow(P);
  { P^.Zoom; }
end;


{ ============================= }

procedure TFibHlpApp.Help ( Proh: boolean );
const Name: PathStr='PMGRAF.HLP';
var PF: PROEditWindow; P: PWindow; I: integer; label Konec;
begin
I:=0;
  repeat inc(I);
  P:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(I))
  until (P=nil) or (I=30) or (typeof(P^)=typeof(TROEditWindow));
if (P<>nil) and (typeof(P^)=typeof(TROEditWindow)) then
  begin P^.Select; exit end;
ZpravaBox('Program   P M G R A F',#3'Petr Mikulk'#$D#3+
  'Department of Solid State Physics'+#$D#3+
  'Masaryk University           Brno'+#$D#3+
  '(PMGRAF version September 1995)',nil,mfOkButton);
if not FileExist(Name) then
  Name:=Copy(ParamStr(0),1,length(ParamStr(0))-3)+'HLP';
{ if Proh then Prohlidni(Name); }
if Proh then
  begin
{  SetMemTop(Ptr(BufHeapPtr, 0));
  FreeMemBump; }
  if not FileExist(Name) then
    begin ZpravaBox('','File '+Name+' not found.',nil,mfWarning+mfOkButton);
    goto Konec end;
  { PF:=new(PROEditWindow,Init(Name)); PF^.Palette:=wpCyanWindow;
    DeskTop^.Insert(PF); }
  { PF:=} OpenROEditor(Name,true);
  Konec:
{  GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0)); }
  end;
end;


procedure TFibHlpApp.Help2;
begin
TextColor(yellow); TextBackground(blue); ClrScr;
writeln('                         Some more help for LaTeX commands:',crlf,crlf,
'New macros to standard editor if LaTeX keyboard is on: press combination',crlf,
'ALT-capital letter:',crlf,
'Roman  Bold face  Italic  Vector  A - 1character bold face  Sans serif',crlf,
'small Caps  sLanted  E upperscript   X subscript  Typewriter  Greek',crlf,
'perpKolmitko  Parallel  J calligraphic',crlf,
'Menu:   Alt-W  size   Alt-Z  \begin \end' ,crlf,crlf,
'Enjoy this program !');
repeat until KeyPressed; ReadKey;
Application^.Redraw
end;


end. { of TVFibHlp }
