UNIT TVFibIni;
{ inicializace }
{ c Petr Mikulk - Brno - 1992 }
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses dos, crt,
     DefFloat, PmElFun, ElFun,
     Objects, Drivers, Memory, Views, Dialogs, Menus,
     Vstupy, Editor, ZprBox, TUnita, TRuzne, App1,
     TVFibDef;


type

  TLastApp = object ( TTimeApp ) end;

  TFibIniApp = object ( TLastApp )
    GrafDialogP: PMyDialog;
    ItemGrErrorSkip: PMenuItem;
    ItemSaveBeforeDOS: PMenuItem;
    ItemLatexKbd: PMenuItem;
    ItemGraphMode: PMenuItem;
    function MakeGrafDialog: PMyDialog;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
    end;


function GetGrErrorSkipstring: TMenuStr;
function GetSaveBeforeDOSstring: TMenuStr;
function GetLatexKbdstring: TMenuStr;

IMPLEMENTATION


{ --- }

function GetGrErrorSkipstring: TMenuStr;
begin
if boolean(GrErrorSkip)
  then GetGrErrorSkipstring:='Skip ~b~ad lines in files'
  else GetGrErrorSkipstring:='Stop graph if ~b~ad line'
end;

function GetSaveBeforeDOSstring: TMenuStr;
begin
if YesSaveBeforeDOS
  then GetSaveBeforeDOSstring:='Sa~v~e files before DOS call'
  else GetSaveBeforeDOSstring:='Don''t sa~v~e all before DOS'
end;

function GetLatexKbdstring: TMenuStr; var S: string[2];
begin
if TeXkbdOn then S:='n' else S:='ff';
GetLatexKbdstring:='~L~aTeX macros are o'+S;
end;

procedure TFibIniApp.InitMenuBar;
const N=''; var R: TRect; GrafMenuItem: PMenuItem;
begin
ItemGrErrorSkip:=NewItem(GetGrErrorSkipstring,N,0,cmGrErrorSkip,0,nil);
ItemSaveBeforeDOS:=NewItem(GetSaveBeforeDOSstring,N,0,cmSaveBeforeDOS,0,nil);
ItemLatexKbd:=NewItem(GetLatexKbdString, '', kbNoKey, cmLatexKbd, hcNoContext,ItemSaveBeforeDOS);
ItemGraphMode:=nil;
if not GrafDialogEnable then GrafMenuItem:=nil else
  begin
  ItemGraphMode:=NewItem('aha',N,0,cmGraphMode,0,
        NewItem('Epson mod~e~',N,0,cmEpsonMode,0,
        NewItem('~P~rint (binary) file',N,0,cmPrintPCL,0,
        NewItem('export to gnuplo~t~',N,0,cmGnuplot,0,
        NewLine(
        ItemGrErrorSkip )))));
    GrafMenuItem:=NewSubMenu('~D~ata',hcNoContext,NewMenu(
      NewItem('~R~ead file to memory',N,kbF3,cmVytahni,hcReadToMemory,
      NewItem('Export ~A~SCII',N,0,cmExportASCII,0,
      NewItem('Export D~P~R',N,0,cmUloz,0,
      NewItem('Export DN~R~',N,0,cmExportDNR,0,
      NewItem('~C~lear memory from data',N,0,cmFreeData,0,
      NewLine(
      NewItem('~N~ormalise y data',N,0,cmNormalizuj,0,
      NewItem('Add and multiply ~x~ data',N,0,cmVynasobx,0,
      NewItem('Add and multiply ~y~ data',N,0,cmVynasoby,0,
{      NewItem('Integration',N,0,cmIntegration,0, }
{      NewItem('S~w~itch off computer',N,0,cmSwitchOffMin,0, }
      nil)))))))))) { ) },
    NewSubMenu('~G~raph',hcNoContext,NewMenu(
      NewItem('~G~raph','F4',kbF4,cmGraf,0,
      NewItem('Graph ~a~utoscale',N,0,cmGraphAutoscale,0,
      NewItem('~S~ave graph desktop',N,0,cmSaveGraphDesk,0,
      NewItem('~L~oad graph desktop',N,0,cmLoadGraphDesk,0,
      NewLine(
      ItemGraphMode )))))),
    NewItem('~1~','Alt-F1',kbAltF1,cmDos1Graf,hcDosGraf12,  (* F11 and F12 keys undef? *)
    NewItem('~2~',N,kbAltF2,cmDos2Graf,hcDosGraf12,
    NewItem('~3~',N,0,cmDos3Graf,hcDosGraf3,
    nil)))));
  end;
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~iles', hcNoContext, NewMenu(
      NewItem('~O~pen...', 'F3', kbF3, cmOpen, hcNoContext,
      NewItem('Open ~T~eX...', 'Shift-F3', kbShiftF3, cmOpenTeX, hcNoContext,
      NewItem('Open ~F~or...', '', kbNoKey, cmOpenFor, hcNoContext,
      NewItem('~N~ew', '', kbNoKey, cmNew, hcNoContext,
      NewItem('~S~ave', 'F2', kbF2, cmSave, hcNoContext,
      NewItem('S~a~ve as...', '', kbNoKey, cmSaveAs, hcNoContext,
      NewItem('Save a~l~l...', '', kbNoKey, cmSaveAll, hcNoContext,
{      NewItem('~V~iew file',N,0,cmShowFile,0, }
      NewItem('~C~hange dir...', '', kbNoKey, cmChangeDir, hcNoContext,
      NewLine(
      NewItem('~D~OS shell', '', kbNoKey, cmDosShell, hcNoContext,
      NewItem('DOS co~m~mand', 'Ctrl-F9', kbCtrlF9, cmDosCmd, hcNoContext,
      NewItem('Command ~1~', 'Ctrl-F1', kbCtrlF1, cmDos1, hcNoContext,
      NewItem('Command ~2~', 'Ctrl-F2', kbCtrlF2, cmDos2, hcNoContext,
      NewItem('Command ~3~', 'Ctrl-F3', kbCtrlF3, cmDos3, hcNoContext,
      NewItem('Set commands 1~-~3', '', kbNoKey, cmDosSet, hcNoContext,
      NewLine(
      NewItem('~H~elp', 'F1', kbF1, cmHelp, hcNoContext,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmKonec, hcNoContext,
      nil))))))))))))))))))),
    NewSubMenu('~E~dit', hcNoContext, NewMenu(
      NewItem('~U~ndo', '', kbNoKey, cmUndo, hcNoContext,
      NewLine(
      NewItem('Cu~t~', 'Shift-Del', kbShiftDel, cmCut, hcNoContext,
      NewItem('~C~opy', 'Ctrl-Ins', kbCtrlIns, cmCopy, hcNoContext,
      NewItem('~P~aste', 'Shift-Ins', kbShiftIns, cmPaste, hcNoContext,
      NewItem('Sho~w~ clipboard', '', kbNoKey, cmShowClip, hcNoContext,
      NewItem('~C~lear', 'Ctrl-Del', kbCtrlDel, cmClear, hcNoContext,
      NewLine(
      NewItem('~F~ind...', 'Ctrl-Q-F', kbNoKey, cmFind, hcNoContext,
      NewItem('~R~eplace...', 'Ctrl-Q-A', kbNoKey, cmReplace, hcNoContext,
      NewItem('~S~earch again', 'Ctrl-L', kbNoKey, cmSearchAgain, hcNoContext,
      NewItem('~G~o to line number...', '', kbNoKey, cmGotoLine, hcNoContext,
      NewLine(
      NewItem('Ta~b~ulator or space maker', '', kbNoKey, cmTabSpaces, hcNoContext,
      ItemLatexKbd ))))))))))))))),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
      NewItem('~S~ize/move','Ctrl-F5', kbCtrlF5, cmResize, hcNoContext,
      NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcNoContext,
      NewItem('~T~ile', '', kbNoKey, cmTile, hcNoContext,
      NewItem('C~a~scade', '', kbNoKey, cmCascade, hcNoContext,
      NewItem('~N~ext', 'F6', kbF6, cmNext, hcNoContext,
      NewItem('~P~revious', 'Shift-F6', kbShiftF6, cmPrev, hcNoContext,
      NewItem('~C~lose', 'Alt-F3', kbAltF3, cmClose, hcNoContext,
      NewItem('~U~ser screen', 'Alt-F5', kbAltF5, cmShowUserScreen, hcNoContext,
      NewLine(
      NewItem('Ca~l~culator', 'Shift-F9', kbShiftF9, cmCalculator, hcNoContext,
      NewItem('Change screen ~m~ode','F9',kbF9,cmScreenMode,hcNoContext,
      NewItem('Do not touch~!~',N,0,cmNevypinat,0,
      NewItem('Text capture','Alt-F10',kbAltF10,cmTextCapture,0,
      nil)))))))))))))),
    GrafMenuItem))))));
end;

procedure TFibIniApp.InitStatusLine;
var R: TRect; Def1: PStatusDef;
begin
if not GrafDialogEnable
  then
    Def1:=NewStatusDef(0, $FFFF,
      NewStatusKey('~F1~ Help', kbF1, cmHelp,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~Shift-F6~ Previous', kbShiftF6, cmPrev,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil)))))))),nil)
   else
     Def1:=NewStatusDef(hcGrafSelected,hcGrafSelected,
       NewStatusKey('~F1~ Help',kbF1,cmHelp,
       NewStatusKey('~F2~,~F4~ Graph',kbF2,cmGraf,
       NewStatusKey('~F3~ Open', kbF3, cmOpen,
       NewStatusKey('~Shift-F6~ Previous',kbShiftF6,cmPrev,
       NewStatusKey('~F6~ Next',kbF6,cmNext,
       NewStatusKey('~F10~ Menu', kbF10, cmMenu,
       NewStatusKey('',kbF4,cmGraf,
       nil))))))),
         NewStatusDef(0, $FFFF,
       NewStatusKey('~F1~ Help', kbF1, cmHelp,
       NewStatusKey('~F2~ Save', kbF2, cmSave,
       NewStatusKey('~F3~ Open', kbF3, cmOpen,
       NewStatusKey('~F4~ Graph',kbF4,cmGraf,
       NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
       NewStatusKey('~Sh-F6~ Prev', kbShiftF6, cmPrev,
       NewStatusKey('~F6~ Next', kbF6, cmNext,
       NewStatusKey('~Alt-9~ Gmenu', kbAlt9, cmkbAlt9,
       NewStatusKey('~F10~ Menu', kbF10, cmMenu,
       NewStatusKey('', kbCtrlF5, cmResize,
       nil)))))))))),
       nil));
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(hcPosuny,hcPosuny,
     NewStatusKey('Curve Bars NoPOintsSHow WaiTVert(n)[l]{s}":$:x+,x*,y+,y*,mulx+,mulx*,..',0,0,
     NewStatusKey('', kbF10, cmMenu,nil)),
   NewStatusDef(hcGrfFileName,hcGrfFileName,
     NewStatusKey('~F4~ Graph',kbF2,cmGraf,
     NewStatusKey('   Examples:  a.dat -b?.dat#3 c.dat#21 d??.dat|8,12  :x :exp(x)|40',0,0,
     NewStatusKey('', kbF10, cmMenu,nil))),
   NewStatusDef(hcReadToMemory,hcReadToMemory,
     NewStatusKey('Ascii data files, .dpr and .dnr files are autodetected.',0,0,nil),
   NewStatusDef(hcDosGraf12,hcDosGraf12,
     NewStatusKey('<F10>1, <F10>2, <ALT>F1, <ALT>F2: Run DOS command and draw the graph',0,0,nil),
   NewStatusDef(hcDosGraf3,hcDosGraf3,
     NewStatusKey('<F10>3: Run DOS command and draw the graph',0,0,nil),
   Def1)))))));
end;

procedure TFibIniApp.OutOfMemory;
begin
  ZpravaBox('','Not enough memory for this operation.',
    nil, mfError + mfOkButton);
end;



{ --- }

function TFibIniApp.MakeGrafDialog: PMyDialog;
var D: PMyDialog; V: PView; R,RR,RRR: TMyRect; J: integer;
begin
R.assign(1,1,76,22);
D:=new(PMyDialog,Init(R,'Graph...'));
with D^ do
  begin
  Flags:=Flags and not wfClose and not wfZoom;
  RR.assign(2,1,3,2);
   RR.Move(0,1); RRR:=RR; RRR.GrowTo(6,0);
   RR.Move(0,2); R:=RR; R.Move(4,0); R.GrowTo(9,0);
  V:=new(PRealInputLine,Init(R,20,-_maxreal,_maxreal,1,5));
  Insert(V); R:=RR; R.GrowTo(2,0);
  Insert(new(PLabel,Init(R,'Fr',V)));
  Insert(new(PLabel,Init(RRR,'X ~a~xis',V)));
   RR.Move(0,1); R:=RR; R.Move(4,0); R.GrowTo(9,0);
  V:=new(PRealInputLine,Init(R,20,-_maxreal,_maxreal,1,5));
  Insert(V); R:=RR; R.GrowTo(2,0);
  Insert(new(PLabel,Init(R,'To',V)));
   RR.Move(0,1); R:=RR; R.Move(6,0); R.GrowTo(7,0);
  V:=new(PRealInputLine,Init(R,20,0,_maxreal,1,1));
  Insert(V); R:=RR; R.GrowTo(4,0);
  Insert(new(PLabel,Init(R,'Step',V)));
   RR.Move(0,1); R.MoveGrowTo(RR,1,0,12,1);
  Insert(new(PRadioButtons,Init(R,NewSItem(' [DMS]',NewSItem(' [sec]',nil)))));
   RR.Move(0,3); R.MoveGrowTo(RR,1,0,12,0);
  Insert(new(PCheckBoxes,Init(R,NewSItem('X log',nil))));
   RR.Move(0,2); R.MoveGrowTo(RR,1,0,12,3);
  Insert(new(PRadioButtons,Init(R,NewSItem('X da~t~a',NewSItem('degrees',NewSItem('minutes',NewSItem('seconds',nil)))))));

  { -- Intensity -- }
   RR.assign(3+15,2,4+15,3); RRR:=RR; RRR.GrowTo(11,0);
   RR.Move(0,2); R.MoveGrowTo(RR,4,0,9,0);
  V:=new(PRealInputLine,Init(R,20,-_maxreal,_maxreal,1,10));
  Insert(V); R:=RR; R.GrowTo(2,0);
  Insert(new(PLabel,Init(R,'Fr',V)));
  Insert(new(PLabel,Init(RRR,'Y ax~i~s',V)));
   RR.Move(0,1); R:=RR; R.Move(4,0); R.GrowTo(9,0);
  V:=new(PRealInputLine,Init(R,20,-_maxreal,_maxreal,1,5));
  Insert(V); R:=RR; R.GrowTo(2,0);
  Insert(new(PLabel,Init(R,'To',V)));
   RR.Move(0,1); R.MoveGrowTo(RR,6,0,7,0);
  V:=new(PRealInputLine,Init(R,20,0,_maxreal,1,1));
  Insert(V); R:=RR; R.GrowTo(4,0);
  Insert(new(PLabel,Init(R,'Step',V)));
   RR.Move(0,1); R.MoveGrowTo(RR,1,0,12,1);
  Insert(new(PCheckBoxes,Init(R,NewSItem('Y ~l~og',NewSItem('Data top',nil)))));
    RR.Move(0,3); R.MoveGrowTo(RR,1,0,3,0);
  V:=new(PInputLine,Init(R,2));
    Insert(V); R:=RR; R.MoveGrowTo(R,5,0,8,0);
  Insert(new(PLabel,Init(R,'g~r~id 012',V)));

(****
  RR.Move(0,2); R.MoveGrowTo(RR,1,0,12,0);
   V:=new(PCheckBoxes,Init(R,NewSItem('Rmax sub',nil)));
   V^.HelpCtx:=hcRmax; Insert(V);
****)

  { -- angle, intensity labels -- }
    RR.Move(0,2); R.MoveGrowTo(RR,1,0,12,0);
  Insert(new(PInputLine,Init(R,79)));
    RR.Move(0,1); R.MoveGrowTo(RR,1,0,12,0);
  Insert(new(PInputLine,Init(R,79)));

  { --- dalsi fily --- }
  RR.assign(2+33,2,3+33,3); RRR:=RR;
   RR.Move(0,2); R.MoveGrowTo(RR,0,0,16,0);
   V:=new(PInputLine,Init(R,79));
   V^.HelpCtx:=hcGrfFileName; Insert(V);
  R.MoveGrowTo(RRR,-1,0,12,0);
    Insert(new(PLabel,Init(R,'File~s~  ',V)));
  for J:=2 to MaxGrFiles do
    begin
    RR.Move(0,1); R.MoveGrowTo(RR,0,0,16,0);
    V:=new(PInputLine,Init(R,79));
    V^.HelpCtx:=hcGrfFileName; Insert(V);
    end;
  RR.Move(0,2); R.MoveGrowTo(RR,0,0,16,4);
   Insert(new(PCheckBoxes,Init(R,NewSItem('~p~attern',NewSItem('~y~ at 0',
     NewSItem('~b~oundary',NewSItem('~c~lipping',NewSItem('no axis',
     nil))))))));

  { --- nacteni posunu k filum --- }
  RR.assign(2+33+20,2,3+33+20,3); RRR:=RR;
   RR.Move(0,2); R.MoveGrowTo(RR,0,0,16,0);
   V:=new(PInputLine,Init(R,79));
   V^.HelpCtx:=hcPosuny; Insert(V);
  R.MoveGrowTo(RRR,-1,0,11,0);
    Insert(new(PLabel,Init(R,'S~h~ifts',V))); {Posuny}
  for J:=2 to MaxGrFiles do
    begin
    RR.Move(0,1); R.MoveGrowTo(RR,0,0,16,0);
    V:=new(PInputLine,Init(R,79));
    V^.HelpCtx:=hcPosuny; Insert(V)
    end;

  { -- Mys -- }
  RR.Move(0,2); R.MoveGrowTo(RR,0,0,16,3);
   Insert(new(PRadioButtons,Init(R,NewSItem('~M~OUSE no',NewSItem('~k~ursor',
     NewSItem('position',NewSItem('Fibonacci',nil)))))));

  { -- Labels -- }
   RR.assign(3,Size.Y-5,Size.X-15,Size.Y-4); { Fily }
   R:=RR; R.A.X:=D^.Size.X-13; R.B.X:=D^.Size.X-3;
  Insert(new(PInputLine,Init(R,79)));
   RR.assign(3,Size.Y-4,Size.X-15,Size.Y-3); { Nadpis }
  Insert(new(PInputLine,Init(RR,79)));
   R:=RR; R.A.X:=D^.Size.X-13; R.B.X:=D^.Size.X-3;
  Insert(new(PInputLine,Init(R,79)));
   RR.assign(3,Size.Y-3,Size.X-15,Size.Y-2); { GrafPozn }
  Insert(new(PInputLine,Init(RR,79)));
   R:=RR; R.A.X:=Size.X-13; R.B.X:=Size.X-3;
  Insert(new(PInputLine,Init(R,79)));
  SelectNext(false);
  SetData(DialogGrafRec);
  end;
D^.HelpCtx:=hcGrafSelected;
D^.Number:=9;
MakeGrafDialog:=D;
end;


end. { TVFibIni }
