UNIT TVFibRun;
{ c Petr Mikulk - Brno - 1992 }
{ Vrcholovy objekt TVFib. V teto unite jsou pouze reakce na events }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, graph, PmElFun, Graf094, Drivers, Views, App1, Editor,
     TVFibDef, TVFibHew, TVFibEd, TVFibGrf;


type

  TLastApp = object ( TEditorApp ) end;

  PFibApp = ^ TFibApp;
  TFibApp = object ( TLastApp )
    procedure HandleEvent ( var E: TEvent ); virtual;
    procedure StartIt;
    end;


IMPLEMENTATION


procedure TFibApp.HandleEvent ( var E: TEvent );
var CtrlState: byte absolute $40:$17;
begin
TLastApp.HandleEvent(E);
if E.What=evCommand then
   case E.Command of
   cmGraf: KresliGraf;
   cmUloz: UlozData;
   cmVytahni: VytahniData;
   cmHelp: begin Help ( true ); if TeXkbdOn then Help2 end;
   cmDOS: DosShell;
   cmDOScommand: DosCommandX;
   cmExportASCII: ExportASCII;
   cmExportDNR: UlozDataDNR;
   cmKalk: Kalkulacka;
   cmNormalizuj: begin NajdiMaximum; Normalizuj end;
   cmEpsonMode: ChangeEpsonMode;
   cmPrintPCL: PrintPCL;
   cmSwitchOffMin: ChangeSwitchOffMin;
   cmTabSpaces: ChangeTabSpaces;
   cmFreeData: FreeData;
   cmNevypinat: Nevypinej;
{   cmShowFile: ShowFile; }
   cmVynasobx: Vynasobx;
   cmVynasoby: Vynasoby;
   cmTextCapture: TextCapture;
   cmSaveGraphDesk: SaveGraphDesk;
   cmLoadGraphDesk: LoadGraphDesk;
   cmGraphAutoScale: GraphAutoScale;
   cmKonec: begin SaveGraphDeskGDT('autodesk.gdt');
                  Putcm(cmQuit) end;
   cmScreenMode: ChangeScreenMode;
   cmGotoLine: GotoLineNb ( -1 );
   cmHalt: Halt(0);
   cmSaveAll: SaveAll;
   cmShowUserScreen: ShowUserScreen;
   cmSaveBeforeDOS: MakeSaveBeforeDOS;
   cmLatexKbd: MakeLatexKbd(true);
   cmIntegration: MakeIntegration;
   cmGrErrorSkip: MakeGrErrorSkip;
   cmGnuplot: DoGnuplot;
   cmDos1Graf: DosGraf(1);
   cmDos2Graf: DosGraf(2);
   cmDos3Graf: DosGraf(3);
   cmGraphMode: AskChangeGraphMode;
   else ClearEvent(E)
   end
(*   else if (E.What=evKeyDown) and (CtrlState=$0C) and
     (E.ScanCode=#0) and (byte(E.CharCode) in [44,45,46])
{     then writeln(' ### ',E.KeyCode,' ###') }
     then DosGraf(1)
*)
   else ClearEvent(E)
end;

procedure TFibApp.StartIt;
var K,Line,Pom,Pom2: integer; S: PathStr; P: PView; E: TEvent;
LookFor: string[80];
begin
DoDetectMode:=false;
DetectGraph(Pom,Pom2); TheGrDriver:=Pom; TheGrMode:=Pom2;
(* if I=VGA then TheGrMode:=3 { 640x480 }    TheGrMode:=2; { 640x350 } *)
DisableCommands(DataMemoryCommands);
LoadGraphDeskGDT('autodesk.gdt');
Line:=0;
if ParamCount=0 then Putcm(cmOpen) else
  for K:=1 to ParamCount do
    begin
    S:=UpString( ParamStr(K) );
     { if S[1]='+' then if Nacteny then begin system.Delete(S,1,1); Val(S,Line,Pom); GotoLineNb(Line) end else else }
    if S[1]='+' then begin system.Delete(S,1,1); Val(S,Line,Pom) end else
    if S[1]<>'/'
      then begin OpenEditor(S,True);
           if Line>0 then GotoLineNb(Line); Line:=0;
           P:=DeskTop^.First;
           if (LookFor<>'') and (TypeOf(P^)=TypeOf(TEditWindow)) then
             PEditWindow(P)^.Editor^.Search(LookFor,0);
           LookFor:='';
           end
      else if length(S)>1 then
      case S[2] of
      'G': if GrafDialogEnable then KresliGraf;
      '?': Help(true);
      'A': if GrafDialogEnable then GraphAutoScale;
      'Q': HaltGraphics:=true;
      'T': begin Tiles;
           P:=DeskTop^.First;
           repeat { refresh lines }
           E.What:=evKeyDown; E.KeyCode:=kbEnd; P^.HandleEvent(E);
           E.What:=evKeyDown; E.KeyCode:=kbHome; P^.HandleEvent(E);
           P:=P^.Next;
           until P=DeskTop^.First;
           end;
      'D': if GrafDialogEnable and (length(S)>2)
             then LoadGraphDeskGDT ( Copy(S,3,length(S)-2) );
      'S': begin val( copy(S,3,255), Pom, Pom2);
           if Pom2=0
             then begin
             P:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(Pom));
             if P<>nil then P^.MakeFirst end;
           end;
      'F': if length(S)>=3 then begin
           Pom:=byte(S[3])-48; if (0<Pom) and (Pom<7) then begin
             if GrafDialogP<>nil then GrafDialogP^.GetData(DialogGrafRec);
             DialogGrafRec.GrFile[Pom]:=Copy(S,4,length(S));
             if GrafDialogP<>nil then GrafDialogP^.SetData(DialogGrafRec);
           end end;
      'H': if length(S)>=3 then begin
           Pom:=byte(S[3])-48; if (0<Pom) and (Pom<7) then begin
             if GrafDialogP<>nil then GrafDialogP^.GetData(DialogGrafRec);
             DialogGrafRec.GrFileMove[Pom]:=Copy(S,4,length(S));
             if GrafDialogP<>nil then GrafDialogP^.SetData(DialogGrafRec);
           end end;
      'L': LookFor:=copy(S,3,length(S));
      end;
    end;
{ if Nacteny then
  begin P:=Message(DeskTop,evBroadCast,cmSelectWindowNum,Pointer(1));
  P^.MakeFirst end;   { ale tohle blbne s volbou +n /T }
ChangeGraphModeText;
end;

end. { TVFibRun }
